-- #1: Get current company code
declare @currentCompanyCode nvarchar(30)
select @currentCompanyCode = Company_Code from dciowner.Companies where id = 1

-- # database
exec dciowner.addDefaultApplicationProperty @code = 'db.connection.disablePoolingForUserNames', @externalCode = 'applicationProperties.field.db.connection.disablePoolingForUserNames', @value = '', @reloadable = 1, @groupName = 'database'

-- exclude not using databases because of databases limit in AWS RDS (e.g. %_archive, %_report) 
exec dciowner.addDefaultApplicationProperty @code = 'db.scripting.create.databases.excludeList', @value = '', @reloadable = 1, @groupName = 'database'

-- # transactions
exec dciowner.addDefaultApplicationProperty @code = 'transactions.fields.class', @externalCode = 'applicationProperties.field.transactionsFieldsClass', @value = 'cz.aimtec.dci.transaction.xp.DciTransactionFields', @reloadable = 0, @groupName = 'transactions'

-- # Cache
exec dciowner.addDefaultApplicationProperty @code = 'thisIsMaster', @externalCode = 'applicationProperties.field.cache.thisIsMaster', @value = 'true', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Cache'
exec dciowner.addDefaultApplicationProperty @code = 'masterURL', @externalCode = 'applicationProperties.field.cache.masterURL', @value = '', @reloadable = 0, @groupName = 'Cache'
exec dciowner.addDefaultApplicationProperty @code = 'slavesURLs', @externalCode = 'applicationProperties.field.cache.slavesURLs', @value = '', @reloadable = 0, @groupName = 'Cache'

-- # rfid
exec dciowner.addDefaultApplicationProperty @code = 'rfid.webserviceUrl', @externalCode = 'applicationProperties.field.rfid.webserviceUrl', @value = 'http://zajc:9090/RFIDMiddleware.asmx', @reloadable = 1, @groupName = 'rfid'
exec dciowner.addDefaultApplicationProperty @code = 'rfid.scannerId', @externalCode = 'applicationProperties.field.rfid.scannerId', @value = '001', @reloadable = 1, @groupName = 'rfid'



-- # dci.secondary
exec dciowner.addDefaultApplicationProperty @code = 'dci.secondary.enabled', @externalCode = 'applicationProperties.field.secondary.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'secondary'
exec dciowner.addDefaultApplicationProperty @code = 'dci.secondary.dbName', @externalCode = 'applicationProperties.field.secondary.dbName', @value = 'dci', @reloadable = 0, @groupName = 'secondary'
exec dciowner.addDefaultApplicationProperty @code = 'dci.secondary.dbServerName', @externalCode = 'applicationProperties.field.secondary.dbServerName', @value = 'localhost', @reloadable = 0, @groupName = 'secondary'
exec dciowner.addDefaultApplicationProperty @code = 'dci.secondary.dbServerPort', @externalCode = 'applicationProperties.field.secondary.dbServerPort', @value = '1437', @reloadable = 0, @groupName = 'secondary'
exec dciowner.addDefaultApplicationProperty @code = 'dci.secondary.dbUsername', @externalCode = 'applicationProperties.field.secondary.dbUsername', @value = 'dci', @reloadable = 0, @groupName = 'secondary'
exec dciowner.addDefaultApplicationProperty @code = 'dci.secondary.dbPassword', @externalCode = 'applicationProperties.field.secondary.dbPassword', @value = 'DCI2dci', @reloadable = 0, @groupName = 'secondary'
exec dciowner.addDefaultApplicationProperty @code = 'dci.secondary.linkedServerName', @externalCode = 'applicationProperties.field.secondary.linkedServerName', @value = 'serverName', @reloadable = 0, @groupName = 'secondary'

exec dciowner.addDefaultApplicationProperty @code = 'dci.liveLinkedServerName', @environments = 'live, test, development', @externalCode = 'applicationProperties.field.secondary.liveLinkedServerName', @value = null, @reloadable = 1, @groupName = 'secondary'
exec dciowner.addDefaultApplicationProperty @code = 'dci.testLinkedServerName', @environments = 'live, test, development', @externalCode = 'applicationProperties.field.secondary.testLinkedServerName', @value = null, @reloadable = 1, @groupName = 'secondary'

-- # jasperReports
exec dciowner.addDefaultApplicationProperty @code = 'jasperReportsEncoding', @externalCode = 'applicationProperties.field.jasperReports.jasperReportsEncoding', @value = 'UTF-8', @reloadable = 1, @groupName = 'jasperReports'

-- # zebra
exec dciowner.addDefaultApplicationProperty @code = 'zebra.fontName', @externalCode = 'applicationProperties.field.zebra.fontName', @value = 'Z:0.FNT', @reloadable = 1, @groupName = 'zebra'

-- # testing
exec dciowner.addDefaultApplicationProperty @code = 'testing.directory', @externalCode = 'applicationProperties.field.testing.directory', @value = 'c:\\Projekty\\Workspaces\\Tst500\\DCI\\Web Content\\WEB-INF\\Testing', @reloadable = 0, @groupName = 'testing'
exec dciowner.addDefaultApplicationProperty @code = 'testing.fileName', @externalCode = 'applicationProperties.field.testing.fileName', @value = 'dci', @reloadable = 0, @groupName = 'testing'
exec dciowner.addDefaultApplicationProperty @code = 'testing.suffixName', @externalCode = 'applicationProperties.field.testing.suffixName', @value = 'bak', @reloadable = 0, @groupName = 'testing'
exec dciowner.addDefaultApplicationProperty @code = 'testing.userName', @externalCode = 'applicationProperties.field.testing.userName', @value = 'testing', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator', @groupName = 'testing'

-- # TransactionsErrorHandlingService
exec dciowner.addDefaultApplicationProperty @code = 'TransactionsErrorHandlingService.enabled', @externalCode = 'applicationProperties.field.TransactionsErrorHandlingService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'TransactionsErrorHandlingService'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionsErrorHandlingService.companyCode', @externalCode = 'applicationProperties.field.TransactionsErrorHandlingService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'TransactionsErrorHandlingService'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionsErrorHandlingService.interval', @externalCode = 'applicationProperties.field.TransactionsErrorHandlingService.interval', @value = '10000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'TransactionsErrorHandlingService'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionsErrorHandlingService.userName', @externalCode = 'applicationProperties.field.TransactionsErrorHandlingService.userName', @value = 'dci', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator', @groupName = 'TransactionsErrorHandlingService'

-- # MinimalBalanceNotifier
exec dciowner.addDefaultApplicationProperty @code = 'MinimalBalanceNotifier.enabled', @externalCode = 'applicationProperties.field.MinimalBalanceNotifier.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'MinimalBalanceNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'MinimalBalanceNotifier.companyCode', @externalCode = 'applicationProperties.field.MinimalBalanceNotifier.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'MinimalBalanceNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'MinimalBalanceNotifier.interval', @externalCode = 'applicationProperties.field.MinimalBalanceNotifier.interval', @value = '3600000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'MinimalBalanceNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'MinimalBalanceNotifier.recipientRoleName', @externalCode = 'applicationProperties.field.MinimalBalanceNotifier.recipientRoleName', @value = 'Min. balance alert recipient', @reloadable = 1, @groupName = 'MinimalBalanceNotifier'

-- # PartnerOrderSupplierNotifier
exec dciowner.addDefaultApplicationProperty @code = 'PartnerOrderSupplierNotifier.enabled', @externalCode = 'applicationProperties.field.PartnerOrderSupplierNotifier.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PartnerOrderSupplierNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'PartnerOrderSupplierNotifier.companyCode', @externalCode = 'applicationProperties.field.PartnerOrderSupplierNotifier.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'PartnerOrderSupplierNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'PartnerOrderSupplierNotifier.interval', @externalCode = 'applicationProperties.field.PartnerOrderSupplierNotifier.interval', @value = '15000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PartnerOrderSupplierNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'PartnerOrderSupplierNotifier.language', @externalCode = 'applicationProperties.field.PartnerOrderSupplierNotifier.language', @value = 'cs', @reloadable = 1, @groupName = 'PartnerOrderSupplierNotifier'

-- # AperakImportNotifier
exec dciowner.addDefaultApplicationProperty @code = 'AperakImportNotifier.enabled', @externalCode = 'applicationProperties.field.AperakImportNotifier.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'AperakImportNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'AperakImportNotifier.companyCode', @externalCode = 'applicationProperties.field.AperakImportNotifier.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'AperakImportNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'AperakImportNotifier.interval', @externalCode = 'applicationProperties.field.AperakImportNotifier.interval', @value = '3600000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'AperakImportNotifier'
exec dciowner.addDefaultApplicationProperty @code = 'AperakImportNotifier.language', @externalCode = 'applicationProperties.field.AperakImportNotifier.language', @value = 'cs', @reloadable = 1, @groupName = 'AperakImportNotifier'

-- # ReleaseChecker
exec dciowner.addDefaultApplicationProperty @code = 'ReleaseChecker.enabled', @externalCode = 'applicationProperties.field.ReleaseChecker.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ReleaseChecker'
exec dciowner.addDefaultApplicationProperty @code = 'ReleaseChecker.companyCode', @externalCode = 'applicationProperties.field.ReleaseChecker.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'ReleaseChecker'
exec dciowner.addDefaultApplicationProperty @code = 'ReleaseChecker.interval', @externalCode = 'applicationProperties.field.ReleaseChecker.interval', @value = '30000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'ReleaseChecker'

-- # UniversalMailNotifierService
exec dciowner.addDefaultApplicationProperty @code = 'UniversalMailNotifierService.enabled', @externalCode = 'applicationProperties.field.UniversalMailNotifierService.enabled', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'UniversalMailNotifierService'
exec dciowner.addDefaultApplicationProperty @code = 'UniversalMailNotifierService.companyCode', @externalCode = 'applicationProperties.field.UniversalMailNotifierService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'UniversalMailNotifierService'

-- # ExportTransactionsToSAPService
exec dciowner.addDefaultApplicationProperty @code = 'ExportTransactionsToSAPService.enabled', @externalCode = 'applicationProperties.field.ExportTransactionsToSAPService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ExportTransactionsToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'ExportTransactionsToSAPService.companyCode', @externalCode = 'applicationProperties.field.ExportTransactionsToSAPService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'ExportTransactionsToSAPService'

-- # ExportCallOffsToSAPService
exec dciowner.addDefaultApplicationProperty @code = 'ExportCallOffsToSAPService.enabled', @externalCode = 'applicationProperties.field.ExportCallOffsToSAPService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ExportCallOffsToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'ExportCallOffsToSAPService.companyCode', @externalCode = 'applicationProperties.field.ExportCallOffsToSAPService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'ExportCallOffsToSAPService'

-- # ImportProductsFromSAP
exec dciowner.addDefaultApplicationProperty @code = 'ImportProductsFromSAP.enabled', @externalCode = 'applicationProperties.field.ImportProductsFromSAP.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ImportProductsFromSAP'
exec dciowner.addDefaultApplicationProperty @code = 'ImportProductsFromSAP.companyCode', @externalCode = 'applicationProperties.field.ImportProductsFromSAP.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'ImportProductsFromSAP'
exec dciowner.addDefaultApplicationProperty @code = 'ImportProductsFromSAP.interval', @externalCode = 'applicationProperties.field.ImportProductsFromSAP.interval', @value = '30000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'ImportProductsFromSAP'

-- # ImportPartnerOrdersFromSAP
exec dciowner.addDefaultApplicationProperty @code = 'ImportPartnerOrdersFromSAP.enabled', @externalCode = 'applicationProperties.field.ImportPartnerOrdersFromSAP.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ImportPartnerOrdersFromSAP'
exec dciowner.addDefaultApplicationProperty @code = 'ImportPartnerOrdersFromSAP.companyCode', @externalCode = 'applicationProperties.field.ImportPartnerOrdersFromSAP.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'ImportPartnerOrdersFromSAP'
exec dciowner.addDefaultApplicationProperty @code = 'ImportPartnerOrdersFromSAP.interval', @externalCode = 'applicationProperties.field.ImportPartnerOrdersFromSAP.interval', @value = '30000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'ImportPartnerOrdersFromSAP'

-- # PrintJobChecker
exec dciowner.addDefaultApplicationProperty @code = 'PrintJobChecker.enabled', @externalCode = 'applicationProperties.field.PrintJobChecker.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PrintJobChecker'
exec dciowner.addDefaultApplicationProperty @code = 'PrintJobChecker.companyCode', @externalCode = 'applicationProperties.field.PrintJobChecker.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'PrintJobChecker'
exec dciowner.addDefaultApplicationProperty @code = 'PrintJobChecker.interval', @externalCode = 'applicationProperties.field.PrintJobChecker.interval', @value = '300000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PrintJobChecker'
exec dciowner.addDefaultApplicationProperty @code = 'PrintJobChecker.toleranceInterval', @externalCode = 'applicationProperties.field.PrintJobChecker.toleranceInterval', @value = '180000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PrintJobChecker'

-- # PrinterStatusReader
exec dciowner.addDefaultApplicationProperty @code = 'PrinterStatusReader.enabled', @externalCode = 'applicationProperties.field.PrinterStatusReader.enabled', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PrinterStatusReader'
exec dciowner.addDefaultApplicationProperty @code = 'PrinterStatusReader.companyCode', @externalCode = 'applicationProperties.field.PrinterStatusReader.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'PrinterStatusReader'
exec dciowner.addDefaultApplicationProperty @code = 'PrinterStatusReader.interval', @externalCode = 'applicationProperties.field.PrinterStatusReader.interval', @value = '5000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PrinterStatusReader'

-- # AutoReleaseConfirmer
exec dciowner.addDefaultApplicationProperty @code = 'AutoReleaseConfirmer.enabled', @externalCode = 'applicationProperties.field.AutoReleaseConfirmer.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'AutoReleaseConfirmer'
exec dciowner.addDefaultApplicationProperty @code = 'AutoReleaseConfirmer.companyCode', @externalCode = 'applicationProperties.field.AutoReleaseConfirmer.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'AutoReleaseConfirmer'
exec dciowner.addDefaultApplicationProperty @code = 'AutoReleaseConfirmer.interval', @externalCode = 'applicationProperties.field.AutoReleaseConfirmer.interval', @value = '300000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'AutoReleaseConfirmer'
exec dciowner.addDefaultApplicationProperty @code = 'AutoReleaseConfirmer.sendNotificationEmailsToSup', @value = 'false', @reloadable = 1, @groupName = 'AutoReleaseConfirmer'

-- # RestartExportTransactionsToSAPService
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportTransactionsToSAPService.enabled', @externalCode = 'applicationProperties.field.RestartExportTransactionsToSAPService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'RestartExportTransactionsToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportTransactionsToSAPService.companyCode', @externalCode = 'applicationProperties.field.RestartExportTransactionsToSAPService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'RestartExportTransactionsToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportTransactionsToSAPService.interval', @externalCode = 'applicationProperties.field.RestartExportTransactionsToSAPService.interval', @value = '21600000 ', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'RestartExportTransactionsToSAPService'

-- # RestartExportDeliveryNotesToSAPService
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportDeliveryNotesToSAPService.enabled', @externalCode = 'applicationProperties.field.RestartExportDeliveryNotesToSAPService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'RestartExportDeliveryNotesToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportDeliveryNotesToSAPService.companyCode', @externalCode = 'applicationProperties.field.RestartExportDeliveryNotesToSAPService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'RestartExportDeliveryNotesToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportDeliveryNotesToSAPService.interval', @externalCode = 'applicationProperties.field.RestartExportDeliveryNotesToSAPService.interval', @value = '21600000 ', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'RestartExportDeliveryNotesToSAPService'

-- # RestartExportCallOffsToSAPService
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportCallOffsToSAPService.enabled', @externalCode = 'applicationProperties.field.RestartExportCallOffsToSAPService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'RestartExportCallOffsToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportCallOffsToSAPService.companyCode', @externalCode = 'applicationProperties.field.RestartExportCallOffsToSAPService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'RestartExportCallOffsToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'RestartExportCallOffsToSAPService.interval', @externalCode = 'applicationProperties.field.RestartExportCallOffsToSAPService.interval', @value = '21600000 ', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'RestartExportCallOffsToSAPService'

-- # TransactionImportLoader
exec dciowner.addDefaultApplicationProperty @code = 'TransactionImportLoader.enabled', @externalCode = 'applicationProperties.field.TransactionImportLoader.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'TransactionImportLoader'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionImportLoader.companyCode', @externalCode = 'applicationProperties.field.TransactionImportLoader.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'TransactionImportLoader'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionImportLoader.interval', @externalCode = 'applicationProperties.field.TransactionImportLoader.interval', @value = '60000000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'TransactionImportLoader'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionImportLoader.userName', @externalCode = 'applicationProperties.field.TransactionImportLoader.userName', @value = 'test', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator', @groupName = 'TransactionImportLoader'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionImportLoader.strategy', @externalCode = 'applicationProperties.field.TransactionImportLoader.strategy', @value = '', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.TransactionImportLoaderStrategyValidator', @groupName = 'TransactionImportLoader'

-- # ImportProductsFromSAP
exec dciowner.addDefaultApplicationProperty @code = 'ImportSuppliersFromSAP.enabled', @externalCode = 'applicationProperties.field.ImportSuppliersFromSAP.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ImportProductsFromSAP'
exec dciowner.addDefaultApplicationProperty @code = 'ImportSuppliersFromSAP.companyCode', @externalCode = 'applicationProperties.field.ImportSuppliersFromSAP.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'ImportProductsFromSAP'
exec dciowner.addDefaultApplicationProperty @code = 'ImportSuppliersFromSAP.interval', @externalCode = 'applicationProperties.field.ImportSuppliersFromSAP.interval', @value = '30000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'ImportProductsFromSAP'

-- # ImportCustomersFromSAP
exec dciowner.addDefaultApplicationProperty @code = 'ImportCustomersFromSAP.enabled', @externalCode = 'applicationProperties.field.ImportCustomersFromSAP.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ImportCustomersFromSAP'
exec dciowner.addDefaultApplicationProperty @code = 'ImportCustomersFromSAP.companyCode', @externalCode = 'applicationProperties.field.ImportCustomersFromSAP.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'ImportCustomersFromSAP'
exec dciowner.addDefaultApplicationProperty @code = 'ImportCustomersFromSAP.interval', @externalCode = 'applicationProperties.field.ImportCustomersFromSAP.interval', @value = '30000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'ImportCustomersFromSAP'

-- # TechnologyCommunicationManager
exec dciowner.addDefaultApplicationProperty @code = 'TechnologyCommunicationManager.companyCode', @externalCode = 'applicationProperties.field.TechnologyCommunicationManager.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'TechnologyCommunicationManager'
exec dciowner.addDefaultApplicationProperty @code = 'TechnologyCommunicationManager.userName', @externalCode = 'applicationProperties.field.TechnologyCommunicationManager.userName', @value = 'test', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator', @groupName = 'TechnologyCommunicationManager'
exec dciowner.addDefaultApplicationProperty @code = 'TechnologyCommunicationManager.PLCmultiThreadExecution', @externalCode = 'applicationProperties.field.TechnologyCommunicationManager.PLCmultiThreadExecution', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'TechnologyCommunicationManager'
exec dciowner.addDefaultApplicationProperty @code = 'TechnologyCommunicationManager.ThreadPoolLimit', @externalCode = 'applicationProperties.field.TechnologyCommunicationManager.ThreadPoolLimit', @value = '30', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'TechnologyCommunicationManager'
exec dciowner.addDefaultApplicationProperty @code = 'TechnologyCommunicationManager.ThreadTimeoutInSeconds', @externalCode = 'applicationProperties.field.TechnologyCommunicationManager.ThreadTimeoutInSeconds', @value = '60', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'TechnologyCommunicationManager'

-- # PTFClientService
exec dciowner.addDefaultApplicationProperty @code = 'PTFClientService.enabled', @externalCode = 'applicationProperties.field.PTFClientService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PTFClientService'
exec dciowner.addDefaultApplicationProperty @code = 'PTFClientService.companyCode', @externalCode = 'applicationProperties.field.PTFClientService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'PTFClientService'
exec dciowner.addDefaultApplicationProperty @code = 'PTFClientService.host', @externalCode = 'applicationProperties.field.PTFClientService.host', @value = 'localhost', @reloadable = 0, @groupName = 'PTFClientService'
exec dciowner.addDefaultApplicationProperty @code = 'PTFClientService.portRequest', @externalCode = 'applicationProperties.field.PTFClientService.portRequest', @value = '3234', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PTFClientService'
exec dciowner.addDefaultApplicationProperty @code = 'PTFClientService.portResponse', @externalCode = 'applicationProperties.field.PTFClientService.portResponse', @value = '2234', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PTFClientService'

-- # JVMMonitor
exec dciowner.addDefaultApplicationProperty @code = 'JVMMonitor.enabled', @externalCode = 'applicationProperties.field.JVMMonitor.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'JVMMonitor'
exec dciowner.addDefaultApplicationProperty @code = 'JVMMonitor.companyCode', @externalCode = 'applicationProperties.field.JVMMonitor.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'JVMMonitor'
exec dciowner.addDefaultApplicationProperty @code = 'JVMMonitor.interval', @externalCode = 'applicationProperties.field.JVMMonitor.interval', @value = '10000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'JVMMonitor'
exec dciowner.addDefaultApplicationProperty @code = 'JVMMonitor.address', @externalCode = 'applicationProperties.field.JVMMonitor.address', @value = '127.0.0.1', @reloadable = 1, @groupName = 'JVMMonitor'
exec dciowner.addDefaultApplicationProperty @code = 'JVMMonitor.port', @externalCode = 'applicationProperties.field.JVMMonitor.port', @value = '5005', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'JVMMonitor'

-- # VDADelNoteGenerator
exec dciowner.addDefaultApplicationProperty @code = 'VDADelNoteGenerator.active', @externalCode = 'applicationProperties.field.VDADelNoteGenerator.active', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'VDADelNoteGenerator'
exec dciowner.addDefaultApplicationProperty @code = 'VDADelNoteGenerator.outputPath', @externalCode = 'applicationProperties.field.VDADelNoteGenerator.outputPath', @value = 'c:/temp', @reloadable = 0, @groupName = 'VDADelNoteGenerator'
exec dciowner.addDefaultApplicationProperty @code = 'VDADelNoteGenerator.fileExtension', @externalCode = 'applicationProperties.field.VDADelNoteGenerator.fileExtension', @value = '.vda', @reloadable = 0, @groupName = 'VDADelNoteGenerator'

-- # ImportASNFromXLS
exec dciowner.addDefaultApplicationProperty @code = 'ImportASNFromXLS.trnDefCode', @externalCode = 'applicationProperties.field.ImportASNFromXLS.trnDefCode', @value = 'RQX.ASN', @reloadable = 0, @groupName = 'ImportASNFromXLS'
exec dciowner.addDefaultApplicationProperty @code = 'ImportASNFromXLS.partnerCode', @externalCode = 'applicationProperties.field.ImportASNFromXLS.partnerCode', @value = '900001', @reloadable = 0, @groupName = 'ImportASNFromXLS'
exec dciowner.addDefaultApplicationProperty @code = 'ImportASNFromXLS.orderGroup', @externalCode = 'applicationProperties.field.ImportASNFromXLS.orderGroup', @value = 'TRJ', @reloadable = 0, @groupName = 'ImportASNFromXLS'

-- # EDI_VDA_4916_Head
exec dciowner.addDefaultApplicationProperty @code = 'EDI_VDA_4916_Head.dtsJobName', @externalCode = 'applicationProperties.field.EDI_VDA_4916_Head.dtsJobName', @value = 'dci_igg_tst_Generate_Whpckgs_From_EDI', @reloadable = 0, @groupName = 'EDI_VDA_4916_Head'

-- # report
exec dciowner.addDefaultApplicationProperty @code = 'reportServer', @externalCode = 'applicationProperties.field.report.reportServer', @value = 'http://localhost:9000/ReportServer', @reloadable = 1, @groupName = 'report'
exec dciowner.addDefaultApplicationProperty @code = 'reportServerExternal', @externalCode = 'applicationProperties.field.report.reportServerExternal', @value = 'http://<servername>:9000/ReportServer', @reloadable = 1, @groupName = 'report'
exec dciowner.addDefaultApplicationProperty @code = 'reportPath', @externalCode = 'applicationProperties.field.report.reportPath', @value = '?/dci_tst_reports/', @reloadable = 1, @groupName = 'report'
exec dciowner.addDefaultApplicationProperty @code = 'reportServerDbName', @externalCode = 'applicationProperties.field.report.reportServerDbName', @value = 'ReportServer', @reloadable = 1, @groupName = 'report'
exec dciowner.addDefaultApplicationProperty @code = 'reportViewer', @externalCode = 'applicationProperties.field.report.reportViewer', @value = '/Pages/ReportViewer.aspx', @reloadable = 1, @groupName = 'report'
exec dciowner.addDefaultApplicationProperty @code = 'reportSettingsUrl', @externalCode = 'applicationProperties.field.report.reportSettingsUrl', @value = '&rs:Command=Render&rc:Parameters=False&rc:stylesheet=hideToolBar&rc:Zoom=Whole%20page', @reloadable = 1, @groupName = 'report'
exec dciowner.addDefaultApplicationProperty @code = 'dciReportUser'                                   	  , @externalCode = 'applicationProperties.field.report.dciReportUser', @value = null                                                                          , @reloadable = 1, @groupName = 'report'


-- # partnerOrderSupplierNotifier
exec dciowner.addDefaultApplicationProperty @code = 'dciInternalUrl', @value = 'http://<serverNameExternal>/dci', @reloadable = 1, @groupName = 'PartnerOrderSupplierNotifier' -- , @description = 'DCIx internal base url used in email notification e.x. dci.configProperty(dciInternalUrl)'
exec dciowner.addDefaultApplicationProperty @code = 'dciExternalUrl', @value = 'http://<serverNameExternal>/dci', @reloadable = 1, @groupName = 'PartnerOrderSupplierNotifier' -- , @description = 'DCIx external base url used in email notification e.x. dci.configProperty(dciExternalUrl)'

-- # memoryObserver
exec dciowner.addDefaultApplicationProperty @code = 'memoryObserverFilenameBase'                         , @externalCode = 'applicationProperties.field.memoryObserver.memoryObserverFilenameBase', @value = '/usr/local/tomcat/logs/memoryStatus'       , @reloadable = 0, @groupName = 'memoryObserver'
exec dciowner.addDefaultApplicationProperty @code = 'memoryObserverSleepTime'                            , @externalCode = 'applicationProperties.field.memoryObserver.memoryObserverSleepTime', @value = '120000'                                                                          , @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'memoryObserver'
exec dciowner.addDefaultApplicationProperty @code = 'isLogOverAllowed'                                   , @externalCode = 'applicationProperties.field.Common.isLogOverAllowed', @value = 'true'                                                                            , @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Common'
exec dciowner.addDefaultApplicationProperty @code = 'databaseQueryTimeout'                               , @externalCode = 'applicationProperties.field.Common.databaseQueryTimeout', @value = '10'                                                                              , @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'Common'
exec dciowner.addDefaultApplicationProperty @code = 'reGenerateLabel'                                    , @externalCode = 'applicationProperties.field.Common.reGenerateLabel', @value = 'false'                                                                           , @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Common'
exec dciowner.addDefaultApplicationProperty @code = 'labelPrinterCharset'                                , @externalCode = 'applicationProperties.field.Common.labelPrinterCharset', @value = 'Cp1250'                                                                          , @reloadable = 0, @groupName = 'Common'
exec dciowner.addDefaultApplicationProperty @code = 'maxGeneratePackagesCount'                           , @externalCode = 'applicationProperties.field.Common.maxGeneratePackagesCount', @value = '500'                                                                             , @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'Common'
exec dciowner.addDefaultApplicationProperty @code = 'menu.useOldRequested'                               , @externalCode = 'applicationProperties.field.Common.menu.useOldRequested', @value = 'false'                                                                           , @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Common'
exec dciowner.addDefaultApplicationProperty @code = 'defaultLanguage'                                    , @externalCode = 'applicationProperties.field.Common.defaultLanguage', @value = 'en'                                                                              , @reloadable = 1, @groupName = 'Common'
exec dciowner.addDefaultApplicationProperty @code = 'browser.restrict.notSupported'                      , @externalCode = 'applicationProperties.field.Common.browser.restrict.notSupported', @value = 'true'                                                              , @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Common'

-- # smtp
exec dciowner.addDefaultApplicationProperty @code = 'smtpHost'                                           , @externalCode = 'applicationProperties.field.smtp.smtpHost', @value = 'postman.aimtec.cz'                                                               , @reloadable = 0, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'fromAddress'                                        , @externalCode = 'applicationProperties.field.smtp.fromAddress', @value = 'name@server.cz'                                                                  , @reloadable = 1, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtpUserName'                                       , @externalCode = 'applicationProperties.field.smtp.smtpUserName', @value = ''                                                                                , @reloadable = 0, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtpPassword'                                       , @externalCode = 'applicationProperties.field.smtp.smtpPassword', @value = ''                                                                                , @reloadable = 0, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtp.ssl.enable'                                    , @externalCode = 'applicationProperties.field.smtp.ssl.enable', @value = ''                                                                                , @reloadable = 0, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtp.ssl.checkserveridentity'                       , @externalCode = 'applicationProperties.field.smtp.ssl.checkserveridentity', @value = ''                                                                                , @reloadable = 0, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtp.ssl.trust'                                     , @externalCode = 'applicationProperties.field.smtp.ssl.trust', @value = ''                                                                                , @reloadable = 0, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtp.ssl.protocols'                                 , @externalCode = 'applicationProperties.field.smtp.ssl.protocols', @value = ''                                                                                , @reloadable = 0, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtp.ssl.ciphersuites'                              , @externalCode = 'applicationProperties.field.smtp.ssl.ciphersuites', @value = ''                                                                                , @reloadable = 0, @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtp.starttls.enable'                               , @externalCode = 'applicationProperties.field.smtp.starttls.enable', @value = ''                                                                          , @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'smtp'
exec dciowner.addDefaultApplicationProperty @code = 'smtp.transport.protocol'                            , @externalCode = 'applicationProperties.field.smtp.transport.protocol', @value = ''                                                                                , @reloadable = 0, @groupName = 'smtp'

-- # activeDirectory
exec dciowner.addDefaultApplicationProperty @code = 'activeDirectory.url', @externalCode = 'applicationProperties.field.activeDirectory.url', @value = '', @reloadable = 1, @groupName = 'activeDirectory'
exec dciowner.addDefaultApplicationProperty @code = 'activeDirectory.authenticationMechanism', @externalCode = 'applicationProperties.field.activeDirectory.authenticationMechanism', @value = '', @reloadable = 1, @groupName = 'activeDirectory'
exec dciowner.addDefaultApplicationProperty @code = 'activeDirectory.searchBase', @externalCode = 'applicationProperties.field.activeDirectory.searchBase', @value = '', @reloadable = 1, @groupName = 'activeDirectory'
exec dciowner.addDefaultApplicationProperty @code = 'activeDirectory.domain', @externalCode = 'applicationProperties.field.activeDirectory.domain', @value = '', @reloadable = 1, @groupName = 'activeDirectory'

-- # Common
exec dciowner.addDefaultApplicationProperty @code = 'maxPackagesCountForAsnBatch', @externalCode = 'applicationProperties.field.Common.maxPackagesCountForAsnBatch', @value = '1000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'Common'
exec dciowner.addDefaultApplicationProperty @code = 'product.allowDisableWhenStockAvailable', @externalCode = 'applicationProperties.field.Common.product.allowDisableWhenStockAvailable ', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Common'

declare @truncateStringsTo4000Chars nvarchar(5) = case when dciowner.isTruncateStringsTo4000Chars() = 1 then 'true' else 'false' end
exec dciowner.addDefaultApplicationProperty @code = 'truncateStringsTo4000Chars', @externalCode = 'applicationProperties.field.Common.truncateStringsTo4000Chars', @value = @truncateStringsTo4000Chars, @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Common'

exec dciowner.addDefaultApplicationProperty @code = 'project.projectCode', @groupName = 'project',	@value = 'DCI.PRA',	@reloadable = 1-- @description = 'Customer project code',
exec dciowner.addDefaultApplicationProperty @code = 'project.locationCode', @groupName = 'project', @value = '010', @reloadable = 1 -- @description = 'A unique identifier of DCIx installation at the customer',

exec dciowner.addDefaultApplicationProperty @code = 'server.path.mapping', @groupName = 'Common', @value = '[{"path":"", "location":""}]', @externalCode = 'applicationProperties.field.Common.server.path.mapping', @reloadable = 0

-- # productionPlan
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanModes', @externalCode = 'applicationProperties.field.productionPlan.productionPlanModes', @value = '', @reloadable = 1, @groupName = 'productionPlan'
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanVisibleProductFields', @externalCode = 'applicationProperties.field.productionPlan.productionPlanVisibleProductFields', @value = 'productCode,productDescription', @reloadable = 1, @groupName = 'productionPlan'

-- # productionPlan
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanDailyHorizon', @externalCode = 'applicationProperties.field.productionPlan.productionPlanDailyHorizon', @value = '3', @reloadable = 0, @groupName = 'productionPlan'
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanWeeklyHorizon', @externalCode = 'applicationProperties.field.productionPlan.productionPlanWeeklyHorizon', @value = '3', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'productionPlan'
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanTransaction1', @externalCode = 'applicationProperties.field.productionPlan.productionPlanTransaction1', @value = 'RQX.TST', @reloadable = 0, @groupName = 'productionPlan'
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanTransaction2', @externalCode = 'applicationProperties.field.productionPlan.productionPlanTransaction2', @value = '', @reloadable = 0, @groupName = 'productionPlan'
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanTransaction3', @externalCode = 'applicationProperties.field.productionPlan.productionPlanTransaction3', @value = '', @reloadable = 0, @groupName = 'productionPlan'
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanTransaction4', @externalCode = 'applicationProperties.field.productionPlan.productionPlanTransaction4', @value = '', @reloadable = 0, @groupName = 'productionPlan'
exec dciowner.addDefaultApplicationProperty @code = 'productionPlanTransaction5', @externalCode = 'applicationProperties.field.productionPlan.productionPlanTransaction5', @value = '', @reloadable = 0, @groupName = 'productionPlan'

-- # purchasePlan
exec dciowner.addDefaultApplicationProperty @code = 'purchasePlanForecastHorizon', @externalCode = 'applicationProperties.field.purchasePlan.purchasePlanForecastHorizon', @value = '4', @reloadable = 1, @groupName = 'purchasePlan'
exec dciowner.addDefaultApplicationProperty @code = 'purchasePlanForecastLength', @externalCode = 'applicationProperties.field.purchasePlan.purchasePlanForecastLength', @value = '4', @reloadable = 1, @groupName = 'purchasePlan'
exec dciowner.addDefaultApplicationProperty @code = 'MRPRequirementsHorizon', @externalCode = 'applicationProperties.field.purchasePlan.MRPRequirementsHorizon', @value = '4', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'purchasePlan'

-- # deliveryPlan
exec dciowner.addDefaultApplicationProperty @code = 'deliveryPlanForecastHorizon', @externalCode = 'applicationProperties.field.deliveryPlan.deliveryPlanForecastHorizon', @value = '4', @reloadable = 1, @groupName = 'deliveryPlan'
exec dciowner.addDefaultApplicationProperty @code = 'deliveryPlanForecastLength', @externalCode = 'applicationProperties.field.deliveryPlan.deliveryPlanForecastLength', @value = '4', @reloadable = 1, @groupName = 'deliveryPlan'
exec dciowner.addDefaultApplicationProperty @code = 'deliveryPlanShowDeliveryNoteCoverage', @externalCode = 'applicationProperties.field.deliveryPlan.deliveryPlanShowDeliveryNoteCoverage', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'deliveryPlan'

-- # password
exec dciowner.addDefaultApplicationProperty @code = 'minPasswordLength', @externalCode = 'applicationProperties.field.password.minPasswordLength', @value = '4', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'password'
exec dciowner.addDefaultApplicationProperty @code = 'passwordHistory', @externalCode = 'applicationProperties.field.password.passwordHistory', @value = '1', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'password'
exec dciowner.addDefaultApplicationProperty @code = 'passwordExpirePeriod', @externalCode = 'applicationProperties.field.password.passwordExpirePeriod', @value = '0', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'password'
exec dciowner.addDefaultApplicationProperty @code = 'passwordExpirationAlertPeriod', @externalCode = 'applicationProperties.field.password.passwordExpirationAlertPeriod', @value = '4', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'password'
exec dciowner.addDefaultApplicationProperty @code = 'maxFailedLoginsCount', @externalCode = 'applicationProperties.field.password.maxFailedLoginsCount', @value = '0', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'password'
exec dciowner.addDefaultApplicationProperty @code = 'Password_Complexity_Regex', @externalCode = 'applicationProperties.field.password.Password_Complexity_Regex', @value = '.*?(([A-Z])|([a-z])|([0-9])|([^A-Za-z0-9]))', @reloadable = 1, @validator = null , @groupName = 'password' -- @description = 'Complexity regex used for password validation. Must be defined as groups of rules in brackets',
exec dciowner.addDefaultApplicationProperty @code = 'Password_Complexity_Regex_Rules_Count', @externalCode = 'applicationProperties.field.password.Password_Complexity_Regex_Rules_Count', @value = '0', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'password' -- , @description = 'Rules count that must be satisfied from regex',

-- # LOGIN
-- # telnet
exec dciowner.addDefaultApplicationProperty @code = 'telnet.enable', @externalCode = 'applicationProperties.field.telnet.enable', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'PORT', @externalCode = 'applicationProperties.field.telnet.port', @value = '6666', @reloadable = 0, @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'LOGIN.server', @externalCode = 'applicationProperties.field.telnet.loginServer', @value = 'http://localhost:8080', @reloadable = 0, @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'LOGIN.context', @externalCode = 'applicationProperties.field.telnet.loginContext', @value = '/DCI', @reloadable = 0, @groupName = 'telnet'

-- # telnet
exec dciowner.addDefaultApplicationProperty @code = 'telnet.connectionManagerCleanupBrokenTimeout', @externalCode = 'applicationProperties.field.telnet.connectionManagerCleanupBrokenTimeout', @value = '5', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'telnet.maxScanableFieldLenght', @externalCode = 'applicationProperties.field.telnet.maxScanableFieldLenght', @value = '200', @reloadable = 0, @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'telnet.menuTransactionsInRoles', @externalCode = 'applicationProperties.field.telnet.menuTransactionsInRoles', @value = 'true', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'telnet.showUserLastLoginInfo', @externalCode = 'applicationProperties.field.telnet.showUserLastLoginInfo', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'telnet'

exec dciowner.addDefaultApplicationProperty @code = 'telnet.beepCountOK', @externalCode = 'applicationProperties.field.telnet.beepCountOK', @value = '0', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'telnet.beepCountERROR', @externalCode = 'applicationProperties.field.telnet.beepCountERROR', @value = '2', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'telnet.beepCountMESSAGE', @externalCode = 'applicationProperties.field.telnet.beepCountMESSAGE', @value = '1', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'telnet.beepCountUrgentMESSAGE', @externalCode = 'applicationProperties.field.telnet.beepCountUrgentMESSAGE', @value = '3', @reloadable = 0, @groupName = 'telnet'
exec dciowner.addDefaultApplicationProperty @code = 'telnet.isStatusBarVisibleByDefault', @externalCode = 'applicationProperties.field.telnet.isStatusBarVisibleByDefault', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'telnet'

-- # web
exec dciowner.addDefaultApplicationProperty @code = 'web.beepCountError', @externalCode = 'applicationProperties.field.web.beepCountError', @value = '0', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'web'
exec dciowner.addDefaultApplicationProperty @code = 'web.beepCountWarning', @externalCode = 'applicationProperties.field.web.beepCountWarning', @value = '0', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'web'
exec dciowner.addDefaultApplicationProperty @code = 'web.errorSoundFile', @externalCode = 'applicationProperties.field.web.errorSoundFile', @value = 'error.wav', @reloadable = 1, @groupName = 'web'
exec dciowner.addDefaultApplicationProperty @code = 'web.warningSoundFile', @externalCode = 'applicationProperties.field.web.warningSoundFile', @value = 'notify.wav', @reloadable = 1, @groupName = 'web'

-- # productImage
exec dciowner.addDefaultApplicationProperty @code = 'productImageMaxFileSize', @externalCode = 'applicationProperties.field.productImage.maxFileSize', @value = '1000000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'productImage'

-- # PreventiveMaintenance
exec dciowner.addDefaultApplicationProperty @code = 'dbinstance', @externalCode = 'applicationProperties.field.PreventiveMaintenance.dbinstance', @value = 'SQL2008', @reloadable = 1, @groupName = 'PreventiveMaintenance'

-- # Messaging
exec dciowner.addDefaultApplicationProperty @code = 'refreshInterval', @externalCode = 'applicationProperties.field.Messaging.refreshInterval', @value = '60000', @reloadable = 1, @groupName = 'Messaging'
exec dciowner.addDefaultApplicationProperty @code = 'senderName', @externalCode = 'applicationProperties.field.Messaging.senderName', @value = 'test', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator', @groupName = 'Messaging'
exec dciowner.addDefaultApplicationProperty @code = 'messageAsEmail.enabled', @externalCode = 'applicationProperties.field.Messaging.messageAsEmailEnabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Messaging'

-- # TransactionScheduler
exec dciowner.addDefaultApplicationProperty @code = 'TransactionScheduler.enabled', @externalCode = 'applicationProperties.field.TransactionScheduler.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'TransactionScheduler'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionScheduler.companyCode', @externalCode = 'applicationProperties.field.TransactionScheduler.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'TransactionScheduler'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionScheduler.userName', @externalCode = 'applicationProperties.field.TransactionScheduler.userName', @value = 'kucp', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator', @groupName = 'TransactionScheduler'

-- # TCPIPListener
exec dciowner.addDefaultApplicationProperty @code = 'TCPIPListener.enabled', @externalCode = 'applicationProperties.field.TCPIPListener.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'TCPIPListener'
exec dciowner.addDefaultApplicationProperty @code = 'TCPIPListener.companyCode', @externalCode = 'applicationProperties.field.TCPIPListener.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'TCPIPListener'
exec dciowner.addDefaultApplicationProperty @code = 'TCPIPListener.userName', @externalCode = 'applicationProperties.field.TCPIPListener.userName', @value = 'test', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator', @groupName = 'TCPIPListener'
exec dciowner.addDefaultApplicationProperty @code = 'TCPIPListener.connectionCheckTimeout', @externalCode = 'applicationProperties.field.TCPIPListener.connectionCheckTimeout', @value = '1000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'TCPIPListener'

-- # RefreshModifiedCachesService
exec dciowner.addDefaultApplicationProperty @code = 'RefreshModifiedCachesService.enabled', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'RefreshModifiedCachesService'
exec dciowner.addDefaultApplicationProperty @code = 'RefreshModifiedCachesService.interval', @value = '5000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'RefreshModifiedCachesService'

-- # DBConnectionManagerService
exec dciowner.addDefaultApplicationProperty @code = 'DBConnectionManagerService.interval', @externalCode = 'applicationProperties.field.DBConnectionManagerService.interval', @value = '5000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'DBConnectionManagerService' -- @description = 'Automatic clear DB connection service.',
exec dciowner.addDefaultApplicationProperty @code = 'DBConnectionManagerService.enabled', @externalCode = 'applicationProperties.field.DBConnectionManagerService.enabled', @value = 'true', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'DBConnectionManagerService'

-- # KardexClientService
exec dciowner.addDefaultApplicationProperty @code = 'KardexClientService.companyCode', @externalCode = 'applicationProperties.field.KardexClientService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'KardexClientService'
exec dciowner.addDefaultApplicationProperty @code = 'KardexClientService.host', @externalCode = 'applicationProperties.field.KardexClientService.host', @value = 'localhost', @reloadable = 0, @groupName = 'KardexClientService'
exec dciowner.addDefaultApplicationProperty @code = 'KardexClientService.port', @externalCode = 'applicationProperties.field.KardexClientService.port', @value = '1234', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'KardexClientService'
exec dciowner.addDefaultApplicationProperty @code = 'KardexClientService.enabled', @externalCode = 'applicationProperties.field.KardexClientService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'KardexClientService'
exec dciowner.addDefaultApplicationProperty @code = 'KardexClientService.dualTrayEnabled', @externalCode = 'applicationProperties.field.KardexClientService.dualTrayEnabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'KardexClientService'
exec dciowner.addDefaultApplicationProperty @code = 'KardexClientService.lightsEnabled', @externalCode = 'applicationProperties.field.KardexClientService.lightsEnabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'KardexClientService'
exec dciowner.addDefaultApplicationProperty @code = 'KardexClientService.sendLaserPosition', @externalCode = 'applicationProperties.field.KardexClientService.sendLaserPosition',  @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'KardexClientService'

-- # MessageDispatcher
exec dciowner.addDefaultApplicationProperty @code = 'MessageDispatcher.enabled', @externalCode = 'applicationProperties.field.MessageDispatcher.enabled', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'MessageDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'MessageDispatcher.companyCode', @externalCode = 'applicationProperties.field.MessageDispatcher.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'MessageDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'MessageDispatcher.userName', @externalCode = 'applicationProperties.field.MessageDispatcher.userName', @value = 'test', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator', @groupName = 'MessageDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'MessageDispatcher.interval', @externalCode = 'applicationProperties.field.MessageDispatcher.interval', @value = '60000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'MessageDispatcher'

-- # OPCClient
exec dciowner.addDefaultApplicationProperty @code = 'OPCClient.connectionCheckTimeout', @externalCode = 'applicationProperties.field.OPCClient.connectionCheckTimeout', @value = '1000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OPCClient'
exec dciowner.addDefaultApplicationProperty @code = 'OPCClient.connectionTimeout', @externalCode = 'applicationProperties.field.OPCClient.connectionTimeout', @value = '180000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OPCClient'
exec dciowner.addDefaultApplicationProperty @code = 'OPCClient.validateEndPoints', @externalCode = 'applicationProperties.field.OPCClient.validateEndPoints', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'OPCClient'
exec dciowner.addDefaultApplicationProperty @code = 'OPCClient.watchdogTimeout', @externalCode = 'applicationProperties.field.OPCClient.watchdogTimeout', @value = '3000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OPCClient'
exec dciowner.addDefaultApplicationProperty @code = 'OPCClient.transactionModulesRepetition', @externalCode = 'applicationProperties.field.OPCClient.transactionModulesRepetition', @value = '3', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OPCClient'
exec dciowner.addDefaultApplicationProperty @code = 'OPCClient.publishingInterval', @groupName = 'OPCClient', @value = '100'
exec dciowner.addDefaultApplicationProperty @code = 'OPCClient.sessionTimeout', @groupName = 'OPCClient', @value = '3600000', @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator'

-- # ResponseDurationLogger
exec dciowner.addDefaultApplicationProperty @code = 'ResponseDurationLogger.enabled', @externalCode = 'applicationProperties.field.ResponseDurationLogger.enabled', @value = 'true', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ResponseDurationLogger' -- @description = 'Stores logged application response durations into database',
exec dciowner.addDefaultApplicationProperty @code = 'ResponseDurationLogger.interval', @externalCode = 'applicationProperties.field.ResponseDurationLogger.interval', @value = '1000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'ResponseDurationLogger'
exec dciowner.addDefaultApplicationProperty @code = 'ResponseDurationLogger.queueMaxSize', @externalCode = 'applicationProperties.field.ResponseDurationLogger.queueMaxSize', @value = '10000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'ResponseDurationLogger'
exec dciowner.addDefaultApplicationProperty @code = 'ResponseDurationLogger.waitForResponseLimit', @externalCode = 'applicationProperties.field.ResponseDurationLogger.waitForResponseLimit', @value = '10000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'ResponseDurationLogger'

-- # ansi
exec dciowner.addDefaultApplicationProperty @code = 'ansi', @externalCode = 'applicationProperties.field.ansi', @value = 'dtw.telnetd.io.terminal.ansi', @reloadable = 0, @groupName = 'ansi'
exec dciowner.addDefaultApplicationProperty @code = 'ansi.aliases', @externalCode = 'applicationProperties.field.ansi.aliases', @value = 'color-xterm,xterm-color,vt320,linux', @reloadable = 0, @groupName = 'ansi'

-- # ck30
exec dciowner.addDefaultApplicationProperty @code = 'ck30', @externalCode = 'applicationProperties.field.ck30', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'ck30'
exec dciowner.addDefaultApplicationProperty @code = 'ck30.aliases', @externalCode = 'applicationProperties.field.ck30.aliases', @value = 'ck30', @reloadable = 0, @groupName = 'ck30'
exec dciowner.addDefaultApplicationProperty @code = 'ck30.geometry', @externalCode = 'applicationProperties.field.ck30.geometry', @value = '20,14', @reloadable = 0, @groupName = 'ck30'

-- # Localization
exec dciowner.addDefaultApplicationProperty @code = 'TimeZonesManagerService.enabled', @externalCode = 'applicationProperties.field.TimeZonesManagerService.enabled', @value = 'true', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'Localization'
exec dciowner.addDefaultApplicationProperty @code = 'Current_Time_Zone', @externalCode = 'applicationProperties.field.DateTime.Current_Time_Zone', @value = '', @reloadable = 1, @decorator = 'jmesa.TimeZoneAutocompleteJmesaDecorator', @groupName = 'Localization'
exec dciowner.addDefaultApplicationProperty @code = 'Date_Format', @externalCode = 'applicationProperties.field.DateTime.Date_Format', @value = '', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.DateFormatValidator', @groupName = 'Localization'
exec dciowner.addDefaultApplicationProperty @code = 'Time_Format', @externalCode = 'applicationProperties.field.DateTime.Time_Format', @value = '', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.TimeFormatValidator', @groupName = 'Localization'
exec dciowner.addDefaultApplicationProperty @code = 'Numerical_Format', @externalCode = 'applicationProperties.field.Numerical_Format', @value = '#0.0####', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.NumericalFormatValidator', @decorator = null, @groupName = 'Localization'
exec dciowner.addDefaultApplicationProperty @code = 'Numerical_Locale', @externalCode = 'applicationProperties.field.Numerical_Locale', @value = 'en', @reloadable = 1, @validator = null, @decorator = 'jmesa.LanguagesSelectBoxJmesaDecorator', @groupName = 'Localization'

-- # default
exec dciowner.addDefaultApplicationProperty @code = 'default', @externalCode = 'applicationProperties.field.default', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'default'
exec dciowner.addDefaultApplicationProperty @code = 'default.aliases', @externalCode = 'applicationProperties.field.default.aliases', @value = 'default', @reloadable = 0, @groupName = 'default'
exec dciowner.addDefaultApplicationProperty @code = 'default.geometry', @externalCode = 'applicationProperties.field.default.geometry', @value = '20,12', @reloadable = 0, @groupName = 'default'
exec dciowner.addDefaultApplicationProperty @code = 'default.showDiacritics', @externalCode = 'applicationProperties.field.default.showDiacritics', @value = '0', @reloadable = 0, @groupName = 'default'

-- # denso300
exec dciowner.addDefaultApplicationProperty @code = 'denso300', @externalCode = 'applicationProperties.field.denso300', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'denso300'
exec dciowner.addDefaultApplicationProperty @code = 'denso300.aliases', @externalCode = 'applicationProperties.field.denso300.aliases', @value = 'denso300', @reloadable = 0, @groupName = 'denso300'
exec dciowner.addDefaultApplicationProperty @code = 'denso300.geometry', @externalCode = 'applicationProperties.field.denso300.geometry', @value = '22,9', @reloadable = 0, @groupName = 'denso300'
exec dciowner.addDefaultApplicationProperty @code = 'denso300.showDiacritics', @externalCode = 'applicationProperties.field.denso300.showDiacritics', @value = '0', @reloadable = 0, @groupName = 'denso300'
exec dciowner.addDefaultApplicationProperty @code = 'denso300.beepWait', @externalCode = 'applicationProperties.field.denso300.beepWait', @value = '200', @reloadable = 0, @groupName = 'denso300'

-- # densow7500
exec dciowner.addDefaultApplicationProperty @code = 'densow7500', @externalCode = 'applicationProperties.field.densow7500', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'densow7500'
exec dciowner.addDefaultApplicationProperty @code = 'densow7500.aliases', @externalCode = 'applicationProperties.field.densow7500.aliases', @value = 'densow7500', @reloadable = 0, @groupName = 'densow7500'
exec dciowner.addDefaultApplicationProperty @code = 'densow7500.geometry', @externalCode = 'applicationProperties.field.densow7500.geometry', @value = '27,19', @reloadable = 0, @groupName = 'densow7500'
exec dciowner.addDefaultApplicationProperty @code = 'densow7500.showDiacritics', @externalCode = 'applicationProperties.field.densow7500.showDiacritics', @value = '0', @reloadable = 0, @groupName = 'densow7500'

-- # ExportDeliveryNotesToSAPService
exec dciowner.addDefaultApplicationProperty @code = 'ExportDeliveryNotesToSAPService.companyCode', @externalCode = 'applicationProperties.field.ExportDeliveryNotesToSAPService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'ExportDeliveryNotesToSAPService'
exec dciowner.addDefaultApplicationProperty @code = 'ExportDeliveryNotesToSAPService.enabled', @externalCode = 'applicationProperties.field.ExportDeliveryNotesToSAPService.enabled', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'ExportDeliveryNotesToSAPService'

-- # jameleon
exec dciowner.addDefaultApplicationProperty @code = 'jameleon', @externalCode = 'applicationProperties.field.jameleon', @value = 'dtw.telnetd.io.terminal.Jameleon', @reloadable = 0, @groupName = 'jameleon'
exec dciowner.addDefaultApplicationProperty @code = 'jameleon.aliases', @externalCode = 'applicationProperties.field.jameleon.aliases', @value = 'Jameleon', @reloadable = 0, @groupName = 'jameleon'
exec dciowner.addDefaultApplicationProperty @code = 'jameleon.geometry', @externalCode = 'applicationProperties.field.jameleon.geometry', @value = '40,16', @reloadable = 0, @groupName = 'jameleon'
exec dciowner.addDefaultApplicationProperty @code = 'jameleon.showDiacritics', @externalCode = 'applicationProperties.field.jameleon.showDiacritics', @value = '0', @reloadable = 0, @groupName = 'jameleon'

-- # mc3000
exec dciowner.addDefaultApplicationProperty @code = 'mc3000', @externalCode = 'applicationProperties.field.mc3000', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'mc3000'
exec dciowner.addDefaultApplicationProperty @code = 'mc3000.aliases', @externalCode = 'applicationProperties.field.mc3000.aliases', @value = 'mc3000', @reloadable = 0, @groupName = 'mc3000'
exec dciowner.addDefaultApplicationProperty @code = 'mc3000.geometry', @externalCode = 'applicationProperties.field.mc3000.geometry', @value = '21,12', @reloadable = 0, @groupName = 'mc3000'

-- # mc9000
exec dciowner.addDefaultApplicationProperty @code = 'mc9000', @externalCode = 'applicationProperties.field.mc9000', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'mc9000'
exec dciowner.addDefaultApplicationProperty @code = 'mc9000.aliases', @externalCode = 'applicationProperties.field.mc9000.aliases', @value = 'mc9000', @reloadable = 0, @groupName = 'mc9000'
exec dciowner.addDefaultApplicationProperty @code = 'mc9000.geometry', @externalCode = 'applicationProperties.field.mc9000.geometry', @value = '24,17', @reloadable = 0, @groupName = 'mc9000'

-- # mc9100
exec dciowner.addDefaultApplicationProperty @code = 'mc9100', @externalCode = 'applicationProperties.field.mc9100', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'mc9100'
exec dciowner.addDefaultApplicationProperty @code = 'mc9100.aliases', @externalCode = 'applicationProperties.field.mc9100.aliases', @value = 'mc9100', @reloadable = 0, @groupName = 'mc9100'
exec dciowner.addDefaultApplicationProperty @code = 'mc9100.geometry', @externalCode = 'applicationProperties.field.mc9100.geometry', @value = '24,17', @reloadable = 0, @groupName = 'mc9100'

-- # mc9200
exec dciowner.addDefaultApplicationProperty @code = 'mc9200.aliases', @externalCode = 'mc9200.aliases', @value = 'mc9200', @reloadable = 0, @groupName = 'mc9200'
exec dciowner.addDefaultApplicationProperty @code = 'mc9200', @externalCode = 'mc9200', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'mc9200'
exec dciowner.addDefaultApplicationProperty @code = 'mc9200.geometry', @externalCode = 'mc9200.geometry', @value = '24,17', @reloadable = 0, @groupName = 'mc9200'

-- # wt41
exec dciowner.addDefaultApplicationProperty @code = 'wt41', @externalCode = 'applicationProperties.field.wt41', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'wt41'
exec dciowner.addDefaultApplicationProperty @code = 'wt41.aliases', @externalCode = 'applicationProperties.field.wt41.aliases', @value = 'wt41', @reloadable = 0, @groupName = 'wt41'
exec dciowner.addDefaultApplicationProperty @code = 'wt41.geometry', @externalCode = 'applicationProperties.field.wt41.geometry', @value = '21,9', @reloadable = 0, @groupName = 'wt41'

-- # ppt8800
exec dciowner.addDefaultApplicationProperty @code = 'ppt8800', @externalCode = 'applicationProperties.field.ppt8800', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'ppt8800'
exec dciowner.addDefaultApplicationProperty @code = 'ppt8800.aliases', @externalCode = 'applicationProperties.field.ppt8800.aliases', @value = 'ppt8800', @reloadable = 0, @groupName = 'ppt8800'
exec dciowner.addDefaultApplicationProperty @code = 'ppt8800.geometry', @externalCode = 'applicationProperties.field.ppt8800.geometry', @value = '24,15', @reloadable = 0, @groupName = 'ppt8800'

-- # PrintDispatcher
exec dciowner.addDefaultApplicationProperty @code = 'PrintDispatcher.enabled', @externalCode = 'applicationProperties.field.PrintDispatcher.enabled', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PrintDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'printerQueue.lpr.waitForAcknoledgeForFileCommands', @externalCode = 'applicationProperties.field.PrintDispatcher.printerQueue.lpr.waitForAcknoledgeForFileCommands', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PrintDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'printerQueue.sendMessageOnError', @externalCode = 'applicationProperties.field.printDispatcher.printerQueue.sendMessageOnError', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PrintDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'printerQueue.maxEntryAge', @externalCode = 'applicationProperties.field.printDispatcher.printerQueue.maxEntryAge', @value = null, @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PrintDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'printerQueue.sleepFrequency', @externalCode = 'applicationProperties.field.printDispatcher.printerQueue.sleepFrequency', @value = null, @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PrintDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'printerQueue.zebraRetryCount', @externalCode = 'applicationProperties.field.printDispatcher.printerQueue.zebraRetryCount', @value = null, @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PrintDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'PrintDispatcher.companyCode', @externalCode = 'applicationProperties.field.PrintDispatcher.companyCode', @value = 'Default com', @reloadable = 0, @groupName = 'PrintDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'printDispatcher.printJasperZebraLabelsOneByOne', @externalCode = 'applicationProperties.field.PrintDispatcher.printJasperZebraLabelsOneByOne', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PrintDispatcher'
exec dciowner.addDefaultApplicationProperty @code = 'PrintDispatcher.printToOnePdfFile', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'PrintDispatcher' -- @description = setting for printing labels (for delivery note) in one PDF file
exec dciowner.addDefaultApplicationProperty @code = 'print.toOnePDFFile', @externalCode = 'applicationProperties.field.print.toOnePDFFile', @value = '', @reloadable = 0, @groupName = 'Print'

-- # putty
exec dciowner.addDefaultApplicationProperty @code = 'putty', @externalCode = 'applicationProperties.field.putty', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'putty'
exec dciowner.addDefaultApplicationProperty @code = 'putty.aliases', @externalCode = 'applicationProperties.field.putty.aliases', @value = 'putty', @reloadable = 0, @groupName = 'putty'
exec dciowner.addDefaultApplicationProperty @code = 'putty.geometry', @externalCode = 'applicationProperties.field.putty.geometry', @value = '21,16', @reloadable = 0, @groupName = 'putty'
exec dciowner.addDefaultApplicationProperty @code = 'putty.detectGeometry', @externalCode = 'applicationProperties.field.putty.detectGeometry', @value = '1', @reloadable = 0, @groupName = 'putty'
exec dciowner.addDefaultApplicationProperty @code = 'putty.showDiacritics', @externalCode = 'applicationProperties.field.putty.showDiacritics', @value = '1', @reloadable = 0, @groupName = 'putty'

-- # symbol220
exec dciowner.addDefaultApplicationProperty @code = 'symbol220', @externalCode = 'applicationProperties.field.symbol220', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'symbol220'
exec dciowner.addDefaultApplicationProperty @code = 'symbol220.aliases', @externalCode = 'applicationProperties.field.symbol220.aliases', @value = 'symbol220', @reloadable = 0, @groupName = 'symbol220'
exec dciowner.addDefaultApplicationProperty @code = 'symbol220.geometry', @externalCode = 'applicationProperties.field.symbol220.geometry', @value = '21,16', @reloadable = 0, @groupName = 'symbol220'

-- # teklogixansi
exec dciowner.addDefaultApplicationProperty @code = 'teklogixansi', @externalCode = 'applicationProperties.field.teklogixansi', @value = 'dtw.telnetd.io.terminal.TeklogixAnsi', @reloadable = 0, @groupName = 'teklogixansi'
exec dciowner.addDefaultApplicationProperty @code = 'teklogixansi.aliases', @externalCode = 'applicationProperties.field.teklogixansi.aliases', @value = 'teklogixansi', @reloadable = 0, @groupName = 'teklogixansi'
exec dciowner.addDefaultApplicationProperty @code = 'teklogixansi.geometry', @externalCode = 'applicationProperties.field.teklogixansi.geometry', @value = '22,16', @reloadable = 0, @groupName = 'teklogixansi'

-- # Terminals
exec dciowner.addDefaultApplicationProperty @code = 'TERMINALS', @externalCode = 'applicationProperties.field.terminals', @value = 'default,vt100,ansi,windoof,xterm,symbol220,teklogixansi,wss1060,putty,ck30,densow7500,denso300,jameleon,mc9000,ppt8800,mc3000,mc9100,mc9200,wt41', @reloadable = 0, @groupName = 'Terminals'

-- # timesheets
exec dciowner.addDefaultApplicationProperty @code = 'Raster_For_Activity_Export_Minutes', @externalCode = 'applicationProperties.field.timesheets.Raster_For_Activity_Export_Minutes', @value = '30', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'timesheets'

-- # vt100
exec dciowner.addDefaultApplicationProperty @code = 'vt100', @externalCode = 'applicationProperties.field.vt100', @value = 'dtw.telnetd.io.terminal.vt100', @reloadable = 0, @groupName = 'vt100'
exec dciowner.addDefaultApplicationProperty @code = 'vt100.aliases', @externalCode = 'applicationProperties.field.vt100.aliases', @value = 'vt100-am,vt102,dec-vt100', @reloadable = 0, @groupName = 'vt100'

-- # windoof
exec dciowner.addDefaultApplicationProperty @code = 'windoof', @externalCode = 'applicationProperties.field.windoof', @value = 'dtw.telnetd.io.terminal.Windoof', @reloadable = 0, @groupName = 'windoof'
exec dciowner.addDefaultApplicationProperty @code = 'windoof.aliases', @externalCode = 'applicationProperties.field.windoof.aliases', @value = '', @reloadable = 0, @groupName = 'windoof'

-- # wss1060
exec dciowner.addDefaultApplicationProperty @code = 'wss1060', @externalCode = 'applicationProperties.field.wss1060', @value = 'dtw.telnetd.io.terminal.Symbol220', @reloadable = 0, @groupName = 'wss1060'
exec dciowner.addDefaultApplicationProperty @code = 'wss1060.aliases', @externalCode = 'applicationProperties.field.wss1060.aliases', @value = 'wss1060', @reloadable = 0, @groupName = 'wss1060'
exec dciowner.addDefaultApplicationProperty @code = 'wss1060.geometry', @externalCode = 'applicationProperties.field.wss1060.geometry', @value = '20,8', @reloadable = 0, @groupName = 'wss1060'

-- # xterm
exec dciowner.addDefaultApplicationProperty @code = 'xterm', @externalCode = 'applicationProperties.field.xterm', @value = 'dtw.telnetd.io.terminal.xterm', @reloadable = 0, @groupName = 'xterm'
exec dciowner.addDefaultApplicationProperty @code = 'xterm.aliases', @externalCode = 'applicationProperties.field.xterm.aliases', @value = '', @reloadable = 0, @groupName = 'xterm'

-- # JMesa Table settings - Excel
exec dciowner.addDefaultApplicationProperty @code = 'jmesa.export.excel' 					, @externalCode = 'applicationProperties.field.JMesaTableExportSetting.jmesa.export.excel', @value = 'true', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'JMesaTableExportSetting'
exec dciowner.addDefaultApplicationProperty @code = 'jmesa.export.excel.maxRecordCount' 		, @externalCode = 'applicationProperties.field.JMesaTableExportSetting.jmesa.export.excel.maxRecordCount', @value = '20000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'JMesaTableExportSetting'

-- # JMesa Table settings - CSV
exec dciowner.addDefaultApplicationProperty @code = 'jmesa.export.csv' 					 	, @externalCode = 'applicationProperties.field.JMesaTableExportSetting.jmesa.export.csv', @value = 'true', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'JMesaTableExportSetting'
exec dciowner.addDefaultApplicationProperty @code = 'jmesa.export.csv.maxRecordCount' 		, @externalCode = 'applicationProperties.field.JMesaTableExportSetting.jmesa.export.csv.maxRecordCount', @value = '20000', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'JMesaTableExportSetting'

-- # Maintenance Mode
exec dciowner.addDefaultApplicationProperty @code = 'maintenanceMode.enabled'                            , @externalCode = 'applicationProperties.field.Common.maintenanceMode.enabled', @value = 'false'                                                                           , @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = null

-- # image folder
exec dciowner.addDefaultApplicationProperty @code = 'users.images.folder'                            	  , @externalCode = 'applicationProperties.field.user.images.folder', @value = 'file://c:/'                                                               	   , @reloadable = 1, @groupName = 'user'

-- # fileBrowser path
exec dciowner.addDefaultApplicationProperty @code = 'logoImagePath', @externalCode = 'applicationProperties.field.Common.logoImagePath', @value = null, @reloadable = 1, @groupName = null  --, @description = 'path to optional top menu logo'

-- # android
exec dciowner.addDefaultApplicationProperty @code = 'application.server.address' 		, @externalCode = 'applicationProperties.field.application.server.address', @value = 'http://server.domain.com', @reloadable = 1, @groupName = 'android'
exec dciowner.addDefaultApplicationProperty @code = 'application.server.port' 			, @externalCode = 'applicationProperties.field.application.server.port', @value = '8081', @reloadable = 1, @groupName = 'android'
exec dciowner.addDefaultApplicationProperty @code = 'android.client.download.apk' 		, @externalCode = 'applicationProperties.field.android.client.download.apk', @value = 'dci.configProperty(application.server.address):dci.configProperty(application.server.port)dci.configProperty(LOGIN.context)/files/android/client/Aimtec_Touch_Client.apk', @reloadable = 1, @groupName = 'android', @scannable = 1
exec dciowner.addDefaultApplicationProperty @code = 'android.browser.download.apk'		, @externalCode = 'applicationProperties.field.android.browser.download.apk', @value = 'dci.configProperty(application.server.address):dci.configProperty(application.server.port)dci.configProperty(LOGIN.context)/files/android/browser/Aimtec_Browser.apk', @reloadable = 1, @groupName = 'android', @scannable = 1
exec dciowner.addDefaultApplicationProperty @code = 'client.connect' 					, @externalCode = 'applicationProperties.field.client.connect', @value = 'server=dci.configProperty(application.server.address):dci.configProperty(application.server.port);context=dci.configProperty(LOGIN.context)', @reloadable = 0, @groupName = 'android', @scannable = 1
exec dciowner.addDefaultApplicationProperty @code = 'android.touch.client.configuration'	, @externalCode = 'applicationProperties.field.android.touch.client.configuration', @value = 'dci.configProperty(application.server.address):dci.configProperty(application.server.port)dci.configProperty(LOGIN.context)/files/android/client/config/config.properties', @reloadable = 1, @groupName = 'android', @scannable = 1
exec dciowner.addDefaultApplicationProperty @code = 'android.browser.configuration'	, @externalCode = 'applicationProperties.field.android.browser.configuration', @value = 'dci.configProperty(application.server.address):dci.configProperty(application.server.port)dci.configProperty(LOGIN.context)/files/android/browser/config/config.properties', @reloadable = 1, @groupName = 'android', @scannable = 1
exec dciowner.addDefaultApplicationProperty @code = 'ANDROID_TOUCH_CLIENT.logon.config.report.name'				, @externalCode = 'applicationProperties.field.ANDROID_TOUCH_CLIENT.logon.config.report.name', @value = null, @reloadable = 1, @groupName = 'android'
exec dciowner.addDefaultApplicationProperty @code = 'ANDROID_TOUCH_CLIENT.logon.config.report.refreshinterval'	, @externalCode = 'applicationProperties.field.ANDROID_TOUCH_CLIENT.logon.config.report.refreshinterval', @value = null, @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveNumberValidator', @groupName = 'android'
exec dciowner.addDefaultApplicationProperty @code = 'logon.versionWarning.ANDROID_TOUCH_CLIENT.enabled'				, @externalCode = 'applicationProperties.field.logon.versionWarning.ANDROID_TOUCH_CLIENT.enabled', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'android'
exec dciowner.addDefaultApplicationProperty @code = 'logon.versionWarning.ANDROID_TOUCH_CLIENT.type'				, @externalCode = 'applicationProperties.field.logon.versionWarning.ANDROID_TOUCH_CLIENT.type', @value = 'EQUAL', @reloadable = 1, @groupName = 'android'
exec dciowner.addDefaultApplicationProperty @code = 'logon.versionWarning.ANDROID_TOUCH_CLIENT.supportedVersion'	, @externalCode = 'applicationProperties.field.logon.versionWarning.ANDROID_TOUCH_CLIENT.supportedVersion', @value = null, @reloadable = 1, @groupName = 'android'

-- # TransactionOptimalPlanService
exec dciowner.addDefaultApplicationProperty @code = 'TransactionOptimalPlanService.enabled' 		, @externalCode = 'applicationProperties.field.TransactionOptimalPlanService.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'TransactionOptimalPlanService'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionOptimalPlanService.interval' 		, @externalCode = 'applicationProperties.field.TransactionOptimalPlanService.interval', @value = '5000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'TransactionOptimalPlanService'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionOptimalPlanService.companyCode' 	, @externalCode = 'applicationProperties.field.TransactionOptimalPlanService.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'TransactionOptimalPlanService'

exec dciowner.addDefaultApplicationProperty @code = 'Portal_Purchase_Order_UO_Definition', @externalCode = 'applicationProperties.field.Common.Portal_Purchase_Order_UO_Definition', @value = null, @reloadable = 0, @groupName = null
exec dciowner.addDefaultApplicationProperty @code = 'Portal_Purchase_Order_UO_Released_State', @externalCode = 'applicationProperties.field.Common.Portal_Purchase_Order_UO_Released_State', @value = null, @reloadable = 0, @groupName = null

-- # SQL Task Service
exec dciowner.addDefaultApplicationProperty @code = 'SqlTaskService.enabled'           				  , @externalCode = 'applicationProperties.field.SqlTaskService.enabled', @value = 'false'                                                                           , @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'SqlTaskService'
exec dciowner.addDefaultApplicationProperty @code = 'SqlTaskService.companyCode'          		  		  , @externalCode = 'applicationProperties.field.SqlTaskService.companyCode', @value = @currentCompanyCode                                                                             , @reloadable = 0, @groupName = 'SqlTaskService'


-- # Login
exec dciowner.addDefaultApplicationProperty @code = 'LOGIN.authenticationMethod', @externalCode = 'applicationProperties.field.login.authenticationMethod', @value = 'DCI', @reloadable = 1, @groupName = 'LOGIN'

-- # SAPRfcServerService
exec dciowner.addDefaultApplicationProperty @code = 'SAPRfcServerService.enabled', @externalCode = 'applicationProperties.field.SAPRfcServer.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'SAPRfcServer'
exec dciowner.addDefaultApplicationProperty @code = 'SAPRfcServerService.companyCode', @externalCode = 'applicationProperties.field.SAPRfcServer.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'SAPRfcServer'
exec dciowner.addDefaultApplicationProperty @code = 'SAPRfcServerService.transactionCode', @externalCode = 'applicationProperties.field.SAPRfcServer.transactionCode', @value = 'SAP_RFC', @reloadable = 1, @groupName = 'SAPRfcServer'
exec dciowner.addDefaultApplicationProperty @code = 'SAPRfcServerService.connectionCheckTimeout', @externalCode = 'applicationProperties.field.SAPRfcServer.connectionCheckTimeout', @value = '60000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'SAPRfcServer'
exec dciowner.addDefaultApplicationProperty @code = 'SAPRfcServerService.autoRestart', @externalCode = 'applicationProperties.field.SAPRfcServerService.autoRestart', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'SAPRfcServer'
	 
-- # KIA JIS messages
exec dciowner.addDefaultApplicationProperty @code = 'kia.messages.integrationFolder'                    , @externalCode = 'applicationProperties.field.kia.messages.integrationFolder', @value = 'dataexchange/kia', @reloadable = 1, @groupName = 'kia.messages'
exec dciowner.addDefaultApplicationProperty @code = 'kia.messages.filePattern'                          , @externalCode = 'applicationProperties.field.kia.messages.filePattern', @value = '.dat', @reloadable = 1, @groupName = 'kia.messages'
exec dciowner.addDefaultApplicationProperty @code = 'kia.messages.productFamily'                        , @externalCode = 'applicationProperties.field.kia.messages.productFamily', @value = 'ED', @reloadable = 1, @groupName = 'kia.messages'

-- # Links to webpages
exec dciowner.addDefaultApplicationProperty @code = 'webPage.aimtecHome.url', @externalCode = 'applicationProperties.field.webPage.aimtecHome.url', @groupName = 'webPage', @value = 'http://www.aimtec.cz', @reloadable = 1
exec dciowner.addDefaultApplicationProperty @code = 'webPage.serviceDesk.url', @externalCode = 'applicationProperties.field.webPage.serviceDesk.url', @groupName = 'webPage', @value = 'https://sd.aimtec.cz', @reloadable = 1

-- # OEE_Report
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.OEE_Negative_Start'					  , @value = '50', @externalCode = 'applicationProperties.field.OEE_Report.OEE_Negative_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.OEE_Neutral_Start'						  , @value = '60', @externalCode = 'applicationProperties.field.OEE_Report.OEE_Neutral_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.OEE_Positive_Start'					  , @value = '70', @externalCode = 'applicationProperties.field.OEE_Report.OEE_Positive_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Availability_Negative_Start'			  , @value = '30', @externalCode = 'applicationProperties.field.OEE_Report.Availability_Negative_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Availability_Neutral_Start'			  , @value = '60', @externalCode = 'applicationProperties.field.OEE_Report.Availability_Neutral_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Availability_Positive_Start'			  , @value = '80', @externalCode = 'applicationProperties.field.OEE_Report.Availability_Positive_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Quality_Negative_Start'				  , @value = '70', @externalCode = 'applicationProperties.field.OEE_Report.Quality_Negative_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Quality_Neutral_Start'					  , @value = '90', @externalCode = 'applicationProperties.field.OEE_Report.Quality_Neutral_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Quality_Positive_Start'				  , @value = '97', @externalCode = 'applicationProperties.field.OEE_Report.Quality_Positive_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Performance_Negative_Start'			  , @value = '70', @externalCode = 'applicationProperties.field.OEE_Report.Performance_Negative_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Performance_Neutral_Start'				  , @value = '90', @externalCode = 'applicationProperties.field.OEE_Report.Performance_Neutral_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'
exec dciowner.addDefaultApplicationProperty @code = 'OEE_Report.Performance_Positive_Start'			  , @value = '97', @externalCode = 'applicationProperties.field.OEE_Report.Performance_Positive_Start', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'OEE_Report'

-- # TransactionFlowLogger
exec dciowner.addDefaultApplicationProperty @code = 'TransactionFlowLogger.enabled', @externalCode = 'applicationProperties.field.TransactionFlowLogger.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'logging'

-- # TransactionStepDurationLogger
exec dciowner.addDefaultApplicationProperty @code = 'TransactionStepDurationLogger.enabled', @externalCode = 'applicationProperties.field.TransactionStepDurationLogger.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'logging'
exec dciowner.addDefaultApplicationProperty @code = 'TransactionStepDurationLogger.topTransactionDefinitions'  , @value = '', @externalCode = 'applicationProperties.field.TransactionStepDurationLogger.topTransactionDefinitions', @reloadable = 1, @groupName = 'logging'

-- # TransactionStepDurationWriter
exec dciowner.addDefaultApplicationProperty @code = 'TransactionStepDurationWriter.interval'             , @value = '100', @externalCode = 'applicationProperties.field.TransactionStepDurationWriter.interval', @reloadable = 1, @groupName = 'logging'

-- # Service discovery server location
exec dciowner.addDefaultApplicationProperty @code = 'service.discovery.server', @externalCode = 'applicationProperties.field.service.discovery.server', @value = 'localhost', @reloadable = 0, @groupName = 'serviceDiscovery'
exec dciowner.addDefaultApplicationProperty @code = 'service.discovery.port', @externalCode = 'applicationProperties.field.service.discovery.port', @value = '10180', @reloadable = 0, @groupName = 'serviceDiscovery'
exec dciowner.addDefaultApplicationProperty @code = 'service.discovery.path', @externalCode = 'applicationProperties.field.service.discovery.path', @value = 'SearchEngine', @reloadable = 0, @groupName = 'serviceDiscovery'

-- # contract settings
exec dciowner.addDefaultApplicationProperty @code = 'contract.showAvaiableQuantityInDetail', @externalCode = 'applicationProperties.field.contract.showAvaiableQuantityInDetail', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'contract'
exec dciowner.addDefaultApplicationProperty @code = 'contract.showExpeditionWarehouseQuantityInDetail', @externalCode = 'applicationProperties.field.contract.showExpeditionWarehouseQuantityInDetail', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'contract'
exec dciowner.addDefaultApplicationProperty @code = 'contract.expeditionWarehousesForQuantityInDetail', @externalCode = 'applicationProperties.field.contract.expeditionWarehousesForQuantityInDetail', @value = null, @reloadable = 1, @groupName = 'contract'

-- # collections
exec dciowner.addDefaultApplicationProperty @code = 'collection.defaultRecordCount', @value = '20', @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'collection'
exec dciowner.addDefaultApplicationProperty @code = 'Pagination_Page_Size_Default', @value = null, @validator = 'cz.aimtec.dci.action.jmesa.validators.PageSizeDefaultValidator', @groupName = 'collection', @reloadable = 1
exec dciowner.addDefaultApplicationProperty @code = 'Pagination_Page_Size_Increments', @value = null, @validator = 'cz.aimtec.dci.action.jmesa.validators.PageSizeIncrementsValidator', @groupName = 'collection', @reloadable = 1


-- # Products In Partial Zones Notification
exec dciowner.addDefaultApplicationProperty @code = 'productsInPartialZonesNotification.parentZones', @externalCode = 'applicationProperties.field.productsInPartialZonesNotification.parentZones', @value = '', @reloadable = 1

-- # BOM
exec dciowner.addDefaultApplicationProperty @code = 'bomAlternative', @externalCode = 'applicationProperties.field.bomAlternative', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'BOM'

-- # restoreLiveToTest
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.tomcatStartJob'                 , @value = 'dci_DCI_Restore_Live_To_Test_Start_Tomcat', 	@externalCode = 'applicationProperties.field.restoreLiveToTest.tomcatStartJob'  				   	, @reloadable = 1, @groupName = 'restoreLiveToTest'
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.tomcatStopJob'                  , @value = 'dci_DCI_Restore_Live_To_Test_Stop_Tomcat', 		@externalCode = 'applicationProperties.field.restoreLiveToTest.tomcatStopJob'  					   	, @reloadable = 1, @groupName = 'restoreLiveToTest'
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.backupDirectory'                , @value = '', 												@externalCode = 'applicationProperties.field.restoreLiveToTest.backupDirectory'  				   	, @reloadable = 1, @groupName = 'restoreLiveToTest'
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.collectorDaysThreshold'         , @value = '30', 											@externalCode = 'applicationProperties.field.restoreLiveToTest.collectorDaysThreshold'  		   	, @reloadable = 1, @groupName = 'restoreLiveToTest'

exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.disablePrintDispatcher'         , @value = 'true', 											@externalCode = 'applicationProperties.field.restoreLiveToTest.disablePrintDispatcher'				, @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'restoreLiveToTest'
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.printerPrefix'                  , @value = 'tst_', 											@externalCode = 'applicationProperties.field.restoreLiveToTest.printerPrefix'  					    , @reloadable = 1, @groupName = 'restoreLiveToTest'
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.deleteEmailNotification'        , @value = 'true', 											@externalCode = 'applicationProperties.field.restoreLiveToTest.deleteEmailNotification'  			, @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'restoreLiveToTest'
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.deleteOPCSubscriptions'         , @value = 'true', 											@externalCode = 'applicationProperties.field.restoreLiveToTest.deleteOPCSubscriptions'  			, @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'restoreLiveToTest'
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.disableTCPIPListeners'          , @value = 'true', 											@externalCode = 'applicationProperties.field.restoreLiveToTest.disableTCPIPListeners'  			    , @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'restoreLiveToTest'

exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.oldBackupsToKeep'               , @value = '5', 											@externalCode = 'applicationProperties.field.restoreLiveToTest.oldBackupsToKeep' 					, @reloadable = 1, @groupName = 'restoreLiveToTest'
exec dciowner.addDefaultApplicationProperty @code = 'restoreLiveToTest.oldBackupsToKeepTotalSizeLimit' , @value = '10000', 										@externalCode = 'applicationProperties.field.restoreLiveToTest.oldBackupsToKeepTotalSizeLimit'		, @reloadable = 1, @groupName = 'restoreLiveToTest'


-- # PlanningCalendar
exec dciowner.addDefaultApplicationProperty @code = 'PlanningCalendar.maxDateDaysDiff', @externalCode = 'applicationProperties.field.PlanningCalendar.maxDateDaysDiff', @value = '1', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PlanningCalendar'
exec dciowner.addDefaultApplicationProperty @code = 'PlanningCalendar.minDateDays', @externalCode = 'applicationProperties.field.PlanningCalendar.minDateDays', @value = '7', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'PlanningCalendar'

-- # Package Types Icons
exec dciowner.addDefaultApplicationProperty @code = 'packageTypesIcons.path',		@externalCode = 'applicationProperties.field.packageTypesIcons.path',		@value = 'img/packageTypes/',	@intoCurrentDB = 1, @reloadable = 1, @groupName = null
exec dciowner.addDefaultApplicationProperty @code = 'packageTypesIcons.cust_path', @externalCode = 'applicationProperties.field.packageTypesIcons.cust_path',	@value = null,					@intoCurrentDB = 1, @reloadable = 1, @groupName = null

-- # others
exec dciowner.addDefaultApplicationProperty @code = 'PackageGeneratorForOrder.pckgQtyGreaterThanTransQtyIsError', @groupName = 'PackageGeneratorForOrder', @value = 'false', @externalCode = 'applicationProperties.field.PackageGeneratorForOrder.pckgQtyGreaterThanTransQtyIsError'
exec dciowner.addDefaultApplicationProperty @code = 'useDuplicateQuestionCode', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'QMS', @externalCode='Aloow_Duplicate_Question_Code'

-- # ResponseDurationMachinesLogger
exec dciowner.addDefaultApplicationProperty @code = 'ResponseDurationMachinesLogger.enabled', @groupName = 'ResponseDurationMachinesLogger', @value = 'true', @externalCode = 'applicationProperties.field.ResponseDurationMachinesLogger.enabled', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator'
exec dciowner.addDefaultApplicationProperty @code = 'ResponseDurationMachinesLogger.interval',	@groupName = 'ResponseDurationMachinesLogger', @value = '1000', @externalCode = 'applicationProperties.field.ResponseDurationMachinesLogger.interval', @reloadable = 1
exec dciowner.addDefaultApplicationProperty @code = 'ResponseDurationMachinesLogger.unfinishedQueueMaxSize', @groupName = 'ResponseDurationMachinesLogger', @value = '1000', @externalCode = 'applicationProperties.field.ResponseDurationMachinesLogger.unfinishedQueueMaxSize', @reloadable = 1
exec dciowner.addDefaultApplicationProperty @code = 'ResponseDurationMachinesLogger.recordsWithoutEndInMinutes', @groupName = 'ResponseDurationMachinesLogger', @value = '30', @externalCode = 'applicationProperties.field.ResponseDurationMachinesLogger.recordsWithoutEndInMinutes', @reloadable = 1

-- MQTTClient
exec dciowner.addDefaultApplicationProperty @code = 'MQTTClient.connectionTimeout', @externalCode = 'applicationProperties.field.MQTTClient.connectionTimeout', @groupName = 'TCPIPListener', @value = '5000', @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator'

-- # Scanning / parsing
exec dciowner.addDefaultApplicationProperty @code = 'GS1_SSCC_FN1_Separators', @externalCode = 'applicationProperties.field.GS1_SSCC_FN1_Separators', @groupName = 'scanning', @value = '+', @reloadable = 1

-- Background transaction executor
exec dciowner.addDefaultApplicationProperty @code = 'BackgroundTransactionExecutor.enabled', @externalCode = 'applicationProperties.field.BackgroundTransactionExecutor.enabled', @groupName = 'BackgroundTransactionExecutor', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator'
exec dciowner.addDefaultApplicationProperty @code = 'BackgroundTransactionExecutor.companyCode', @externalCode = 'applicationProperties.field.BackgroundTransactionExecutor.companyCode', @groupName = 'BackgroundTransactionExecutor', @value = @currentCompanyCode, @reloadable = 0, @validator = null
exec dciowner.addDefaultApplicationProperty @code = 'BackgroundTransactionExecutor.userName', @externalCode = 'applicationProperties.field.BackgroundTransactionExecutor.userName', @groupName = 'BackgroundTransactionExecutor', @value = 'dci', @reloadable = 0, @validator = 'cz.aimtec.dci.action.jmesa.validators.UserValidator'

-- # LogsFreeDiskSpaceChecker
exec dciowner.addDefaultApplicationProperty @code = 'LogsFreeDiskSpaceChecker.interval', @externalCode = 'applicationProperties.field.LogsFreeDiskSpaceChecker.interval', @value = '600000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'LogsFreeDiskSpaceChecker'
exec dciowner.addDefaultApplicationProperty @code = 'LogsFreeDiskSpaceChecker.enabled', @externalCode = 'applicationProperties.field.LogsFreeDiskSpaceChecker.enabled', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'LogsFreeDiskSpaceChecker'
exec dciowner.addDefaultApplicationProperty @code = 'LogsFreeDiskSpaceChecker.minimalDiskFreeSpace', @externalCode = 'applicationProperties.field.LogsFreeDiskSpaceChecker.minimalDiskFreeSpace', @value = '11264', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'LogsFreeDiskSpaceChecker'
exec dciowner.addDefaultApplicationProperty @code = 'LogsFreeDiskSpaceChecker.companyCode', @externalCode = 'applicationProperties.field.LogsFreeDiskSpaceChecker.companyCode', @value = @currentCompanyCode, @reloadable = 0, @groupName = 'LogsFreeDiskSpaceChecker'

-- # CSRF Guard
exec dciowner.addDefaultApplicationProperty @code = 'csrf.tokenParameterName', @externalCode = 'applicationProperties.field.csrf.tokenParameterName', @groupName = 'CSRFGuard', @value = 'OWASP-CSRFTOKEN', @reloadable = 1

-- # Partnership
exec dciowner.addDefaultApplicationProperty @code = 'partnership.ASNGenerateAction.defaultValue', @externalCode = 'applicationProperties.field.partnership.ASNGenerateAction.defaultValue', @groupName = 'Partnership', @value = 'N', @reloadable = 1
exec dciowner.addDefaultApplicationProperty @code = 'partnership.releaseContainsQtyReceived.defaultValue', @externalCode = 'applicationProperties.field.partnership.releaseContainsQtyReceived.defaultValue', @groupName = 'Partnership', @value = 1, @reloadable = 1

-- # routings
exec dciowner.addDefaultApplicationProperty @code = 'routing.excludeTransactions', @externalCode = 'applicationProperties.field.routing.excludeTransactions', @value = '', @reloadable = 1, @groupName = 'routing'
exec dciowner.addDefaultApplicationProperty @code = 'routing.miniroutingGroups', @externalCode = 'applicationProperties.field.routing.miniroutingGroups', @value = 'JIS-MINIROUTING', @reloadable = 1, @groupName = 'routing'

-- Check EAN codes duplicity
exec dciowner.addDefaultApplicationProperty @code = 'checkEanCodeDuplicities', @externalCode = 'applicationProperties.field.checkEanCodeDuplicities', @value = 'false', @reloadable = 0, @decorator = 'jmesa.BooleanJmesaDecorator'

-- # Keycloak Authentication
exec dciowner.addDefaultApplicationProperty @code = 'keycloak.baseUrl', @externalCode = 'applicationProperties.field.keycloak.baseUrl', @groupName = 'keycloak', @value = null, @reloadable = 1, @validator = null
exec dciowner.addDefaultApplicationProperty @code = 'keycloak.clientBaseUrl', @externalCode = 'applicationProperties.field.keycloak.clientBaseUrl', @groupName = 'keycloak', @value = null, @reloadable = 1, @validator = null
exec dciowner.addDefaultApplicationProperty @code = 'keycloak.realm', @externalCode = 'applicationProperties.field.keycloak.realm', @groupName = 'keycloak', @value = 'DCI', @reloadable = 1, @validator = null
exec dciowner.addDefaultApplicationProperty @code = 'keycloak.clientId', @externalCode = 'applicationProperties.field.keycloak.clientId', @groupName = 'keycloak', @value = 'DCIx', @reloadable = 1, @validator = null
exec dciowner.addDefaultApplicationProperty @code = 'keycloak.logoutEnabled', @externalCode = 'applicationProperties.field.keycloak.logoutEnabled', @groupName = 'keycloak', @value = 'true', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator'

-- Displaytag scheduler decorator
exec dciowner.addDefaultApplicationProperty @code = 'scheduler.export.pdf', @externalCode = 'applicationProperties.field.scheduler.export.pdf', @value = null, @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator'

-- # Calendar first day of the week index
exec dciowner.addDefaultApplicationProperty @code = 'calendar.weekStartDayIndex', @externalCode = 'applicationProperties.field.calendar.weekStartDayIndex', @value = '1', @reloadable = 1, @decorator = 'jmesa.WeekStartDaySelectBoxJmesaDecorator', @groupName = 'calendar'

-- # quality
exec dciowner.addDefaultApplicationProperty @code = 'qualityDocumentDefinition.defaultState', @externalCode = 'applicationProperties.field.qualityDocumentDefinition.defaultState', @value = 'Released', @reloadable = 1, @decorator = 'jmesa.QualityDocumentDefinitionStateJmesaDecorator'
exec dciowner.addDefaultApplicationProperty @code = 'qualityDocumentDefinition.releasedState', @externalCode = 'applicationProperties.field.qualityDocumentDefinition.releasedState', @value = 'Released', @reloadable = 1, @decorator = 'jmesa.QualityDocumentDefinitionStateJmesaDecorator'

-- Jungheinrich AGV
exec dciowner.addDefaultApplicationProperty @code = 'jungheinrich.agv.protocolVersion', @externalCode = 'applicationProperties.field.jungheinrich.agv.protocolVersion', @value = '2', @reloadable = 1, @groupName = 'JungheinrichAGV', @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveIntegerValueValidator'

-- Swisslog
exec dciowner.addDefaultApplicationProperty @code = 'swisslog.telegram.senderId', @externalCode = 'applicationProperties.field.swisslog.telegram.senderId', @value = 'DCIxWH', @reloadable = 1, @groupName = 'Swisslog'

-- Transaction Definitions
exec dciowner.addDefaultApplicationProperty @code = 'TransactionDefinitions.menuIconStartPath', @externalCode = 'applicationProperties.field.TransactionDefinitions.menuIconStartPath', @groupName = 'TransactionDefinitions', @value = 'img/transDef', @reloadable = 1
exec dciowner.addDefaultApplicationProperty @code = 'TransactionDefinitions.menuIconFileFilters', @externalCode = 'applicationProperties.field.TransactionDefinitions.menuIconFileFilters', @groupName = 'TransactionDefinitions', @value = '*.bmp,*.gif,*.ico,*.jpeg,*.jpg,*.png', @reloadable = 1

-- # System Services monitoring
exec dciowner.addDefaultApplicationProperty @code = 'SystemServicesMonitor.enabled', @externalCode = 'applicationProperties.field.SystemServicesMonitor.enabled', @value = 'false', @reloadable = 1, @decorator = 'jmesa.BooleanJmesaDecorator', @groupName = 'SystemServicesMonitor'
exec dciowner.addDefaultApplicationProperty @code = 'SystemServicesMonitor.interval', @externalCode = 'applicationProperties.field.SystemServicesMonitor.interval', @value = '5000', @reloadable = 1, @validator = 'cz.aimtec.dci.action.jmesa.validators.PositiveOrZeroIntegerValueValidator', @groupName = 'SystemServicesMonitor'

-- Stocktaking transaction definitions
exec dciowner.addApplicationProperty @code = 'stocktaking.transaction.release', @externalCode = 'stocktaking.transaction', @value = 'INV_020', @intoCurrentDB = 1, @reloadable = 1, @validator = null, @groupName = 'Stocktaking', @decorator = null, @defaultValueOnly = 1
exec dciowner.addApplicationProperty @code = 'stocktaking.transaction.finish', @externalCode = 'stocktaking.transaction', @value = 'INV_100', @intoCurrentDB = 1, @reloadable = 1, @validator = null, @groupName = 'Stocktaking', @decorator = null, @defaultValueOnly = 1
exec dciowner.addApplicationProperty @code = 'stocktaking.transaction.cancel', @externalCode = 'stocktaking.transaction', @value = 'INV_110', @intoCurrentDB = 1, @reloadable = 1, @validator = null, @groupName = 'Stocktaking', @decorator = null, @defaultValueOnly = 1
