﻿(function (global, $) {

    /**
     * Namespace initialization.
     */
    var ns = global.cz.aimtec.dci.utils.initializeNamespace('cz.aimtec.dci.window');
    
    var utilsSpace = cz.aimtec.dci.utils;
    var utilsDialogSpace = utilsSpace.initializeNamespace('cz.aimtec.dci.utils.dialog');
    var formSpace = utilsSpace.initializeNamespace('cz.aimtec.dci.form');
    var leftMenuSpace = utilsSpace.initializeNamespace('cz.aimtec.dci.left.menu');
    var desktopSpace = utilsSpace.initializeNamespace('cz.aimtec.dci.desktop');
    var windowContentSpace = utilsSpace.initializeNamespace('cz.aimtec.dci.window.content');
    var windowUtilsSpace = utilsSpace.initializeNamespace('cz.aimtec.dci.window.utils');
    var jmesaSpace = utilsSpace.initializeNamespace('cz.aimtec.dci.jmesa');
    var webUtilsNs = utilsSpace.initializeNamespace('cz.aimtec.dci.web.utils');
    var appResourcesSpace = cz.aimtec.dci.appResources;
    var modalWindowNs;

    var windowToRemoveId = null;
    var closingType = null;
   
    require(['cz.aimtec.dci.window.modalWindow'], function() {
    	modalWindowNs = cz.aimtec.dci.window.modalWindow;
    });
    
    var ACTIVE_WINDOW_HEIGHT_VALUE = 60;
    var ACTIVE_WINDOW_WIDTH_VALUE = 40;
    var ACTIVE_WINDOW_MIN_HEIGHT = 60;
    var ACTIVE_WINDOW_MIN_WIDTH = 300;
    ns.Z_INDEX = {
    		ACTIVE_WINDOW_LOW 			: 10,
    		ACTIVE_WINDOW_HIGH 			: 100,
    		MODAL_WINDOW	 			: 1002,
    		MODAL_WINDOW_IN_BACKGOURND 	: 1,
    		OVERLAY 					: 1000,
		    PROGRESS_BAR_OVERLAY 		: 1010,
		    FULLTEXT_AUTOCOMPLETE		: 1000
    };
    var MAX_COUNT_OF_WINDOWS = 10;
    var MINIMIZED_WINDOW_SPACE = 10;
    var MINIMIZED_WINDOW_SPACE_FROM_DESKTOP = 20;
    var MINIMIZED_WINDOW_WIDTH = 150;
    var MINIMIZED_WINDOW_SPACE_FROM_LEFT_MENU = 30;
    var MAXIMIZED_WINDOW_NULL_LEFT_POSITION = 0;
    var MAXIMIZED_WINDOW_NULL_TOP_POSITION = 0;
    var MODAL_WINDOW_CONTENT_WINDOW_WIDTH = 20;
    var MIN_WINDOW_ANIMATION_SPEED = 'slow'; 
    var MODAL_WINDOW_MARGIN_FROM_BROSWER_WINDOW = 100;
    var MODAL_WINDOW_WIDTH_MARGIN_FROM_BROSWER_WINDOW = 150;
    var MODAL_WINDOW_HEIGHT_MARGIN_FROM_BROSWER_WINDOW = 100;
    var DOCUMENTATION_ICON_HOVER_NAME = 'documentationWindowHover.png';
    var CLOSING_TYPE_MAX_WINDOW = 'max_w';
    var CLOSING_TYPE_CLOSE = 'close';
    ns.WINDOW_IS_MINIMIZED = 1;
    ns.WINDOW_IS_NOT_MINIMIZED = 0;
    ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT = 10;
    ns.ATTR_WINDOW_HAS_FOCUS = '_dci_windowhasfocus';
    ns.ATTR_MIN_WINDOW_SEQUENCE = '_dci_minimizedWindowSequence';
    ns.ATTR_WINDOW_POSITION_X = '_dci_positionx';
    ns.ATTR_WINDOW_POSITION_Y = '_dci_positiony';
    ns.ATTR_WINDOW_WIDTH = '_dci_windowwidth';
    ns.ATTR_WINDOW_HEIGHT = '_dci_windowheight';
    ns.ATTR_CONTENT_WINDOW_HEIGHT = '_dci_contentwindowheight';
    ns.ATTR_WINDOW_ID = '_dci_windowid';
    ns.ATTR_WINDOW_IS_MINIMIZED = '_dci_isMinimized';
    ns.ATTR_WINDOW_Z_INDEX = '_dci_zindex';
    ns.ATTR_WINDOW_ELEMENT_WITH_FOCUS = '_dci_elementwithfocus';
    ns.ATTR_SHOW_WINDOW_CLOSE_DIALOG = '_dci_showwindowclosedialog';
    ns.ATTR_SHOW_MAX_WINDOW_DIALOG = '_dci_showMaxWindowDialog';
    ns.BUTTON_TAG_NAME = 'BUTTON';
    ns.ATTR_IS_COLLECTION_SETTINGS_HIDDEN = '_dci_iscollectionsettingshidden';
    ns.ATTR_WINDOW_IS_NOT_MODAL = '_dci_isnotmodal';
    ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT = 25;
    ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH = 30;
    ns.ATTR_PARENT_WINDOW_ID = '_dci_parentwindowid';
    ns.MODAL_WINDOW_TITLE_MAX_TEXT_LENGHT = 80;
    var BORDER_SHADOW = {
    		ACTIVE_WINDOW_LOW 			: 'activeWindowLow',
    		ACTIVE_WINDOW_HIGH 			: 'activeWindowHigh'
    };
    var MODAL_WINDOW_TITLE_MAX_TEXT_LENGHT = 80;
    ns.MODAL_WINDOW_CONTENT_MARGIN_FROM_WINDOW = 20;
    var MODAL_WINDOW_CONTENT_MARGIN_FROM_WINDOW_MES = 30;
    var MODAL_WINDOW_MES_BOTTOM_MARGIN = 5;
    var MODAL_WINDOW_OPENED_EVENT = 'modalWindowOpened';
    var JMESA_UNSAVED_CHANGES_CLASSES = '.wsColumnChange, .wsColumnError';
    var AUTOMATIC_SIZE = -1;

    /**
     * Save info about position and size to attributes of element given by parameter.
     * 
     * @param pWindow window element
     * 
     * @returns pWindow window element with attributes
     */
    ns.saveWindowPropertiesToAttributes = function (pWindow, pIsMinimized) {
        pWindow.attr(ns.ATTR_WINDOW_POSITION_X, pWindow.position().left);
        pWindow.attr(ns.ATTR_WINDOW_POSITION_Y, pWindow.position().top);
        pWindow.attr(ns.ATTR_WINDOW_WIDTH, pWindow.width());
        pWindow.attr(ns.ATTR_WINDOW_HEIGHT, pWindow.height());
        pWindow.attr(ns.ATTR_CONTENT_WINDOW_HEIGHT, pWindow.children('.activeWindowContent').height());
        pWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED , pIsMinimized);
        return pWindow;
    };
    
    /**
     * Set window element size and position.
     * 
     * @param pWindow window element
     * 
     */
    ns.setWindowSizeAndPositionsFromAttributes = function (pWindow) {
        pWindow.css('left', pWindow.attr(ns.ATTR_WINDOW_POSITION_X) + 'px');
        pWindow.css('top', pWindow.attr(ns.ATTR_WINDOW_POSITION_Y) + 'px');
        pWindow.css('width', pWindow.attr(ns.ATTR_WINDOW_WIDTH));
        pWindow.css('height', pWindow.attr(ns.ATTR_WINDOW_HEIGHT));
        pWindow.children('.activeWindowContent').css('height', pWindow.attr(ns.ATTR_CONTENT_WINDOW_HEIGHT));
        pWindow.children('.activeWindowContent').css('width', pWindow.attr(ns.ATTR_WINDOW_WIDTH) - ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH);
        pWindow.draggable({ disabled: false });
        pWindow.resizable({ disabled: false });
    };
    
    
    /**
     * Change window position, size given by parameter window object.
     * 
     * @param pWindowO window object
     * 
     *          needed attributes
     * 
     *          pWindow.windowId - window id
     *          pWindow.menuId - menu id from left menu, window was created from this menu item
     *          pWindow.positionX - window left position
     *          pWindow.positionY - window top position
     *          pWindow.width - window width
     *          pWindow.height - window height
     *          pWindow.isMinimized - 1 - minimized window, 0 - opened window 
     *          pWindow.isCollectionSettingsHidden - 1 hidden, 0- visible 
     *          zIndex - window z-index
     * 
     *          
     */
    ns.moveWindow = function (pWindow) {
        $.ajax({
            type: 'POST',
            url : 'changeActiveWindows.do',
            data : {
                action : 'moveWindow',
                windowId : pWindow.windowId,
                menuId : pWindow.menuId,
                positionX :pWindow.positionX,
                positionY :pWindow.positionY,
                width: pWindow.width,
                height: pWindow.height,
                isMinimized: pWindow.isMinimized,
                isCollectionSettingsHidden : pWindow.isCollectionSettingsHidden,
                zIndex : pWindow.zIndex,
                ajaxCall : true
            }
        }); 
        
    };
    
    
    
    /**
     * Create new minimized icon.
     *  
     * @param pMinimizedIcon minimized icon object
     * 
     *          needed attributes
     * 
     *          pMinimizedIcon.src - icon image src
     *          pMinimizedIcon.text - wrapped text 
     *          pMinimizedIcon.longText - text
     *          pMinimizedIcon.id - id
     *          pMinimizedIcon.sequence - text
     * 
     * @return minimized window icon element 
     */
    ns.createMinimizedWindowIcon = 
        function(pMinimizedIcon) {
                return ($("<div/>", {
                    id : 'minimizedWindow' + pMinimizedIcon.id,
                    _dci_minimizedWindowSequence : pMinimizedIcon.sequence,
                    _dci_windowid : pMinimizedIcon.id,
                    _dci_isminimized : 0,
                    "class" : 'minimizedWindow'
                }).append($("<div/>", {
                    "class" : 'removeIconActive'
                })).append($("<div/>", {
                    "class" : 'iconTextActiveWindow',
                    text : pMinimizedIcon.text,
                    title : pMinimizedIcon.longText
                })));
    };
    
    
    /**
     * Create new window.
     * 
     * @param pWindowObject window object
     * 
     *          needed attributes
     * 
     *          pWindowObject.title - window title
     *          pWindowObject.menuId - menu id from left menu, window was created from this item
     *          pWindowObject.url - window url - in most cases struts action url
     *          pWindowObject.src - window image icon src
     * 
     * @param pPath path in url
     * @param pRewriteExistingWindow true or false
     * @param pCompleteFuntion pointer to function which will be execute in new window
     * @param pCompleteFuntionParams pCompleteFuntion params
     */
    ns.createWindow = function(pWindowObject, pPath, pRewriteExistingWindow, windowsCount, pCompleteFuntion, pCompleteFuntionParams) {
     
        var windowWithThisMenuId = $('.activeWindowContent[_dci_menukey = "' + pWindowObject.menuKey + '"]');
        var windowId = null;
        var rewriteExistingWindow = pRewriteExistingWindow || false;

        // ----- Window with this menuid has already opened - set window to top
        if (windowWithThisMenuId.length > 0) {
            windowId = windowWithThisMenuId.parent().attr(ns.ATTR_WINDOW_ID);
            if ($('#activeWindow' + windowId).attr(ns.ATTR_WINDOW_IS_MINIMIZED ) === ns.WINDOW_IS_NOT_MINIMIZED) {
                ns.setCurrentWindowToTop(windowId, true);
                
            } else {
                ns.restoreWindowFromMinimized(windowId);
            }
            
            // ----- execute defined function in this window
            if (pCompleteFuntion) {
        		pCompleteFuntion('#activeWindow' + windowId, pCompleteFuntionParams);
        	}
            
            return;
        }

        // If number of windows is not specified, it is computed.
        if (!windowsCount) {
            windowsCount = $('div.activeWindowDiv').find('div.activeWindowContent').length;
            windowsCount++;
        }
        
        var exceededWindowsCount = windowsCount - MAX_COUNT_OF_WINDOWS;
        
        // If max count of windows is exceeded, currently opened window is closed. 
        if(exceededWindowsCount > 0) {
        	
        	// Identify window
        	var currentWindow = windowUtilsSpace.getCurrentWindow();
        	windowToRemoveId = currentWindow.attr(ns.ATTR_WINDOW_ID);
        	if (!windowToRemoveId) {
        		// If windowId from getCurrentWindow() is undefined, last window in DOM is selected instead.
        		var minWin = document.querySelectorAll('#minimizedWindows .minimizedWindow');
        		if(minWin && minWin[minWin.length - 1]) {
        			currentWindow = minWin[minWin.length - 1];
            		windowToRemoveId = currentWindow.getAttribute(ns.ATTR_WINDOW_ID);
        		}
            }
            
            var dialogMaxWindow = $('#dialogMaxWindow');
            dialogMaxWindow.data('windowsCount', windowsCount);
            dialogMaxWindow.data('windowToOpen', pWindowObject);
            closingType = CLOSING_TYPE_MAX_WINDOW;
            var windowWasClosed = closeWindowWithCheck(windowToRemoveId);
        }
        
        if ( (exceededWindowsCount <= 0) || (exceededWindowsCount <= 1 && windowWasClosed) ) {
        	if (!rewriteExistingWindow || windowsCount === 1) {
        		// ----- create window element 
        		$('#desktop').append($("<div class='activeWindowDiv'/>", {
        		}).append($("<div class='windowTitlebar' title='" + pWindowObject.title + "'/>", {
        		}).append($("<div class='windowTitle'> ", {
        			text : pWindowObject.title
        		})).append($("<div class='closeWindow windowIcon'/> ", {
        		})).append($("<div class='maximizeWindow windowIcon'/>", {})).append($("<div class='extendWindow windowIcon'/><div class='minimizeWindow windowIcon'/><div class='documentationWindow windowIcon' onclick='cz.aimtec.dci.window.openDocumentationWindow(this)'/>", {
        		}))).append($("<div class='activeWindowContent' src='" + pPath + pWindowObject.url+"' _dci_menuid='"+pWindowObject.menuId+"' _dci_menukey='" + pWindowObject.menuKey + "' _dci_srcbig='"+pWindowObject.src+"' _dci_isMinimized='"+0+"'/>", {
        		})));
            
            // ----- add new window to db and get window id from db
            $.ajax({
                async : false,
                dataType: 'json',
                url : 'changeActiveWindows.do',
                type : 'POST',
                data : {
                    action : 'addWindow',
                    menuKey : pWindowObject.menuKey,
                    ajaxCall : true
                },
                error : function(data, textSatus, errorThrown) {
                    if (utilsSpace.handleUserLogging(data.responseText));
                    utilsDialogSpace.showError(data, textSatus, errorThrown);
                },
                success: function(data) {
                         windowId = data.windowId;
                         var activeWindow = $('#desktop .activeWindowDiv:last');
                         var activeWindowContent = $('#desktop .activeWindowContent:last');
                         
                         // ----- change window id with id from db
                         activeWindow.attr('id', 'activeWindow' + windowId);  
                         activeWindow.attr(ns.ATTR_SHOW_WINDOW_CLOSE_DIALOG, data.showWindowCloseDialog);
                         activeWindow.attr(ns.ATTR_SHOW_MAX_WINDOW_DIALOG, data.showMaxWindowDialog);
                         activeWindowContent.attr('id', 'activeWindowContent' + windowId);  
                         
                        $.ajax({
                            url : pPath + pWindowObject.url + utilsSpace.AJAX_CALL_URL_PARAM,
                            type : 'POST',
                            beforeSend: utilsSpace.showProgressIndicator,
                            error : function (response, textSatus, errorThrown) {
                                utilsDialogSpace.showError(response, textSatus, errorThrown, activeWindow);
                                ns.closeWindow(windowId);
                            }, 
                            success : function(data) {
                            	    var scripts = ns.loadJavaScripts(data);
                                    ns.loadStyles(data, 'activeWindow' + windowId);
                                    // ----- load scripts needed by page
                                    require(scripts, function() {
                                    	// ----- set data from server to window
                                    	activeWindowContent.html(data);                           
                                    	
                                    	// ----- set window size
                                    	activeWindowContent.css('height', $('#desktop').height() - ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT);
                                    	activeWindowContent.css('width', $('#desktop').width() - ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH);
                                    	activeWindow.css('height', $('#desktop').height());
                                    	activeWindow.css('width', $('#desktop').width());    
                                    	activeWindow.css('top', activeWindow.position().top);
                                    	activeWindow.css('left',activeWindow.position().left);  
                                    	
                                    	// ---- set window draggable and resizable
                                    	ns.setWindowResizable(windowId);
                                    	ns.setWindowDraggable(windowId);
                                    	
                                    	// ---- set attributes
                                    	activeWindow.attr(ns.ATTR_WINDOW_ID, windowId);
                                    	activeWindow.attr('src', activeWindowContent.height() - ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT);
                                    	activeWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED , 0);   
                                    	activeWindow.attr(ns.ATTR_IS_COLLECTION_SETTINGS_HIDDEN , false);  
                                    	ns.saveWindowPropertiesToAttributes(activeWindow, ns.WINDOW_IS_NOT_MINIMIZED);
                                    	ns.saveWindowChangeToDb(windowId);
                                    	ns.setCurrentWindowToTop(windowId, true);
                                    	
                                    	var activeWindowId = 'activeWindow' + windowId;
                                    	// ----- set window title
                                    	var moduleCode = ns.getModuleCode(activeWindowId);  
 										var windowName = ns.getWindowName(activeWindowId);       
	                                 	activeWindow.find('.windowTitle').text(webUtilsNs.addEnvironmentName(windowName + ' ('  + moduleCode + ')'));  
	                                 	
                                    	// set focus
                                        var firstInput = webUtilsNs.getFirstNotHiddenInputInWindow(activeWindowId);   		   	
                                    	firstInput.focus();
                                    	activeWindow.attr(ns.ATTR_WINDOW_ELEMENT_WITH_FOCUS, firstInput.attr('name'));   
                                    	
                                    	// ----- set inputs width
                                    	ns.setInputsWidthInWindow(activeWindowId);
                                    	ns.disableClickOnSortableColumn();
                                    	      	
                                    	// ----- move windows in taskbar
                                    	var newWindow = $('#desktop .activeWindowDiv:last');
                                    	// ----- new window is always number 0 in sequence
                                    	newWindow.attr(ns.ATTR_MIN_WINDOW_SEQUENCE, 0);
                                    	
								        var minimizedIcon = {};
								        minimizedIcon.longText = pWindowObject.title;
								        minimizedIcon.text = webUtilsNs.wrapText(minimizedIcon.longText, webUtilsNs.MAX_CHARS_ON_ROW, webUtilsNs.MAX_COUNT_OF_ROWS);
								        minimizedIcon.id = windowId;
								        minimizedIcon.sequence = 0;
							       		minimizedIcon.src = newWindow.children('.activeWindowContent').attr('_dci_srcbig');
                                    	
                                    	// ----- add to taskbar
                                    	// ----- compute position for first window
                                    	var positionX = parseInt($('#menuLeft').width()) + parseInt($('#hideLeftMenu').width());
                                    	if (parseInt($('#menuLeft').css('margin-left')) < 0) {
                                    		positionX = Math.round(MINIMIZED_WINDOW_SPACE + 20);
                                    	}
                                    	var positionY = parseInt($('.topMenu').height()) + parseInt($('#desktop').height()) + MINIMIZED_WINDOW_SPACE_FROM_DESKTOP;
                                    	
                                    	var minimizedWindow = ns.createMinimizedWindowIcon(minimizedIcon);
                                    	$(minimizedWindow).appendTo('#minimizedWindows');
                                    	minimizedWindow.css('position', 'absolute').css('left', positionX).css('top', positionY);
                                    	minimizedWindow.attr(ns.ATTR_WINDOW_HAS_FOCUS, true);
                                    	minimizedWindow.attr('_dci_menuid', pWindowObject.menuId);              
                                    	minimizedWindow.draggable(leftMenuSpace.dragFromMinimizedWindowsOptions);
                                    	
							        	ns.sortMinimizedWindows(true);
							        	ns.saveMinimizedWindows();
							
                                    	// Set an orange [?] if documentation exists for this window 
                                    	if (activeWindow.find('.docExists').length > 0) {
                                    		activeWindow.find('.documentationWindow').switchClass('documentationWindow', 'documentationExistsWindow');
                                    	}
                                    	
                                    // ----- execute defined function in this window
                                    if (pCompleteFuntion) {
                                        pCompleteFuntion('#' + activeWindowId, pCompleteFuntionParams);
                                    }
                                    	
                                    	utilsSpace.hideProgressIndicator();
                                    });

                                    }
                        });
                }
            }); 
        
        	} else {
        		
                    	$.ajax({
                    		url : pPath + pWindowObject.url + utilsSpace.AJAX_CALL_URL_PARAM,
                    		type : 'POST',
                    		beforeSend: utilsSpace.showProgressIndicator,
                    		error : function (response, textSatus, errorThrown) {
                    			utilsDialogSpace.showError(response, textSatus, errorThrown, activeWindow);
                    			ns.closeWindow(windowId);
                    		}, 
                    		success : function(data) {
                    			
                    			var activeWindow = $('#desktop .activeWindowDiv:last');
                    			var activeWindowContent = $('#desktop .activeWindowContent:last');   
                    			var windowId = activeWindow.attr(ns.ATTR_WINDOW_ID);
                    			
                    			activeWindow.find('div.windowTitlebar').attr('title', pWindowObject.title);
                    			activeWindow.find('div.windowTitle').text(pWindowObject.title);
                    			
                    			activeWindowContent.attr('src', pPath + pWindowObject.url);
                    			activeWindowContent.attr('title', pWindowObject.title);
                    			activeWindowContent.attr('_dci_menukey', pWindowObject.menuKey);
                    			activeWindowContent.attr('_dci_menuid', pWindowObject.menuId);
                    			activeWindowContent.attr('_dci_srcbig', pWindowObject.src);
                    			
                    			var scripts = ns.loadJavaScripts(data);
                    			ns.loadStyles(data, 'activeWindow' + windowId);
                    			// ----- load scripts needed by page
                    			require(scripts, function() {
                    				// ----- set data from server to window
                    				activeWindowContent.html(data);                           
                    				
                    				// ---- set attributes
                    				activeWindow.attr('src', activeWindowContent.height() - ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT);
                    				
                    				var activeWindowId = 'activeWindow' + windowId;
                    				// ----- set window title
                    				var moduleCode = ns.getModuleCode(activeWindowId);  
                    				var windowName = ns.getWindowName(activeWindowId);       
                    				activeWindow.find('.windowTitle').text(webUtilsNs.addEnvironmentName(windowName + ' ('  + moduleCode + ')'));  
                    				
                    				var minimizedWindow = $('#minimizedWindow' + windowId).find('div.iconTextActiveWindow');
                    				minimizedWindow.attr('title', windowName);
                    				minimizedWindow.text(windowName);
                    				
                    				// set focus
                    				var firstInput = webUtilsNs.getFirstNotHiddenInputInWindow(activeWindowId);   		   	
                    				firstInput.focus();
                    				activeWindow.attr(ns.ATTR_WINDOW_ELEMENT_WITH_FOCUS, firstInput.attr('name'));   
                    				
                    				// ----- set inputs width
                    				ns.setInputsWidthInWindow(activeWindowId);
                    				ns.disableClickOnSortableColumn();
                    				
                    				// Set an orange [?] if documentation exists for this window 
                    				if (activeWindow.find('.docExists').length > 0) {
                    					activeWindow.find('.documentationWindow').switchClass('documentationWindow', 'documentationExistsWindow');
                    				}
                    				
                    				utilsSpace.hideProgressIndicator();
                    			});
                    			
                    		}
                    	});
                    	
        		
        	}
        } 
    };
    
     ns.createSingleWindow = function(pWindowObject, pPath) {
            // ----- rewrite current window with new content
            if ($('.activeWindowDiv').attr('_dci_singlewindow')) {
                    $.ajax({
                        url : pPath + pWindowObject.url + utilsSpace.AJAX_CALL_URL_PARAM,
                        type : 'POST',
                        beforeSend: utilsSpace.showProgressIndicator,
                        complete : utilsSpace.hideProgressIndicator,  
                        success : function(data) {
                            if (utilsSpace.handleUserLogging(data)) {
                            	var activeWindowId = 'activeWindow1';
                            	
                            	ns.loadStyles(data, activeWindowId);
                            	
                				// ----- load scripts needed by page
                				require(ns.loadJavaScripts(data), function() {
                					var activeWindowContent = $('#activeWindowContent' + 1);
	                                activeWindowContent.html(data);                           
	                                // ----- set content size
	                                activeWindowContent.css('height', $('#desktop').height() - ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT);
	                                activeWindowContent.css('width', $('#desktop').width() - ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH);
	                                
	                                var activeWindow = $('#activeWindow' + 1);
	                                activeWindow.css('height', $('#desktop').height());
	                                activeWindow.css('width', $('#desktop').width());  
	                                activeWindow.attr('_dci_windowid', 1)
	                                
	                                ns.setWindowResizable(1);
	                                ns.setWindowDraggable(1);
	                                
	                                // ----- set window title
                                	var moduleCode = ns.getModuleCode(activeWindowId);  
									var windowName = ns.getWindowName(activeWindowId);       
                                 	activeWindow.find('.windowTitle').text(webUtilsNs.addEnvironmentName(windowName + ' ('  + moduleCode + ')'));  
	                              
	                                activeWindow.attr(ns.ATTR_WINDOW_ID, 1);
	                                activeWindow.attr(ns.ATTR_CONTENT_WINDOW_HEIGHT, activeWindowContent.height() - ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT);
	                                activeWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED , 0);       
	                                activeWindow.attr(ns.ATTR_IS_COLLECTION_SETTINGS_HIDDEN , 'false');  
	                                 
	                                // refresh info in attributes 
	                                activeWindowContent.attr('src', pPath + pWindowObject.url); 
	                                activeWindowContent.attr('_dci_menuid', pWindowObject.menuId); 
	                                activeWindowContent.attr('title', pWindowObject.title); 
	                                activeWindowContent.attr('_dci_srcbig',pWindowObject.src); 
	                                
	                                 ns.saveWindowPropertiesToAttributes($('#activeWindow' + 1), ns.WINDOW_IS_NOT_MINIMIZED);
	                                 ns.saveWindowChangeToDb(1);
	                                 ns.setCurrentWindowToTop(1, true);	
	                                 
	                                 // close dialog after window refresh
	                                 $('#dialog-form-activeWindow1').dialog('close');
                				});
                            }

                        }
                    });
            }
            
            else {
	            // ----- create window element 
	            $('#desktop').append($("<div id='activeWindow" + 1 + "' class='activeWindowDiv' _dci_singlewindow='true'/>", {
	            }).append($("<div class='windowTitlebar'/>", {
	            }).append($("<div class='windowTitle'> ", {
	                text : pWindowObject.title
	            })).append($("<div class='closeWindow windowIcon'/> ", {
	            })).append($("<div class='extendWindow windowIcon'/><div class='maximizeWindow windowIcon'/><div class='minimizeWindow windowIcon'/> <div class='documentationWindow windowIcon' onclick='cz.aimtec.dci.window.openDocumentationWindow(this)'/>", {}))).append($("<div id='activeWindowContent"+ 1 + "' class='activeWindowContent' src='" + pPath + pWindowObject.url+"' +  _dci_menuid='"+pWindowObject.menuId+"' title='"+pWindowObject.title+"' _dci_srcbig='"+pWindowObject.src+"' _dci_isMinimized='"+0+"'/>", {
	            })));
	            
	            
	            ns.loadContent(pWindowObject, pPath);
                
            }
      };
     
    
      /**
       * Load window content by AJAX call.
       * 
       * @param	pWindowObject - window object
       * 
       * @param	pPath - application path
       * 
       */
      ns.loadContent = function (pWindowObject, pPath) {
          
    	  $.ajax({
              url : pPath + pWindowObject.url + utilsSpace.AJAX_CALL_URL_PARAM,
              type : 'POST',
              beforeSend: utilsSpace.showProgressIndicator,
              complete : utilsSpace.hideProgressIndicator,  
              error: utilsDialogSpace.showError,
              success : function(data) {
                  if (utilsSpace.handleUserLogging(data)) {
                	  var activeWindowId = 'activeWindow1';
                	  
                	    var scripts = ns.loadJavaScripts(data);
                        ns.loadStyles(data, activeWindowId);
                       
                        // ----- load scripts needed by page
                        require(scripts, function() {
                        	
                        	var activeWindowContent = $('#activeWindowContent' + 1);
                            activeWindowContent.html(data);                           
                         
                            // ----- set content size
                            activeWindowContent.css('height', $('#desktop').height() - ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT);
                            activeWindowContent.css('width', $('#desktop').width() - ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH);
                            
                            var activeWindow = $('#activeWindow' + 1);
                            activeWindow.css('height', $('#desktop').height());
                            activeWindow.css('width', $('#desktop').width());   
                            
                           	// ----- set window title
                        	var moduleCode = ns.getModuleCode(activeWindowId);  
							var windowName = ns.getWindowName(activeWindowId);       
                         	activeWindow.find('.windowTitle').text(webUtilsNs.addEnvironmentName(windowName + ' ('  + moduleCode + ')'));  
                            
                            ns.setWindowResizable(1);
                            ns.setWindowDraggable(1);
                          
                            activeWindow.attr(ns.ATTR_WINDOW_ID, 1);
                            activeWindow.attr(ns.ATTR_CONTENT_WINDOW_HEIGHT, activeWindowContent.height() - ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT);
                            activeWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED , 0);       
                            
                            if (jmesaSpace.initializeAllComponentsForJMesa) {
                            	var moduleCode = windowUtilsSpace.getModuleCodeByWindowId(activeWindowId);
                            	jmesaSpace.initializeAllComponentsForJMesa(moduleCode);
							}
                            
                            ns.saveWindowPropertiesToAttributes($('#activeWindow' + 1), ns.WINDOW_IS_NOT_MINIMIZED);
                            ns.saveWindowChangeToDb(1);
                            ns.setCurrentWindowToTop(1, true);
                        	
                        });
                	  
                  }
              }
          });
    	  
      };
      
      
    
    /**
     * Set window resizable by mouse.
     * 
     */
    ns.setWindowResizable = function (pWindowId) {
        $('#activeWindow' + pWindowId).resizable({ 
            // ------ Set containment document for resizable because of problem in zoomed page when body is set.
            containment : '#windowsDesktop',
            handles : 'n, e, s, w, se',
            alsoResize: $('#activeWindowContent' + pWindowId),
            minHeight: ACTIVE_WINDOW_MIN_HEIGHT,
            minWidth: ACTIVE_WINDOW_MIN_WIDTH,
            maxWidth: $('#windowsDesktop').width(),
            start : function() {
                ns.setCurrentWindowToTop(pWindowId, true);    
            },
            stop : function() {         
                ns.saveWindowChangeToDb(pWindowId);
                ns.saveWindowPropertiesToAttributes($('#activeWindow' + pWindowId), ns.WINDOW_IS_NOT_MINIMIZED);
                $('#activeWindow' + pWindowId).attr(ns.ATTR_CONTENT_WINDOW_HEIGHT, $('#activeWindowContent' + pWindowId).height() - ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT);
            }
        });
    };
    
    
    /**
     * Set window draggable by mouse.
     */
    ns.setWindowDraggable = function (pWindowId) {
        var currentWindow = $('#activeWindow' + pWindowId);
        currentWindow.draggable({
            handle: ('.windowTitlebar'), 
            containment: '#windowsDesktop',
            start : function() {                    
                ns.setCurrentWindowToTop(pWindowId, true);
            },
            stop : function() {         
            	if (currentWindow.attr('_dci_extended') == 'true') {
            		currentWindow.attr('_dci_extended', 'false');
            	}
                ns.saveWindowPropertiesToAttributes($('#activeWindow' + pWindowId), ns.WINDOW_IS_NOT_MINIMIZED);
                ns.saveWindowChangeToDb(pWindowId);
            }   
        });
        
    };
    
    /**
     * Set window given by window id to top of active windows.
     * 
     * @param pWindowId window id
     * 
     * @param pSetFocus true or false 
     *                  set focus to element in window attribute
     *                  must be false for restoring window from minimized 
     *                  because of animation
     *
     * @param pReloadContextMenu true or false or null
     *                           If value is set to true, then function to reload contextMenu is always called
     * 
     */
    ns.setCurrentWindowToTop = function (pWindowId, pSetFocus, pReloadContextMenu) {
        var currentActiveWindow = $('.activeWindowDiv[_dci_windowhasfocus="true"]');
        var activeWindow = $('#activeWindow' + pWindowId);
        var minimizedWindow = $('#minimizedWindow' + pWindowId);

        //
        // handle z-index
        //

        if (parseInt(activeWindow.attr(ns.ATTR_WINDOW_Z_INDEX)) !== ns.Z_INDEX.ACTIVE_WINDOW_HIGH) {

            activeWindow.attr(ns.ATTR_WINDOW_Z_INDEX, ns.Z_INDEX.ACTIVE_WINDOW_HIGH);
            activeWindow.css('z-index', ns.Z_INDEX.ACTIVE_WINDOW_HIGH);
            activeWindow.addClass(BORDER_SHADOW.ACTIVE_WINDOW_HIGH);
            activeWindow.removeClass(BORDER_SHADOW.ACTIVE_WINDOW_LOW);

            //
            // set low z-index to other windows
            //

            var activeWindowId = parseInt(pWindowId);
            var zIndexesArray = [];

            $('.activeWindowDiv').each(function() {

                var element = $(this);

                if (parseInt(element.attr(ns.ATTR_WINDOW_ID)) !== activeWindowId) {

                    element.attr(ns.ATTR_WINDOW_Z_INDEX, ns.Z_INDEX.ACTIVE_WINDOW_LOW);
                    element.css('z-index', ns.Z_INDEX.ACTIVE_WINDOW_LOW);
                    element.addClass(BORDER_SHADOW.ACTIVE_WINDOW_LOW);
                    element.removeClass(BORDER_SHADOW.ACTIVE_WINDOW_HIGH);
                }

                var zIndexesItem = {};
                zIndexesItem.windowId = element.attr(ns.ATTR_WINDOW_ID);
                zIndexesItem.zIndex = element.attr(ns.ATTR_WINDOW_Z_INDEX);
                zIndexesArray.push(zIndexesItem);
            });

            ns.saveChangesToDb(zIndexesArray);
        }

        //
        // handle focus
        //

        ns.removeHasFocusAttributeFromAllWindows();
        activeWindow.attr(ns.ATTR_WINDOW_HAS_FOCUS, true);
        minimizedWindow.attr(ns.ATTR_WINDOW_HAS_FOCUS, true);

        if (pSetFocus === true) {
            activeWindow.find('.activeWindowContent').find('*[name="' + activeWindow.attr(ns.ATTR_WINDOW_ELEMENT_WITH_FOCUS) + '"]').focus();
        }

        var elementWithFocus = activeWindow.find('*:focus');

        // don't keep focus for buttons
        if (elementWithFocus.tagName !== ns.BUTTON_TAG_NAME) {
            activeWindow.attr(ns.ATTR_WINDOW_ELEMENT_WITH_FOCUS, elementWithFocus.attr('name'));
        }

        // Handle change of context menu
        require(['cz.aimtec.dci.contextMenu'], function(context) {
            if (pReloadContextMenu) {
                context.initialize(true);
            } else if (currentActiveWindow.length == 1) {
                var currentActiveWindowId = currentActiveWindow.attr("_dci_windowid");
                if (currentActiveWindowId != pWindowId) {
                    context.initialize(true);
                }
            }
        })
    };


    /**
     * Save window given by window id attributes to db.
     * 
     * @param pWindowId window id
     */
    ns.saveWindowChangeToDb = function (pWindowId) {
        var window = {};
        var currentWindow = $('#activeWindow' + pWindowId);
        window.windowId = currentWindow.attr(ns.ATTR_WINDOW_ID);
        window.menuId = currentWindow.children('.activeWindowContent').attr('_dci_menuid');
        window.positionX = Math.round(currentWindow.position().left);
        window.positionY = Math.round(currentWindow.position().top);
        window.width = Math.round(currentWindow.width());      
        window.height = Math.round(currentWindow.height());    
        window.isMinimized = currentWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED);
        window.isCollectionSettingsHidden = currentWindow.attr(ns.ATTR_IS_COLLECTION_SETTINGS_HIDDEN);
        window.zIndex = currentWindow.attr(ns.ATTR_WINDOW_Z_INDEX);
        ns.moveWindow(window);
    };
    
    
    var element = null;
    /**
     * Show confirm dialog after click on close minimized window. 
     * 
     * If dialog is confirm, close window and move active windows. 
     * 
     * Else close dialog.
     */
    $(document).on('click', '.removeIconActive',
        function (event) {
            element = $(event.currentTarget);

            // ----- fixed bug when user confirm dialog by enter and then quickly click on another remove element
            if (!element.hasClass('nonclick')) {
                // ----- get windows which will be removed          
                windowToRemoveId = element.parent().attr(ns.ATTR_WINDOW_ID);
                closingType = CLOSING_TYPE_CLOSE;
                closeWindowWithCheck(windowToRemoveId);
            }
            return false;
        }
    );
    
    // ----- set dialog options for confirm remove active window
    ns.dialogRemoveElementWindowOptions = {
        autoOpen : false,
        show : 'blind',
        hide : 'fade',
        resizable : false,
        modal : true,
        open : function() {
            
            // ----- set elements unclickable by class
            $('#minimizedWindows .removeIconActive').each(function() {
                $(this).addClass('nonclick');
            });

        },
        close : function() {
            
            // ----- after close elements will be clickable
            $('#minimizedWindows .removeIconActive').each(function() {
                $(this).removeClass('nonclick');
            });
        },
        buttons : {
            
            // ----- close dialog, remove window, show desktop and move active windows
            yes : function() {
                ns.closeWindow(windowToRemoveId);
                $('#dialogRemoveWindow').parent('.ui-dialog').css('display', 'none');
                
                var inputShowDialog = $('#dialogRemoveWindow').find("input[name='showDialog']");
                
                $(this).dialog('close');
                
                // ------ do not show a confirmation dialog 
                if (inputShowDialog.attr('checked')) {
                	$('.activeWindowDiv').attr(ns.ATTR_SHOW_WINDOW_CLOSE_DIALOG, 'false');
                	
                	// ----- set in db
                    $.ajax({
                        type : 'POST',
                        url : utilsSpace.getBasePath() + '/saveUser.do',
                        data : {
                            action : 'changeShowDialogOption',
                            showDialog : inputShowDialog.attr('checked'),
                            ajaxCall : true
                        }
                    });
                }
            },
            
            // ----- only close dialog
            no : function() {
                $(this).dialog('close');
                $('#dialogRemoveWindow').parent('.ui-dialog').css('display', 'none');
            }
        }
    };

    function saveAndCloseJmesa() {
        var win = $('#activeWindow' + windowToRemoveId);
        var saveLink = win.find('div.jmesaContent').find('img.jmesaSaveLink');
        saveLink.click();

        setTimeout(closeWindowWithoutJmesaErrors, 1000, win);
    }

    // ----- set dialog options for confirm remove active window when window has unsaved changes in jmesa
    ns.dialogCloseUnsavedJmesaOptions = {
        autoOpen: false,
        show: 'blind',
        hide: 'fade',
        resizable: false,
        modal: true,
        buttons: {

            // ----- close dialog, save changes, remove window
            saveandclose: function () {
                saveAndCloseJmesa();
                $(this).dialog('close');
            },

            // ----- only close dialog and remove window
            close: function () {
                if (closingType === CLOSING_TYPE_MAX_WINDOW) {
                    closeExceededWindow();
                    if ($('#activeWindow' + windowToRemoveId).attr(ns.ATTR_SHOW_MAX_WINDOW_DIALOG) !== 'true') {
                        openWindowToOpen();
                    }
                } else {
                    ns.closeWindow(windowToRemoveId);
                }
                $(this).dialog('close');
            }
        }
    };
    
    // ----- set dialog options for confirm deletion of a view
    ns.dialogDeleteViewDisplaytagOptions = {
        autoOpen : false,
        show : 'blind',
        hide : 'fade',
        resizable : false,
        modal : true
    };
    
    /**
     * Closes window if window doesn't contain jmesaValidationErrors. 
     * @param jmesaWindow jQuery object of window (#activeWindow237)
     */
    function closeWindowWithoutJmesaErrors(jmesaWindow) {
        if (jmesaWindow.find('span.jmesaValidationError').length === 0) {
            if (closingType === CLOSING_TYPE_MAX_WINDOW) {
                closeExceededWindow();
                if ($('#activeWindow' + windowToRemoveId).attr(ns.ATTR_SHOW_MAX_WINDOW_DIALOG) !== 'true') {
                    openWindowToOpen();
                }
            } else {
                ns.closeWindow(windowToRemoveId);
            }
        }
    }
    
    /**
     * Close window by ID given in param.
     * 
     * Remove window element and move windows in taskbar.
     * 
     * @param pWindowToRemoveId window ID
     */
   ns.closeWindow = function(pWindowToRemoveId) {
    	var activeWindow =  $('#activeWindow' + pWindowToRemoveId);
    	var moduleCode = ns.getModuleCode('activeWindow' + pWindowToRemoveId);
    	if (moduleCode == '_SYS.SCM.10' && cz.aimtec.dci.systemServices) {
    	    cz.aimtec.dci.systemServices.closeConnection();
    	}
        var deletedSequenceNumber = $('#minimizedWindow' + pWindowToRemoveId).attr(ns.ATTR_MIN_WINDOW_SEQUENCE); 
        var windowToHighlightId = windowUtilsSpace.getNearestNotMinimzedWindowId(pWindowToRemoveId);
        var animationSpeed = webUtilsNs.showAnimation() ? 'slow' : 0;
        
        // ----- slowly remove active and minimized window
        activeWindow.hide(animationSpeed, function() {
            activeWindow.remove();

            $('#minimizedWindows .removeIconActive').each(function() {
                $(this).removeClass('nonclick');
            });
            
            ns.unloadStyles('activeWindow' + pWindowToRemoveId);
        });
        
        $('#minimizedWindow' + pWindowToRemoveId).remove(); 
        $('#desktop').show(animationSpeed);
        
        var minimizedWindowsArray = ns.updateSequnceNumbers(deletedSequenceNumber);         
        ns.sortMinimizedWindows(true);
        ns.saveChangesToDb(minimizedWindowsArray);
        
        // ------ there is sometime issue with calendar, hide calendar after closing window
        activeWindow.find(activeWindow.attr('dci_datepickerinput')).datetimepicker('hide');
        
        // ----- delete from db
        $.ajax({
            type : 'POST',
            url : 'changeActiveWindows.do',
            data : {
                action : 'removeWindow',
                windowId : pWindowToRemoveId,
                ajaxCall : true
            }
        });
        
        ns.setActualWindowHighlight(pWindowToRemoveId, windowToHighlightId);
    }
    
    /**
     * Close all opened windows.
     * 
     */
    ns.closeAllWindows = function() {
    	var openedWindows =  $(".activeWindowDiv");
    	for (var i = 0; i < openedWindows.length; i++) {
    		//TODO: check for unsaved changes or warn user about that data can be lost
    		ns.closeWindow($(openedWindows[i]).attr('_dci_windowid'));
    	}
    };
    
    /**
     * Close all opened windows.
     * 
     */
    ns.minimizeAllWindows = function() {
    	var openedWindows =  $(".activeWindowDiv");
    	for (var i = 0; i < openedWindows.length; i++) {
    		ns.minimizeWindow($(openedWindows[i]).attr(ns.ATTR_WINDOW_ID));
    	}
    };
    
    
    /**
     * Minimize window.
     * 
     * @param pWindowId window to minimize
     */
    ns.minimizeWindow = function (pWindowId) {
          
        var currentWindow = $('#activeWindow' + pWindowId);
        var minimizeWindow = $('#minimizedWindow' + pWindowId);
        
        ns.setActualWindowHighlight(pWindowId);
        
        if (parseInt(currentWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED)) === ns.WINDOW_IS_NOT_MINIMIZED) {
        	// ----- dont save size and position for maximized window
        	if (currentWindow.attr('_dci_maximized') !== 'true') {
        		ns.saveWindowPropertiesToAttributes(currentWindow, ns.WINDOW_IS_MINIMIZED);
        	} else {
        		var maximizeIcon = currentWindow.find('.windowTitlebar:first .maximizeWindow');
        		maximizeIcon.removeClass('restoreWindow');
        	}
        	
        	currentWindow.css('z-index', 0);
        	currentWindow.attr(ns.ATTR_WINDOW_Z_INDEX, 0);
        	currentWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED , 1);
        	currentWindow.removeAttr(ns.ATTR_WINDOW_HAS_FOCUS);
        	minimizeWindow.removeAttr(ns.ATTR_WINDOW_HAS_FOCUS);
        	minimizeWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED , 1);
        	
        	var minWin = $('#minimizedWindow' + pWindowId);
        	currentWindow.appendTo(minWin);
        	
        	currentWindow.css('position', 'absolute').css({
        		height : 0,
        		width : 0,
        		left : 0,
        		top : 0,
        		opacity : 0.5
        	});
        	
        	// ----- hide forms
        	currentWindow.children('.activeWindowContent').css('visibility', 'hidden').css('width', ACTIVE_WINDOW_WIDTH_VALUE).css('height', ACTIVE_WINDOW_HEIGHT_VALUE);
        	currentWindow.children('.windowTitlebar').css('display', 'none');
        	currentWindow.children('.windowTitlebar').children('.windowTitle').css('display', 'none'); 
        	currentWindow.children('.windowTitlebar').children('.windowIcon').css('visibility', 'hidden'); 
        	currentWindow.children('.ui-icon-gripsmall-diagonal-se').css('display', 'none'); 
        	
        	ns.saveWindowChangeToDb(pWindowId);
        	
        	  // ------ close calendar dialog
        	currentWindow.find(currentWindow.attr('dci_datepickerinput')).datetimepicker('destroy');
        	
        	
        }
        

        };
    
    
    /**
     * Minimize current window after click on minimize _ link.
     */
    $(document).on('click', '.minimizeWindow',
        function() {
            var windowId = $(this).parents('.activeWindowDiv:first').attr(ns.ATTR_WINDOW_ID);
            ns.minimizeWindow(windowId);             
        }
    );
    
    /**
     * Sort minimized window by sequence numbers.
     * 
     * @param pAnimation true or false
     *                   true - animate minimizing
     *                   false - dont animate minimizing
     * 
     */
    ns.sortMinimizedWindows = function(pAnimation) {
    	var animationSpeed = webUtilsNs.showAnimation() ? MIN_WINDOW_ANIMATION_SPEED : 0;
    	
    	var elements = $('#minimizedWindows .minimizedWindow');
    	var sequence = elements.size() - 1;
    	
    	elements.each(
                function() {                                                                
                    var currentElement = $(this);
					currentElement.attr(ns.ATTR_MIN_WINDOW_SEQUENCE, sequence);
					
                    var positionX = Math.round(parseInt($('#menuLeft').width()) + sequence * MINIMIZED_WINDOW_WIDTH + sequence * MINIMIZED_WINDOW_SPACE + 20);
                    var positionY = Math.round(parseInt($('.topMenu').height()) + parseInt($('#desktop').height()) + MINIMIZED_WINDOW_SPACE_FROM_DESKTOP);
                    
                    // ----- when left menu is hidden
                    if ($('#hideLeftMenu').hasClass('showMenu')) {
                        positionX = Math.round(sequence * MINIMIZED_WINDOW_WIDTH + sequence * MINIMIZED_WINDOW_SPACE + MINIMIZED_WINDOW_SPACE_FROM_LEFT_MENU);
                    }
                
                    var minimizingWindowOptions = {
                            left: positionX,
                            top: positionY,
                            duration : animationSpeed
                    };
                    
                    if (pAnimation) {              
                        (currentElement).css('position', 'absolute').animate(minimizingWindowOptions);                  
                    } else {
                        var position = {'position': 'absolute', 'left': positionX, 'top': positionY};
                        (currentElement).css(position);
                    }                   
                    
                    sequence--;
                }
            );
    };

    function openWindowToOpen() {
        var dialog = $('#dialogMaxWindow');
        var windowTooOpen = dialog.data('windowToOpen');
        var windowsCount = dialog.data('windowsCount');
        ns.createWindow(windowTooOpen, utilsSpace.getBasePath(), webUtilsNs.rewriteWindow(), windowsCount - 1);
    }
    
    ns.saveMinimizedWindows = function() {
		var minimizedWindowsArray = ns.getMinimizedWindowsArray();
        ns.saveChangesToDb(minimizedWindowsArray);
    };
    
    ns.getMinimizedWindowsArray = function() {
		var minimizedWindowsArray = Array();
		
        // ----- update sequence number for minimized windows
        $('#minimizedWindows .minimizedWindow').each(function() {
            var currentElement = $(this);
            
            var activeWindow = {};
            activeWindow.windowId = currentElement.attr(ns.ATTR_WINDOW_ID);
            activeWindow.sequence = currentElement.attr(ns.ATTR_MIN_WINDOW_SEQUENCE);
            minimizedWindowsArray.push(activeWindow);
        });
        
        return minimizedWindowsArray;
    };
    
    // ----- set options of dialog for maximum number of windows exceeded
    ns.dialogMaxWindowOptions = {
        autoOpen : false,
        show : 'blind',
        hide : 'fade',
        modal : true,
        resizable : false,
        buttons : {
    		yes : function() {
                ns.closeWindow(windowToRemoveId);
                
    			var dialog =  $('#dialogMaxWindow');
    			dialog.parent('.ui-dialog').css('display', 'none');
                
                var inputShowDialog = $('#dialogMaxWindow').find("input[name='showMaxWindowDialog']");
                dialog.dialog('close');
                
                // ------ do not show a confirmation dialog 
                if (inputShowDialog.attr('checked')) {
                	$('.activeWindowDiv').attr(ns.ATTR_SHOW_MAX_WINDOW_DIALOG, 'false');
                	
                	// ----- set in db
                    $.ajax({
                        type : 'POST',
                        url : utilsSpace.getBasePath() + '/saveUser.do',
                        data : {
                            action : 'changeShowMaxWindowDialogOption',
                            showMaxWindowDialog : true,
                            ajaxCall : true
                        }
                    });
                }
				openWindowToOpen();
    		},
    
    		no : function() {
    			$(this).dialog('close');
    			$('#dialogMaxWindow').parent('.ui-dialog').css('display', 'none');
    		}
        }
    };
    
     /**
     * Maximize minimized window and close minimized window after click on minimized window.
     * 
     */
     ns.restoreWindowFromMinimized = function (pWindowId) {
            
            var activeWindow = $('#activeWindow' + pWindowId);
            var minimizedWindow = $('#minimizedWindow' + pWindowId);
            var activeWindowContent = activeWindow.children('.activeWindowContent');
            var animationSpeed = webUtilsNs.showAnimation() ? 'slow' : 0;
            
            /** Minimize window */
            if (activeWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED ) === ns.WINDOW_IS_NOT_MINIMIZED) {
                ns.minimizeWindow(pWindowId);
                return;
            }
            
            var window = {};
            window.height = activeWindow.attr(ns.ATTR_WINDOW_HEIGHT);
            window.width = activeWindow.attr(ns.ATTR_WINDOW_WIDTH);
            window.positionX = activeWindow.attr(ns.ATTR_WINDOW_POSITION_X);
            window.positionY = activeWindow.attr(ns.ATTR_WINDOW_POSITION_Y);
            window.windowId = activeWindow.attr(ns.ATTR_WINDOW_ID);
            window.isMinimized = ns.WINDOW_IS_NOT_MINIMIZED;
            window.isCollectionSettingsHidden = activeWindow.attr(ns.ATTR_IS_COLLECTION_SETTINGS_HIDDEN);
            window.zIndex = activeWindow.attr(ns.ATTR_WINDOW_Z_INDEX);
            
            ns.moveWindow(window);
            
            // ----- set vindow visible
            activeWindow.css('visibility', 'visible');
            
            // ----- animate maximizing
            activeWindow.css('position', 'absolute').animate(
            {
                height : window.height,
                width : window.width,
                left : window.positionX,
                top : window.positionY,
                opacity : 1
            }
            , animationSpeed, function() {
                 activeWindowContent.find('*[name="' + $('#activeWindow' + pWindowId).attr(ns.ATTR_WINDOW_ELEMENT_WITH_FOCUS) + '"]').focus();
            });  
            
            // ----- content window will be smaller because of scrollbar
            if(activeWindowContent.hasHorizontalScrollbar() ||
               activeWindowContent.hasVerticalScrollbar()) {
                window.height = window.height - ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT;
                window.width = window.width - ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH;
            }
            
            activeWindowContent.css('height', window.height).css('width', window.width);
            activeWindowContent.css('visibility', 'visible');
            activeWindow.children('.windowTitlebar').css('display', 'block');
            activeWindow.children('.windowTitlebar').children('.windowTitle').css('display', 'block');
            activeWindow.children('.windowTitlebar').children('.windowIcon').css('visibility', 'visible');
            activeWindow.children('.ui-icon-gripsmall-diagonal-se').css('display', 'block'); 
            activeWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED , 0);
            activeWindow.attr(ns.ATTR_WINDOW_HAS_FOCUS, true);
            minimizedWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED , 0);
            
            activeWindow.attr(ns.ATTR_CONTENT_WINDOW_HEIGHT, window.height - ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT);
            
            ns.setCurrentWindowToTop(window.windowId, false, true);
            
            // ----- move from minimizedWindows div
            activeWindow.appendTo('#desktop');
        };
    
    /**
     * Restore window size from minimized.
     * 
     */
   
    $(document).on('click', '.minimizedWindow', function() {
        var windowId = $(this).attr(ns.ATTR_WINDOW_ID);
        var activeWindow = $('#activeWindow' + windowId);
        if (!activeWindow.attr(ns.ATTR_WINDOW_HAS_FOCUS) && parseInt(activeWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED)) === ns.WINDOW_IS_NOT_MINIMIZED) {
            ns.setCurrentWindowToTop(windowId, true, true);
        } else {
            var isWindowAnimating = activeWindow.is(':animated');

            if (!isWindowAnimating) {
                ns.restoreWindowFromMinimized(windowId);
            }
        }
    }); 

    
    
        // plugtrade.com - jQuery detect vertical scrollbar function //
    /**
     * Return if element has vertical scrollbar.
     */
    (function($) {
        $.fn.hasVerticalScrollbar = function() {
            var divnode = this.get(0);
            if (divnode && divnode.scrollHeight > divnode.clientHeight)
                return true;
        };
    })(jQuery);
    
    /**
     * Return if element has horizontal scrollbar.
     */
    (function($) {
        $.fn.hasHorizontalScrollbar = function() {
            var divnode = this.get(0);
            if (divnode && divnode.scrollWidth > divnode.clientWidth)
                return true;
        };
    })(jQuery);
    
    
    /*
     * After click on window title, set window as first.
     */
    $(document).on('click', '.windowTitlebar', 
       function () {

    	// when click on modal window title - do nothing - only one modal window is always active
    	if (windowUtilsSpace.existsModalWindow()) {
    		return;
    	}

    	var windowId = $(this).parent('.activeWindowDiv').attr(ns.ATTR_WINDOW_ID);
    	var currentWindow = $('#activeWindow' + windowId);
    	
    	// ----- problem in some IE11 versions
    	// ----- when new browser window is opened and after that is set focus into active window, browser window goes to background
    	// ----- check if documentation icon has hover icon image - it has when link is clicked
    	if (currentWindow.find('.documentationWindow:hover').length > 0) {
    	   return false;
    	}
    	
	    if (currentWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED) !== '1') {
	   		ns.setCurrentWindowToTop(windowId, true);
		}
       }
    );
    
    
    /*
     * After click no window title, set window as first.
     * 
     */
    $(document).on('click', '.activeWindowContent', 
       function () {
     	 var originalWindowId = formSpace.getWindow(this);
         if ($('#' + originalWindowId).attr('_dci_settotopwhenclicked') == 'false') {
        	 $('#' + originalWindowId).attr('_dci_settotopwhenclicked', 'true')
        	 return;
    	 }
         // ----- no overlay - no modal modal window - window is clickable
         // ignore modal windows
         if ($('.ui-widget-overlay').length === 0 && !ns.isModalWindow($(this).attr('id'))){
        	ns.setCurrentWindowToTop($(this).parent('.activeWindowDiv').attr(ns.ATTR_WINDOW_ID), false);
         }
       }
    );
    
       /*
     * After click no window title, set window as first.
     * 
     */
    $(document).on('click', 'div.activeWindowDiv div.activeWindowDiv', 
       function () {
    	
         // ----- no overlay - no modal modal window - window is clickable
         // condition extended - ignore modal windows (attribute id starts with 'modalWindow'); see DUOH-0226.02
         if ($('.ui-widget-overlay').length === 0 && !ns.isModalWindow($(this).attr('id'))) {
             setCurrentWindowToTop($(this).attr(ns.ATTR_WINDOW_ID), false);
         }
       }
    );

    function showMaxWindowDialog() {
        var nameOfWindow = document.getElementById('activeWindow' + windowToRemoveId).querySelector(".windowTitlebar").title;
        var closingWindowName = document.getElementById("closingWindowName");
        closingWindowName.textContent = nameOfWindow;

        var dialogMaxWindow = $('#dialogMaxWindow');
        dialogMaxWindow.css('visibility', 'visible');
        dialogMaxWindow.dialog('open');
    }

    function closeExceededWindow() {
        if ($('#activeWindow' + windowToRemoveId).attr(ns.ATTR_SHOW_MAX_WINDOW_DIALOG) === 'true') {
            showMaxWindowDialog();
            return false;
        }
        ns.closeWindow(windowToRemoveId);
        return true;
    }
    
    
    /**
     * Closes specific window or shows confirmation dialog. Closing (or showing dialog) itself can be done
	 * in multiple ways depending on application settings and state.
     * @returns true  - if window was closed
     *          false - if window wasn't closed (dialog was opened instead) 
     * @param pWindowId ID of window to be closed
     */
    function closeWindowWithCheck(pWindowId) {
        var currentWindowName = 'activeWindow' + pWindowId;
        var activeWindow = $('#' + currentWindowName);
        
        // Unsaved Jmesa dialog
        if (windowUtilsSpace.isJmesaWindow(currentWindowName)) {
            if (windowUtilsSpace.hasJmesaInputFieldInWindow(currentWindowName)) {
                windowUtilsSpace.getJmesaInputFieldInWindow(currentWindowName).blur();
            }
            if (jmesaSpace.hasChangedData(windowUtilsSpace.getJmesaTableIdInWindow(currentWindowName))) {
                ns.setCurrentWindowToTop(pWindowId, false);
        	
                if (parseInt(activeWindow.attr(ns.ATTR_WINDOW_IS_MINIMIZED)) === ns.WINDOW_IS_MINIMIZED) {
                    ns.restoreWindowFromMinimized(pWindowId);
                }
                var dialogCloseUnsavedJmesa = $('#dialogCloseUnsavedJmesa');
                var dialogTitlebar = dialogCloseUnsavedJmesa.parent().find('.ui-dialog-title');
                var dialogTitle = appResourcesSpace.getMessage("jmesa.message.closeUnsavedTitle");
                var windowName = activeWindow.find('.windowTitlebar').attr('title');
                dialogTitle = dialogTitle.replace('{0}', windowName);
                dialogTitlebar.text(dialogTitle);
                dialogCloseUnsavedJmesa.css('visibility', 'visible');
                dialogCloseUnsavedJmesa.dialog('open');
                return false;
            }
        }

        // Max. windows dialog
        if (closingType === CLOSING_TYPE_MAX_WINDOW) {
            return closeExceededWindow();
        }

        // Confirm close dialog
        if (activeWindow.attr(ns.ATTR_SHOW_WINDOW_CLOSE_DIALOG) === 'true') {
             var dialogRemoveWindow = $('#dialogRemoveWindow');
            // ----- fixed bug when sometimes dialog isnt open
            var display = dialogRemoveWindow.parent('.ui-dialog').css('display');
            if (display === 'none') {
                dialogRemoveWindow.parent('.ui-dialog').css('display', 'block');
                dialogRemoveWindow.parent('.ui-dialog').css('top', '167px');
                dialogRemoveWindow.parent('.ui-dialog').css('left', '799px');
            }
            // ----- set dialog visible because of IE
            dialogRemoveWindow.css('visibility', 'visible');
            dialogRemoveWindow.dialog('open');
            return false;
        } else {
            ns.closeWindow(pWindowId);
            return true;
        }
    }
    
    
    
    /**
     * Show confirm dialog after click on close window link. 
     * 
     * If dialog is confirm, remove window. 
     * 
     * Else close dialog.
     */
    $(document).on('click', '.closeWindow', 
            function(event) {
    			element = $(event.currentTarget);
                windowToRemoveId = element.parent().parent().attr(ns.ATTR_WINDOW_ID);
                closingType = CLOSING_TYPE_CLOSE;
                closeWindowWithCheck(windowToRemoveId);
                return false;
        });

    /**
     * Maximize window after click on maximize window link.
     */
    $(document).on('click', '.maximizeWindow', function() {
    	var activeWindow = $(this).parents('.activeWindowDiv:first');
    	ns.changeWindowMaximization(activeWindow.attr(ns.ATTR_WINDOW_ID));
    });

    /**
     * Updates the size of a window according to desktop size
     *
     * @param pWindow window to resize
     * @param desktopSizeWidth
     * @param desktopSizeHeight
     */
    ns.updateWindowSizeByDesktopSize = function(pWindow, desktopSizeWidth, desktopSizeHeight) {
        
        var windowContent = pWindow.find('.activeWindowContent');
        var width = pWindow.width();
        var height = pWindow.height();
         
        if (pWindow.attr('_dci_isMinimized') === '0' | pWindow.hasClass('modalWindow')) {
            // do not change minimized windows size
        
            if (pWindow.attr('_dci_maximized') === 'true') {
                if (pWindow.hasClass('modalWindow')) {
                    modalWindowNs.maximizeModalWindow(pWindow.attr('id'));
                } else {
                    ns.maximizeWindow(pWindow);
                }
            } else {
        
                var sizeChanged = false;
                if (width != desktopSizeWidth) {
                    var actualWindowDciWindowWidth = pWindow.attr('_dci_windowwidth');
                    actualWindowDciWindowWidth = actualWindowDciWindowWidth <= desktopSizeWidth ? actualWindowDciWindowWidth : desktopSizeWidth;
                    
                    pWindow.css('width', actualWindowDciWindowWidth + 'px');
                    windowContent.css('width', actualWindowDciWindowWidth - ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH + 'px');
                    sizeChanged = true;
                }
        
                if (height >= desktopSizeHeight) {
                    pWindow.css('height', desktopSizeHeight + 'px');
                    windowContent.css('height', desktopSizeHeight - ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT + 'px');
                }
        
                if (sizeChanged) {
                    // set up resizing again to ensure that maxWidth is set correctly
                    ns.setWindowResizable(pWindow.attr(ns.ATTR_WINDOW_ID));
                }
            }
        }
    }
    
    /**
     * Maximize window or adjust size by attributes if is currently maximized
     */
    ns.changeWindowMaximization = function(pWindowId) {
    	var activeWindow = $('#activeWindow' + pWindowId);
        var maximizeIcon = activeWindow.find('.windowTitlebar:first .maximizeWindow');
        
        if (maximizeIcon.hasClass('restoreWindow')) {
        	 
        	// --------- window have to be added to desktop element when is not maximized
        	activeWindow.appendTo('#desktop');
        	
            ns.setWindowSizeAndPositionsFromAttributes(activeWindow);
            activeWindow.attr('_dci_maximized', 'false');
            var desktop = $('#desktop');
            ns.updateWindowSizeByDesktopSize(activeWindow, desktop.width(), desktop.height());
            maximizeIcon.removeClass('restoreWindow');
        } 
        else {           
            var windowId = activeWindow.attr(ns.ATTR_WINDOW_ID);     
            ns.setCurrentWindowToTop(windowId, true);     
            ns.maximizeWindow(activeWindow);           
            maximizeIcon.addClass('restoreWindow');
            maximizeIcon.addClass('windowIcon');
        }
    };
    
    /**
     * Extend window into desktop space after click on extend window link.
     */
    $(document).on('click', '.extendWindow', function() {
		var activeWindow = $(this).parents('.activeWindowDiv:first');
		ns.performWindowExtend(activeWindow.attr(ns.ATTR_WINDOW_ID));
    }); 
    
    /**
     * Extend window into desktop space
     */
    ns.performWindowExtend = function(pWindowId) {
    	var activeWindow = $('#activeWindow' + pWindowId);
    	
   	 	// ---------- when window has been maximized it is appends to body
    	// ---------- append it back to desktop
    	if (activeWindow.attr('_dci_maximized') === 'true') {
    		activeWindow.attr('_dci_maximized', 'false');
    		activeWindow.appendTo('#desktop');
    	 }
        
        var windowId = activeWindow.attr(ns.ATTR_WINDOW_ID);
        ns.setCurrentWindowToTop(windowId, true);     
        ns.extendWindow(activeWindow);
        ns.saveWindowPropertiesToAttributes(activeWindow, ns.WINDOW_IS_NOT_MINIMIZED);
    	ns.saveWindowChangeToDb(windowId);
    };
        
     /**
      * Maximizes given modal or basic window
      *
      * @param pWindow element 
      */
     ns.maximizeWindowAfterResize = function (pWindow) {
        if (pWindow.hasClass('modalWindow')) {
            modalWindowNs.maximizeModalWindow(pWindow.attr('id'));
        } else {
            ns.maximizeWindow(pWindow);
        }
     }
      
     /**
      * Maximize window.
      * 
      * @param pWindow element 
      */  
     ns.maximizeWindow = function (pWindow) {
         var browserWindow = $('body');

         // --------- window cannot be greater than desktop append to body when is maximized
         pWindow.appendTo(browserWindow);

         pWindow.width(browserWindow.width() - ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT);
         pWindow.height($('#desktop').height() + $('.topMenu').height() + ns.ACTIVE_WINDOW_SPACE_FROM_CONTENT);
         pWindow.attr('_dci_maximized', 'true');
         var pWindowChildren = pWindow.children('.activeWindowContent');
         pWindowChildren.css('height', pWindow.height() - ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT);
         pWindowChildren.css('width', pWindow.width() - ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH);
         pWindow.css('left', MAXIMIZED_WINDOW_NULL_LEFT_POSITION);
         pWindow.css('top', MAXIMIZED_WINDOW_NULL_TOP_POSITION);
         pWindow.draggable({disabled: true});
         pWindow.resizable({disabled: true});
     };

     /**
      * Extend window.
      * 
      * @param pWindow element 
      */
     ns.extendWindow = function (pWindow) {
         var jDesktop = $('#desktop');
         pWindow.width(jDesktop.width());
         pWindow.height(jDesktop.height());
         var pWindowChildren = pWindow.children('.activeWindowContent');
         pWindowChildren.css('height', pWindow.height() - ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT);
         pWindowChildren.css('width', pWindow.width() - ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH);
         pWindow.css('left', utilsSpace.isLeftMenuHidden() ? MAXIMIZED_WINDOW_NULL_LEFT_POSITION : 0);
         pWindow.css('top', 0);
     };

    
    
    /**
     * Update sequence numbers for minimized windows.
     * 
     * @param pFrom from which number will be numbers updated
     *
     * @return minimizedWindowsArray array with object - window id
     *                                                 - sequence number
     */
    ns.updateSequnceNumbers = function(pFrom) {
        var minimizedWindowsArray = Array();    
        
        // ------ iterate over active windows, reverse because off adding to left
        $($('#minimizedWindows .minimizedWindow').get().reverse()).each(
            function() {        
                var currentElement = $(this);
                var currentElementId = $(this).attr(ns.ATTR_WINDOW_ID);
                var activeWindow = $('#activeWindow' + currentElementId);
                
                // ---- only windows right from pFrom param
                if (currentElement.attr(ns.ATTR_MIN_WINDOW_SEQUENCE) > pFrom) {                          
                    currentElement.attr(ns.ATTR_MIN_WINDOW_SEQUENCE, parseInt(currentElement.attr(ns.ATTR_MIN_WINDOW_SEQUENCE)) - 1);                     
                    activeWindow.attr(ns.ATTR_MIN_WINDOW_SEQUENCE, parseInt(activeWindow.attr(ns.ATTR_MIN_WINDOW_SEQUENCE)) - 1);                     
                    
                    activeWindow = {};
                    activeWindow.windowId = currentElement.attr(ns.ATTR_WINDOW_ID);
                    activeWindow.sequence = currentElement.attr(ns.ATTR_MIN_WINDOW_SEQUENCE);
                    minimizedWindowsArray.push(activeWindow);
                }       
            }
        );
        return minimizedWindowsArray;
    };
    
    $(document).on('click', '.closeModalWindow', function() {
        // ----- get window which will be removed
        var modalWindow = $(this).parent().parent();
        ns.closeModalWindowWithCheck(modalWindow);
        
        return false;
    });
    
    /**
     * Show confirm dialog after click on close modal window link. 
     * 
     * If dialog is confirm, remove modal window. 
     * 
     * Else close dialog.
     */
    ns.closeModalWindowWithCheck = function(pModalWindow) {
        // ----- get window which will be removed
        var modalWindow = pModalWindow ? pModalWindow : $('.modalWindow:last');
        var dialogRemoveModalWindow = $('#dialogRemoveModalWindow');
        var parentWindowId = modalWindow.attr('_dci_parentwindowid');
        
        // ----- check if user want to show dialog
        if ($('#' + parentWindowId).attr(ns.ATTR_SHOW_WINDOW_CLOSE_DIALOG) === 'true') {
        	
        	// ----- fixed bug when sometimes dialog isnt open
        var	display = dialogRemoveModalWindow.parent('.ui-dialog').css('display');
        	if (display === 'none') {
        		dialogRemoveModalWindow.parent('.ui-dialog').css('display', 'block');
        		dialogRemoveModalWindow.parent('.ui-dialog').css('top', '167px');
        		dialogRemoveModalWindow.parent('.ui-dialog').css('left', '799px');
        	}
        	
        	// ----- set dialog visible because of IE
        	dialogRemoveModalWindow.css('visibility', 'visible');
        	dialogRemoveModalWindow.dialog('open');
        } else {
             ns.closeModalWindow(modalWindow.attr('id'));
        }
    };
    
    
    // ----- set dialog options for confirm remove modal window
    ns.dialogCloseModalWindowOptions = {
        autoOpen : false,
        show : 'blind',
        hide : 'fade',
        resizable : false,
        modal : true,
        buttons : {
            
            yes : function() {
                $(this).dialog('close');
                ns.closeModalWindow(modalWindow.attr('id'));
                $('#dialogRemoveModalWindow').parent('.ui-dialog').css('display', 'none');
            
            },
            
            no : function() {
                $(this).dialog('close');
                $('#dialogRemoveModalWindow').parent('.ui-dialog').css('display', 'none');
            }
        }
    };
    
    /**
     * Save sequence to db by AJAX.
     * 
     *  @param pMinimizedWindowsArray Array with sequence numbers and windows id
     * 
     */
    ns.saveChangesToDb = function(pMinimizedWindowsArray) {
        $.ajax({
            type: 'POST',
            dataType: 'json',
            url : utilsSpace.getBasePath() + '/changeActiveWindows.do',
            data : {
                action : 'saveWindowsChanges',
                minimizedWindowsListJSON: JSON.stringify(pMinimizedWindowsArray),
                ajaxCall : true
            }
        }); 
    };

    /**
     * Function called on window resize event
     */
    ns.windowResized = function() {
        var windowId = windowUtilsSpace.getCurrentWindowId();
        ns.sortMinimizedWindows(false);
    	
    	// -------------- do not change window size during resizing event
    	var controlWidowSize =  $('#' + windowId).hasClass(windowUtilsSpace.CLASSES.RESIZABLE_RESIZING_EVENT) ? false : true;
    	webUtilsNs.setDesktopSize(controlWidowSize);
    	webUtilsNs.fixOverlayDivSize();
    };

    function extractUrlValue(key, url) { 
        var match = url.match('[?&]' + key + '=([^&]+)');
        return match ? match[1] : null;
    }

    /**
     * Fills relevant filter in assistant.
     * @param pSourceWindowId 
     * @param pTargetWindowId 
     * @param pActionPath 
     */
    function fillFilter(pSourceWindowId, pTargetWindowId, pActionPath) {
        var sourceKey = extractUrlValue('toField1', pActionPath);
        var targetKey = 'displaytagFilter.';
        targetKey += extractUrlValue('fromProperty1', pActionPath);

        var sourceInput = $('#'+ pSourceWindowId + " input[name='" + sourceKey + "']");
        var targetFilter = $('#'+ pTargetWindowId + " input[name='" + targetKey + "']");

        if (sourceInput && targetFilter && sourceInput.length === 1 && targetFilter.length === 1) {
            var value = sourceInput[0].value;
            targetFilter[0].value = webUtilsNs.endsWith(value, '%') ? value : value + '%';
        }
    }
    
    /**
     * Create new modal window.
     * 
     * @param currentWindow
     * @param newActionPath
     * @param newWindowName
     * @param width
     * @param height
     * @param resizible
     * @param showBars
     * @param chainWithOpener
     * @param hAlign
     * @param vAlign
     * @param pLoadContent		- true or false - indicate if content will be loaded to modal window by AJAX
     * @param pWindowMinWidth - min window width during resizing window
	 * @param pWindowMinHeight - min window height during resizing window
	 * @param pNotModal - indicate if window will be modal
	 * @param pReuseWindow		- flag indicating the actual modal window should be reused in order to contain new content
	 * @param pModalWindowClass - CSS class that will be added to modal window div tag
     */
    
    
    ns.openModalWindow = function (currentElement,
    							   newActionPath,
    							   newWindowName,
    							   width,
    							   height,
    							   resizible,
    							   showBars,
    							   chainWithOpener,
    							   hAlign,
    							   vAlign,
    							   pLoadContent,
    							   pWindowMinWidth,
    							   pWindowMinHeight,
    							   pNotModal,
    							   pReuseWindow,
    							   pModalWindowClass,
                                   pAfterContentLoadedHandler) {
    	
    	// -------- prevent opening window after stop dragging event
    	if($(currentElement).parents('.desktopIcon').data(desktopSpace.ICON_IS_DRAGGING)) {
    		return;
        }
        
        var currentWindowId = windowUtilsSpace.getCurrentWindowId();
    	
        var count = parseInt($('.modalWindow:last').attr('_dci_modalwindowid')) || 0;
        var reuseWindow = pReuseWindow && count > 0;
       	count += reuseWindow ? 0 : 1;
        
        var parentWindowId = $(currentElement).parents('.activeWindowDiv:first').attr('id');
        
        if (!parentWindowId) {
        	parentWindowId = $('.modalWindow:last').attr('id') || $(currentElement).parents('.ui-dialog-content:first').attr('id');
        }
        if (!parentWindowId && $('div#container').length) {
        	parentWindowId = 'container';
        }
        
       	if (windowContentSpace.isTransactionDefinition(parentWindowId)) {
    		ns.disableButtons(parentWindowId);
    	}
        
        // ----- set active windows lower z-index 
        $('#desktop .activeWindowDiv').each(
                function() {
                    $(this).css('z-index', $(this).attr('id') === parentWindowId ? 1 : 0);
                }
        );
        
        var toElement = null;
        if ($('#windowsDesktop').length > 0 && !utilsSpace.isMES()) {
            toElement = $('#windowsDesktop');	 
        } else {	 
            toElement = $('body');	 
        }
        // ----- for selenium tests
        if ($('#actualWindow').length === 0) {
        	 toElement.append("<div id='actualWindow' class='modalWindow"+ count + "'/>");
        } else {
        	$('#actualWindow').attr('class', 'modalWindow' + count);
        }
        
           // ----- create window element 
        var modalWindow = $('#modalWindow' + count);
        var modalWindowContent = modalWindow.find('.activeWindowContent');
        
        if (reuseWindow) {
        	modalWindow.attr('_dci_modalwindowaction', newActionPath);
        	modalWindow.attr('_dci_modalwindowcurrentaction', newActionPath);
        	modalWindowContent.empty();
        	modalWindowContent.attr('src', newActionPath);
        	
        } else {
	        toElement.append($("<div id ='modalWindow"+ count + "' class='modalWindow " + utilsSpace.getEmptyStringIfContainsNull(pModalWindowClass) + "' _dci_modalwindowid='" + count + "' _dci_parentwindowid='" + parentWindowId + "' _dci_modalwindowaction='" + newActionPath + "' _dci_modalwindowcurrentaction='" + newActionPath + "'/>", {
	        }).append($("<div class='windowTitlebar'/>", {
	        }).append($("<div class='windowTitle'> ")).append($("<div class='closeModalWindow windowIcon'/><div class='maximizeModalWindow windowIcon'/><div class='documentationWindow windowIcon' onclick='cz.aimtec.dci.window.openDocumentationWindow(this)'/>", {
	        }))).append($("<div id='modalWindowContent"+ count + "' class='activeWindowContent' src='" + newActionPath +"'/>", {
	        })));
    
            modalWindow = $('#modalWindow' + count);
            modalWindowContent = modalWindow.find('.activeWindowContent');
        }
        
        if (!utilsSpace.isMES()) {
            modalWindow.width(width + MODAL_WINDOW_CONTENT_WINDOW_WIDTH);
            modalWindowContent.width(width - ns.MODAL_WINDOW_CONTENT_MARGIN_FROM_WINDOW);
            
        	if (height != AUTOMATIC_SIZE) {
        		modalWindow.height(height);
        	}
            modalWindowContent.height(height - ns.MODAL_WINDOW_CONTENT_MARGIN_FROM_WINDOW);
            var leftMenu = $('#menuLeft');
            var topMenu = $('div.topMenu');
            modalWindow.css({
	        	'left' : leftMenu.length ? $('#menuLeft').width() : 0,
	            'top' : topMenu.length ? $('div.topMenu').height() : 0
        	});
            ns.saveWindowPropertiesToAttributes(modalWindow, false);
        } else {
        	modalWindow.width(width);
        	
        	if (height != AUTOMATIC_SIZE) {
        		modalWindow.height(height - MODAL_WINDOW_MES_BOTTOM_MARGIN);
        	}

        	modalWindowContent.height(height - MODAL_WINDOW_CONTENT_MARGIN_FROM_WINDOW_MES);
            modalWindow.css({
	            'left' : 0,
	            'top' : 0
        	});
        }
        
        // ----- add overlay over page
        // ----- width and height is for zoomed page - set overlay over whole document
        if (!reuseWindow) {
        if (!pNotModal) {
        	utilsSpace.createOverlayDiv('modalWindow-overlay');
        } else {
        	modalWindow.attr(ns.ATTR_WINDOW_IS_NOT_MODAL, 'true');
        }
        }
        
        if (!pNotModal) {
        	// ----- set another modal windows lower z-index - will be overlayed
        	$('.modalWindow').each(
        			function() {
        				var modalWindow = $(this);
        				if (modalWindow.attr('_dci_modalwindowid') !== count) {
        					modalWindow.css('z-index', ns.Z_INDEX.MODAL_WINDOW_IN_BACKGOURND);                    
        				}
        			}
        	);
        }
        
        // ----- modal window has greater z-index than overlay
        var uiDialogZIndex = 0;
        if (utilsSpace.exists($(currentElement).closest('.ui-dialog'))) {
        	uiDialogZIndex = parseInt($(currentElement).closest('.ui-dialog').css('z-index'));
        }
        modalWindow.css('z-index', uiDialogZIndex + ns.Z_INDEX.MODAL_WINDOW);
       
        if (resizible === 1 && !utilsSpace.isMES()) {
        	modalWindowNs.setModalWindowDraggable(count);
        }
        if (resizible === 1 && !utilsSpace.isMES()) {
            
            var windowMinWidth = pWindowMinWidth ? pWindowMinWidth : ACTIVE_WINDOW_MIN_WIDTH;
            var windowMinHeight = pWindowMinHeight ? pWindowMinHeight : ACTIVE_WINDOW_MIN_HEIGHT;
            		
            modalWindowNs.setModalWindowResizable(count, windowMinWidth, windowMinHeight);
        }
        
        var urlObject = utilsSpace.convertUrlToPostCall(newActionPath);
        
		// --------- Loading IDs of checked rows, used 
		var selectedItems = $('#' + parentWindowId + ' .selectRow:checked');
		for (var index = 0; index < selectedItems.length; index++) {
			urlObject.postObject.push({'name' : 'selectedItemKeys', 'value' : $(selectedItems[index]).attr('idValue')});
		}
        
        if(pAfterContentLoadedHandler && typeof pAfterContentLoadedHandler === 'function') {
            modalWindow[0].addEventListener(MODAL_WINDOW_OPENED_EVENT, pAfterContentLoadedHandler);
        }
        
        if (pLoadContent === 'true') {	
            
            $.ajax({
                url : urlObject.url,
                type : 'POST',
                data: urlObject.postObject,
                beforeSend: function () {
                    utilsSpace.showProgressIndicator();                        
                },
                success : function(data) {
                    if (utilsSpace.handleUserLogging(data)) {
                    	var modalWindowId = 'modalWindow' + count;
                        var scripts = ns.loadJavaScripts(data);
                        
                        // ---- load CSS styles
                        ns.loadStyles(data, modalWindowId);
                       
                        // ----- load scripts needed by page
                        require(scripts, function() {
                            // ----- srcipts are loaded, set page to modal window content
                            windowUtilsSpace.reloadWindowContent('modalWindowContent' + count, data);    
                            
                            // ----- set title
                            var moduleCode = ns.getModuleCode(modalWindowId);  
                            var titleText = ns.getWindowName(modalWindowId);
                            var modalWindowTitleElement = $('#' + modalWindowId + ' .windowTitlebar .windowTitle');
                            
                            // ----- check if module code is blank 
                            var modalWindowTitle = (moduleCode !== '') ? titleText.substring(0, ns.MODAL_WINDOW_TITLE_MAX_TEXT_LENGHT) + ' ('  + moduleCode + ')' : titleText;
                            modalWindowTitleElement.text(modalWindowTitle);
                            modalWindowTitleElement.attr('title', titleText);
                            



                            ns.setInputsWidthInWindow(modalWindowId);

                            fillFilter(currentWindowId, modalWindowId, newActionPath);
                             
                            ns.disableClickOnSortableColumn();

                         	// Set an orange [?] if documentation exists for this window 
                         	if (modalWindow.find('.docExists').length > 0) {
                        		modalWindow.find('.documentationWindow').switchClass('documentationWindow', 'documentationExistsWindow');
                        	}

                         	utilsSpace.hideProgressIndicator(modalWindowId);
                         	ns.fixModalWindowSize(modalWindowId, width, height, toElement);
                             
                             // ----- set up close button for transaction window
                             if (windowUtilsSpace.isTransactionWindow(modalWindowId)) {
                            	 ns.setupCloseButtonForTransactionWindow();
                             }

                            //modalWindow[0].dispatchEvent(new Event(MODAL_WINDOW_OPENED_EVENT));
                             //element.dispatchEvent(new Event("submit"));
                             var event;
                             if(typeof(Event) === 'function') {
                                 event = new Event(MODAL_WINDOW_OPENED_EVENT);
                             }else{
                                 event = document.createEvent('Event');
                                 event.initEvent(MODAL_WINDOW_OPENED_EVENT, true, true);
                             }

                             modalWindow[0].dispatchEvent(event);
                        });
                    }
                }, 
                error : function(response, textStatus, errorThrown) {
                    	utilsDialogSpace.showError(response, textStatus, errorThrown);					
						utilsSpace.hideProgressIndicator();  
                }
            });

        }

    };
    
    /**
	 * Set up close button visibility and action in transaction window.
	 *  
	 */  
    ns.setupCloseButtonForTransactionWindow = function(debug) {
    	var currentWindow = windowUtilsSpace.getCurrentWindow();
	   	var closeButton = $('div.closeModalWindow', currentWindow);
	   	if (!closeButton.length) {
	   		return;
	   	}
	   	var pagePath = webUtilsNs.getPagePath(closeButton);
	   	
	   	if (pagePath.indexOf('debugPage') < 0 && !debug) {
	   		// remove close button for non-debug transaction
	   		closeButton.remove();
	   	} else {
			// set up close button for debug transaction
			// - call finishTransaction module before window close
	   		if (closeButton.css('display') === 'none') {
	   			closeButton.css('display', 'block');
	   		}
	   		closeButton.removeClass('closeModalWindow');
			closeButton.addClass('closeTransactionWindow');
			closeButton.click(ns.closeTransactionWindow);
	   	}
    };
    
	/**
	 * Close transaction modal window by calling finishTransaction module.
	 *  
	 */     
    ns.closeTransactionWindow = function() {
    	var currentWindow = windowUtilsSpace.getCurrentWindow();
    	var transactionForm = $('form:first', currentWindow);
		var actionInput = $('input[name="action"]', transactionForm);
		
		if (actionInput && transactionForm) {
			// set action name
			actionInput.val('debugClose');
			// set form action (needed for page modules, e.g. typingPage)
			transactionForm.attr('action', utilsSpace.getBasePath() + '/transactionFlowController.do');
			// set up form submit event handler
			formSpace.sendData(actionInput);
			// submit form
			transactionForm.submit();
		}
    };
    
   
     /**
     * Corrects the size of the modal window.
     */
    ns.fixModalWindowSize = function (modalWindowId, width, height, parentElement) {
    	var modalWindow = $('#' + modalWindowId);
    	var modalWindowContent = modalWindow.find('.activeWindowContent');
    	var widthModification = false;
    	var originalWidth = width;
    	var originalHeight = height;
    	
    	// ----- check if the modal window's content is wider than the window
    	var mainBodyFrame = modalWindow.find('.mainBodyFrame')[0];
    	
    	// the fix for the Transaction definitions screen, using the mainBodyFrame's and modalWindowContent's scroll dimensions
    	if (mainBodyFrame) {    
    		var modalWindowMaxScrollHeight, modalWindowMinClientHeight;
    		var MWCDiff = modalWindowContent[0].scrollHeight - modalWindowContent[0].clientHeight;
    		var MBFDiff = mainBodyFrame.scrollHeight - mainBodyFrame.clientHeight;
    		
    		if (MWCDiff === 0) {
    			modalWindowMaxScrollHeight = mainBodyFrame.scrollHeight;
        		modalWindowMinClientHeight = mainBodyFrame.clientHeight;
    		}
    		else if (MBFDiff === 0) {
    			modalWindowMaxScrollHeight = modalWindowContent[0].scrollHeight;
        		modalWindowMinClientHeight = modalWindowContent[0].clientHeight;    			
    		}
    		else {
        		// eliminates scenario, when mainBodyFrame or modalWindowContent has same scrollHeight and clientHeight, but content is wider than the window
        		modalWindowMaxScrollHeight = Math.max(mainBodyFrame.scrollHeight, modalWindowContent[0].scrollHeight);
        		modalWindowMinClientHeight = Math.min(mainBodyFrame.clientHeight, modalWindowContent[0].clientHeight);    			
    		}
    		
    		var modalWindowWidth = mainBodyFrame.scrollWidth + ns.ACTIVE_WINDOW_SCROLLBAR_WIDTH; // do not expand to the window frame, leave the space for the scrollbar
    		var modalWindowHeight = modalWindowMaxScrollHeight + ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT;
    		
    		if (windowContentSpace.isTransactionDefinition(modalWindowId)) {
    			mainBodyFrame = modalWindow.find('#tranTemp div.details')[0]; // scrolling element for transaction window
    		}
    		
			var widthDiff = mainBodyFrame.scrollWidth - mainBodyFrame.clientWidth;
    		var heightDiff = modalWindowMaxScrollHeight  - modalWindowMinClientHeight;
    		
    		if (widthDiff > 0) { // scrolling necessary
    			width = modalWindowWidth + widthDiff; // expand the width if the content does not fit
    			widthModification = true;
    		}

            if (heightDiff > 0) { // scrolling necessary
                height = modalWindowHeight + heightDiff; // expand the height if the content does not fit
            }
    	}
    	
    	//----- check modal window size 
        if (width > parentElement.width() || !width || !$.isNumeric(width) || width < originalWidth) {
        	width = parentElement.width() - modalWindowNs.MODAL_WINDOW_MARGIN_FROM_BROWSER_WINDOW;
        }
        if (height > parentElement.height() || !height || !$.isNumeric(height) || height < originalHeight && 'body' !== parentElement.selector) {
        	height = parentElement.height();
        }
	    
	    if (utilsSpace.isMES()) {
	    	// ----- modal window is over whole page in MES
	    	width = $(window).width(); 
        	height = $(window).height();
	    	
		    modalWindow.width(width);
		    modalWindow.height(height - MODAL_WINDOW_MES_BOTTOM_MARGIN);
		    modalWindowContent.height(height - MODAL_WINDOW_CONTENT_MARGIN_FROM_WINDOW_MES);
		    modalWindow.css({
		    	'left' : 0,
		    	'top' : 0
		    });	        
	    } else {
	    	width = widthModification ? width : width + MODAL_WINDOW_CONTENT_WINDOW_WIDTH;
	    	modalWindow.width(width);
	    	modalWindowContent.width(width);
	        modalWindow.height(height);
	        modalWindowContent.height(height - ns.MODAL_WINDOW_CONTENT_MARGIN_FROM_WINDOW);
	        modalWindow.css({
	        	'left' : $('#menuLeft').width(),
	            'top' : $('div.topMenu').height()
	        });
	    }
    }

    /**
     * Create error modal window.
     * 
     * @param newActionPath				url to open			
     * 
     * @param newWindowName				window name
     * 
     * @param width						window width
     * 
     * @param height					window height
     * 
     */
    
    ns.openErrorWindow = function (newActionPath, newWindowName, width, height) {
  
        var count = $('.modalWindow').length;
        count++;

        // ----- set active windows lower z-index
        $('#desktop .activeWindowDiv').each(function() {
            $(this).css('z-index', 0);
        });

        var toElement = null;

        // For change password, where is not desktop
        if ($('#desktop').length > 0) {
            toElement = $('#desktop');
        } else {
            toElement = $('body');
        }

        
		// ----- create window element 
        // ----- one difference from modal window - x button which allow to close error window directly
		toElement.append($("<div id ='modalWindow"+ count + "' class='modalWindow' _dci_modalwindowid='" + count + "' _dci_modalwindowaction='" + newActionPath + "'/>", {
		}).append($("<div class='windowTitlebar'><div class='closeModalWindow windowIcon'/></div>", {
		}).append($("<div class='windowTitle'> ")).append($("<div class='closeModalWindow'/> ", {
		}))).append($("<div id='modalWindowContent"+ count + "' class='activeWindowContent' src='" + newActionPath +"' title='"+newWindowName+"'/>", {
		})));
        
        var modalWindowId = 'modalWindow' + count;
        var modalWindow = $('#' + 'modalWindow' + count);
        modalWindow.width(width);
        modalWindow.height(height);
        modalWindow.css('position', 'absolute');
        modalWindow.css('left', '5px');
        modalWindow.css('top', '5px');

        var modalWindowContent = modalWindow.find('.activeWindowContent');
        modalWindowContent.height(height - ns.ACTIVE_WINDOW_SCROLLBAR_HEIGHT);

        // ----- add overlay over page
        if (!utilsSpace.isMES()) {
        	utilsSpace.createOverlayDiv('errorWindow-overlay');
        }

        // ----- set another modal windows lower z-index - will be overlayed
        $('.modalWindow').each(function() {
            var modalWindow = $(this);
            if (modalWindow.attr('_dci_modalwindowid') !== count) {
                modalWindow.css('z-index', 0);
            }
        });

        // ----- modal window has greater z-index than overlay
        modalWindow.css('z-index', ns.Z_INDEX.MODAL_WINDOW);


        var randomedActionPath = utilsSpace.addRandomAttribute(newActionPath);

        $.ajax({
            url : randomedActionPath + utilsSpace.AJAX_CALL_URL_PARAM,
            type : 'POST',
            beforeSend : function() {
                utilsSpace.showProgressIndicator();
            },
            success : function(data) {
                // ----- srcipts are loaded, set page to modal window content
                $('#modalWindowContent' + count).html(data);
                utilsSpace.hideProgressIndicator();
                
                // ---- load CSS styles
                ns.loadStyles(data, modalWindowId);
                
                // ----- set stack trace element size - do not expand window with error
                modalWindowContent.find('.errorStackTrace').width(width);
                modalWindowContent.find('.errorStackTrace').width(height);
                
                //----- set after content is loaded - sometimes fails and we need to show error message
                modalWindowNs.setModalWindowDraggable(count);
                modalWindowNs.setModalWindowResizable(count, ACTIVE_WINDOW_MIN_WIDTH, ACTIVE_WINDOW_MIN_HEIGHT);
            }
        });
    };

    /**
     * Load CSS file into page.
     * 
     * @pSrc path to CSS file
     * 
     * @pWindowId window ID (activeWindow1, modalWindow2, ...)
     */
    ns.loadStyle = function (pSrc, pWindowId) {
    	
    	if (!utilsSpace.exists($('link[href="' + pSrc + '?v=' + utilsSpace.getCurrentVersion() + '?win=' + pWindowId + '"]'))) {
    		$("head").append("<link>");
    		var element = $("head").children(":last");
    		element.attr({
    			rel : "stylesheet",
    			type : "text/css",
    			href : pSrc + "?v=" + utilsSpace.getCurrentVersion() + "?win=" + pWindowId	// Ensure the CSS styles reload correctly with new version of DCI
    		}); 
    	}

    };
    
    /**
     * Return array of javascripts paths.
     * 
     * @pWindowId window ID
     * 
     * @return scripts array of javascripts paths
     */
    ns.unloadStyles = function(pWindowId) {
    	 $('link[href*="win=' + pWindowId + '"]').remove();
        
    };
    
    /**
     * Return array of style paths.
     * 
     * @param pData part of page
     * 
     * @param pWindowId window id
     * 
     * @return scripts array of css paths
     */
    ns.loadStyles = function(pData, pWindowId) {
        var styles = [];
        // ----- span must be wrapped by <div> or another element, because when page is returned by AJAX from server
        // ----- without <html> element JQuery doesn't find element with script paths
        $('span.requireCSS', '<div>' + $.trim(pData) + '</div>').each(
            function() {
                ns.loadStyle($(this).text(), pWindowId);
        });
        
        return styles;
    };
    
    
    /**
     * Return array of css paths.
     * 
     * @param pData part of page
     * 
     * @return styles array of styles paths
     */
    ns.loadJavaScripts = function(pData) {
        var scripts = [];

        // ----- span must be wrapped by <div> or another element, because when page is returned by AJAX from server
       // ----- without <html> element JQuery doesn't find element with script paths
        $('span.requireJS', '<div>' + $.trim(pData) + '</div>').each(
            function() {
                var src = $(this).text();
                    scripts.push(src);
        });
   
        return scripts;
    };
    
   	   /**
        * enable buttons in modal window.
        * 
        * @param pModalWindowId modal window id
        *  
        */    
    ns.enableButtons = function(pModalWindowId) {
    	var buttons = $('#' + pModalWindowId + ' :button');
    	
    	buttons.prop( 'disabled', false );
    	buttons.removeClass('disabled');     	
    };
    
       /**
        * disable buttons in modal window.
        * 
        * @param pModalWindowId modal window id
        *  
        */  
    ns.disableButtons = function(pModalWindowId) {
    	var buttons = $('#' + pModalWindowId + ' :button');
    
    	buttons.prop( 'disabled', true );
    	buttons.addClass('disabled'); 
    };
        
       /**
	 * If given modal window has an iframe, the iframe must
	 * be dealt with in a special way to prevent 'white page' bug
	 */
    ns.closeIFrame = function(pModalWindowId) {
    	var iFrame = $('#' + pModalWindowId).find('iframe');
    	
    	if (iFrame) {
			iFrame.attr('src', 'about:blank');
			iFrame.remove();
    	}
    };
 
 		/**
        * Close modal window.
        * 
        * @param pModalWindowId modal window id
        *  
        */     
 
    ns.closeModalWindow = function(pModalWindowId) {

        var parentWindowId = $('#' + pModalWindowId).attr('_dci_parentwindowid');
        var isNotModal = $('#' + pModalWindowId).attr(ns.ATTR_WINDOW_IS_NOT_MODAL);
        var countOfModalWindows = $('.modalWindow').length;
        
        // ----- if exists parent modal window set z-index
        if (parentWindowId && parentWindowId.indexOf('modalWindow') > -1) {
            $('#' + parentWindowId).css('z-index', $('#' + parentWindowId).attr(ns.ATTR_WINDOW_Z_INDEX) || ns.Z_INDEX.MODAL_WINDOW);
        }
        
        if (windowContentSpace.isTransactionDefinition(parentWindowId)) {
        	ns.enableButtons(parentWindowId);
        }
        
        ns.unloadStyles(pModalWindowId);
        ns.closeIFrame(pModalWindowId);
        
        // ----- remove overlay, each modal window has own overlay
        if (!isNotModal) {
        	var overlayName = 'modalWindow-overlay';
        	var modalWindowAction = $('#' + pModalWindowId).attr('_dci_modalwindowaction');
        	if (modalWindowAction && modalWindowAction.indexOf('editErrors') > -1) {
        		overlayName = 'errorWindow-overlay';
        	}
        	utilsSpace.removeOverlayDiv(overlayName);
        }
        
        // call the optional event
        var event = document.createEvent('Event');
        event.initEvent('optionalCloseModalWindowEvent', true, true);
        $('#' + pModalWindowId)[0].dispatchEvent(event);
        
        // ----- remove window
        $('#' + pModalWindowId).remove();

        // ----- if is there no another modal window
        if (countOfModalWindows === 0) {

            // ----- set z-index for active windows
            $('#desktop .activeWindowDiv').each(function() {
                $(this).css('z-index', $(this).attr(ns.ATTR_WINDOW_Z_INDEX));
            });
            
            // ----- set focus back
            ns.setFocusToElementInWindow();
        }
        
        // ----- there is another modal window set z-index for parent
        if (countOfModalWindows > 1) {
            
            // ----- parent id
            var parentId = countOfModalWindows - 1;
            $('#modalWindow' + parentId).css('z-index', ns.Z_INDEX.MODAL_WINDOW);
            
            // ----- for selenium tests
            $('#actualWindow').attr('class', 'modalWindow' + parentId);
        } else if (countOfModalWindows === 1) {
        	$('#actualWindow').remove();
        	// ----- closing last modal window and putting the active windows where they belong
        	var activeWindows = $('#desktop .activeWindowDiv');
        	for (var i = 0; i < activeWindows.length; i++) {
        		$(activeWindows[i]).css('z-index', $(activeWindows[i]).attr(ns.ATTR_WINDOW_Z_INDEX));
        }
        }
        
    }; 
    
     
    /**
     * Remove focus attribute - define in ATTR_WINDOW_HAS_FOCUS.
     * From all active window. 
     * 
     */
    ns.removeHasFocusAttributeFromAllWindows = function () {
        $('.activeWindowDiv').each(function() {
                $(this).removeAttr(ns.ATTR_WINDOW_HAS_FOCUS);
            });
        $('.minimizedWindow').removeAttr(ns.ATTR_WINDOW_HAS_FOCUS);
    };
    
     /**
     * Set attribute element with focus with element name.
     * 
     * @param pWindowId window id
     * 
     * @param pValue element with focus name
     * 
     */
    ns.setElementWithFocusAttribute = function (pWindowId, pValue) {
        $('#' + pWindowId).attr(ns.ATTR_WINDOW_ELEMENT_WITH_FOCUS, pValue);
    };
    
    /**
     * Set focus to element in actual window.
     * Actual window is window which was clicked last time. 
     */
    ns.setFocusToElementInWindow = function() {
     
     // ---- if there is modal window focus is always on it	
     if ($('.modalWindow').length === 0) {
	      $('input:not([type=hidden]):first').focus();
	      var elementWithFocus = $(".activeWindowDiv[_dci_windowhasfocus='true']").attr('_dci_elementwithfocus');
	      $(".activeWindowDiv[_dci_windowhasfocus='true']").find("[name='" + elementWithFocus + "']").focus(); 
     }	
    };
    
    
    /**
     * Set inputs widht in window with id given by param.
     * 
     * @pWindowId window id
     * 
     */
    ns.setInputsWidthInWindow = function(pWindowId) {
    	var inputs = $('#'+ pWindowId + ' .collection thead .input');
    	
    	// --- jmesa collection
    	if (inputs.length === 0) {
    		inputs = $('#'+ pWindowId + ' .jmesa tr.filter .input');
    	}
    	
		var changeSize = function () {
			 webUtilsNs.inputWidthByText(this);
		};
		
		$.each(inputs, changeSize);
		inputs.keyup(changeSize);

    }; 
    
	/** Disable sorting after click on sortable column.
	 * 
	 * Sort data in table by AJAX.
	 *  
	 */
	ns.disableClickOnSortableColumn = function () {
            $('th.sortable a').click(function(event) {
                event.preventDefault();
                
                var windowId = $(this).closest('.activeWindowDiv').attr('id');
                
                // ----- modal window 
                if (!windowId) {
                    windowId = $(this).parents('.modalWindow:first').attr('id');
                }
                formSpace.sortColumn(windowId, $(this).attr('href'));
            }); 
	};
        
    
	/** 
	 * Change attribute ATTR_SHOW_WINDOW_CLOSE_DIALOG according to checkbox value.
	 *
	 * @pThis button which send checkbox value by AJAX 
	 */
	ns.changeShowDialogAttrInActiveWindow = function (pThis) {
		var value;
		
		$(pThis).parents('form:first').find('input[name="showDialog"]').attr('checked') === 'checked' ? 
				value = 'true': value = 'false';

		$('.activeWindowDiv').each(function() {
			$(this).attr(ns.ATTR_SHOW_WINDOW_CLOSE_DIALOG, value);
		});
		
		$(pThis).parents('form:first').find('input[name="showMaxWindowDialog"]').attr('checked') === 'checked' ? 
				value = 'true': value = 'false';

		$('.activeWindowDiv').each(function() {
			$(this).attr(ns.ATTR_SHOW_MAX_WINDOW_DIALOG, value);
		});
	};
    
    /**
     * Reloads active window content and initializes all the componets.
     * 
     * @param pWindowSelector		window jquery selector
     * @param pContent				new active window HTML content
     * @param pAction				action which was called
     * @param pCompletionFunction	function executed after content has been reloaded
	 * @param pCompleteFuntionParams pCompleteFuntion params     
     */
    ns.reloadActiveWindowContent =
	    function (pWindowSelector,
	    		  pContent,
	    		  pAction,
	    		  pCompletionFunction,
	    		  pCompletionFunctionParams) {
	    	var	windowId = $(pWindowSelector).attr('id');
	    	var	windowContentId = $(pWindowSelector).children('.activeWindowContent').attr('id');
	    	
	    	// ----------------- load dynamic CSS styles
	    	ns.loadStyles(pContent, windowId);
	    	
	    	// ----------------- load dynamic JavaScript
            require(ns.loadJavaScripts(pContent),
               		function() {
			            if (utilsSpace.handleUserLogging(pContent)) {
			            	var currentWindow = $(pWindowSelector);
			            	var windowTitle = currentWindow.find('.windowTitle');
			            	
			            	windowUtilsSpace.reloadWindowContent(windowContentId, pContent);
			            	
			            	ns.disableClickOnSortableColumn();
			            	

			            	// -------------------- when we do not want focus to element ex: _SYS.LOG.10 page
			            	if (windowUtilsSpace.isIgnoreFocusSelectorInCurrentWindow() === false) {
			            		 ns.setFocusToElementInWindow();
			            	}
			            	
			                ns.setInputsWidthInWindow(windowId);
			                currentWindow.attr('_dci_modalwindowcurrentaction', pAction);
			                webUtilsNs.changeCollectionSettingsVisibilityInWindow($(pWindowSelector).attr('id'));
			                
			                // -------------------- set window title
			                var moduleCode = ns.getModuleCode(windowId);  
			                var windowName = ns.getWindowName(windowId); 
			                var titleText;
			                if (moduleCode && windowName && !webUtilsNs.isAutomaticTesting()) {
			                	titleText = windowName + ' ('  + moduleCode + ')';
			                } else if (windowName && !webUtilsNs.isAutomaticTesting() ){
			                	titleText = windowName;
			                } else {
			                	titleText = moduleCode;
			                }
			                
			                // ----------------- modal window check title lenght
			                if (currentWindow.hasClass('modalWindow')) {
			                	titleText = titleText.substring(0, ns.MODAL_WINDOW_TITLE_MAX_TEXT_LENGHT);
			                }
			                	
			                windowTitle.text(titleText);   
			                
			                // --------------------- completion function execution
			                pCompletionFunction && pCompletionFunction(pWindowSelector, pCompletionFunctionParams);
			                
			                utilsSpace.hideProgressIndicator();
			            }
				    });
		};
    
    
		/** 
		 * Find module code in window and open documentation window.
		 *
		 * @pThis help icon which was clicked
		 */
		ns.openDocumentationWindow = function (pThis) {
			var moduleCode = null;
			var windowId = null;
			var documentationType = null;
			var documentationKey = null;
			
			windowId = formSpace.getWindow(pThis);
			moduleCode = ns.getModuleCode(windowId);
			
			// ---- if there is not module code use default
			if (!moduleCode) {
				moduleCode = 'MAIN';
			}
			
			// Display project documentation for transaction screens (with some exceptions)
			if (webUtilsNs.startsWith(moduleCode, 'TRN.TRN.') && moduleCode !== 'TRN.TRN.70'
					|| webUtilsNs.startsWith(moduleCode, 'TRN.OTR.') && moduleCode !== 'TRN.OTR.10') {
				documentationType = 'process';
				documentationKey = $('.headPart').text();
			}
			else if (webUtilsNs.startsWith(moduleCode, 'DTB_')) { // Display project documentation for dynamic tables
					documentationType = 'dynamictable';
					documentationKey = moduleCode;
				}
				else { // Display product documentation otherwise
					documentationType = 'page';
					documentationKey = moduleCode;
				}
			
			// ----- open doc window
			ns.openDocWindow(pThis, utilsSpace.getBasePath() + '/editDocumentation.do?action=View', 
					documentationType,  documentationKey, 'null', 900, 600, 1, 1, 0, 'null', 'null');
		};	
		
		

		/** 
		 * Find module code in given window and open documentation window.
		 *
		 * @pWindowId window id
		 * 
		 * @return module code
		 */
		ns.getModuleCode = function (pWindowId) {
			return $('#' + pWindowId + ' .developerPageInfo .title:first').text();
			
		};	
		
		/** 
		 * Find window name in given window.
		 *
		 * @pWindowId window id
		 * 
		 * @return window name
		 */
		ns.getWindowName = function (pWindowId) {
			var window = $('#' + pWindowId);
			var windowName;
			
			if (windowContentSpace.isUniversalOrderWindow(pWindowId)) {
				var parentWindowId = window.attr(ns.ATTR_PARENT_WINDOW_ID);
				var parentWindow = $('#' + parentWindowId);
				windowName = parentWindow.find('.activeWindowContent').attr('title');
			}
			
			if (!windowName) {
				windowName = window.find('div.editHead.menuTop').text().trim();
			}
			
			if (!windowName) {
				windowName = window.find('div.mainPart td.formTitle').first().text().trim();
			}
			
			// ---- window without title (title is in tabs)
			if (!windowName) {
				windowName = window.find('div.mainPart td.tabControlHeadActive').first().text().trim();
			}
			
			// ----- charts and planning table
			if (!windowName) {
				var headerWithTitle = window.find('div.mainPart div.formTitle').first();
				windowName = headerWithTitle.text().trim();
				headerWithTitle.css('display', 'none');
			}
			
			// ---- detail page
			if (!windowName) {
				windowName =  window.find('td.formTitle').first().text().trim();
			}
			
			// ---- detail page
			if (!windowName) {
				windowName =  window.find('div.headPart').first().text().trim();
			}
			
			// --- anothed detail page
			if (!windowName) {
				windowName =  window.find('div.mainBodyFrame  td.formSegmentHead').text().trim();
			}
			
			// --- transactions
			if (!windowName) {
				windowName =  window.find('.windowTitleText').text().trim();
			}
			return windowName;			
		};	
		
		/** 
		 * Set focus to first window in DOM.
		 * 
		 */
		ns.setFirstWindowHighlight = function () {
		 	$('.minimizedWindow').removeAttr(ns.ATTR_WINDOW_HAS_FOCUS);	
	        $('.minimizedWindow:last').attr(ns.ATTR_WINDOW_HAS_FOCUS, 'true');	
		};
		
		
		/** 
		 * Sets highlight to actual window.
		 * Actual window is nearest window which is not minimized.
		 * 
		 * @pWindowId ID of window which is highlighted now
		 * 
		 * @pWindowToHighlightId ID of window which will be highlighted
		 */
		ns.setActualWindowHighlight = function (pWindowId, pWindowToHighlightId) {
			var activeWindow = $('#activeWindow' + pWindowId);
			
			// ---------- remove window highlight
			$('.minimizedWindow').removeAttr(ns.ATTR_WINDOW_HAS_FOCUS);	
			activeWindow.removeAttr(ns.ATTR_WINDOW_HAS_FOCUS);
			activeWindow.attr(ns.ATTR_WINDOW_Z_INDEX, ns.Z_INDEX.ACTIVE_WINDOW_LOW);
			
			// --------- search for another window for highlight
			// --------- when is window for highlight given by parameter use it
		 	var windowId = pWindowToHighlightId || $(".activeWindowDiv[_dci_windowhasfocus='true']").attr(ns.ATTR_WINDOW_ID) ||
		 				   windowUtilsSpace.getNearestNotMinimzedWindowId(pWindowId);
		 	
		 	var minimizedWindow = $("#minimizedWindow" + windowId);
		 	
		 	// --------- no window was found
		 	if (minimizedWindow.length === 0) {
		 		ns.setFirstWindowHighlight();
		 	
		 	// -------- highlight window which was found
		 	} else {
		 		minimizedWindow.attr(ns.ATTR_WINDOW_HAS_FOCUS, 'true');	
		 		ns.setCurrentWindowToTop(windowId, true);
		 	}
		 	
			 ns.saveAllWindowsZindexesToDb();
		};	
		
		/** 
		 * Save all window z-index value to database.
		 */
		ns.saveAllWindowsZindexesToDb = function () {
		 	var windowsZindexesArray = [];
		 	
		 	// ------------ iterate over all windows
			$('.activeWindowDiv').each(
			                function() {
			                	var currentElement = $(this);
			                	var activeWindow = {};
				                activeWindow.windowId = currentElement.attr(ns.ATTR_WINDOW_ID);
				                activeWindow.zIndex = currentElement.attr(ns.ATTR_WINDOW_Z_INDEX);
				                windowsZindexesArray.push(activeWindow);
			                }
			 );
			
			 ns.saveChangesToDb(windowsZindexesArray);
		};	

		/** 
		 *  Set documentation icon in window.
		 *  
		 *  If documentation exists helper will be color.
		 *  
		 *  @pWindow window object
		 *  
		 */
		ns.setDocumentationHelper = function (pWindow) {
			if (pWindow.find('.docExists').length > 0) {
				pWindow.find('.documentationWindow').switchClass('documentationWindow', 'documentationExistsWindow');
        	}
		};
		
		
		/**
		 * Open a new window with documentation.
		 * The method calls OpenActionWindow() and completes the URL from module code and tab index.
		 * 
		 * @param currentWindow		Current window name
		 * @param url				Target URL to be opened
		 * @param type				Documentation type (e.g. 'page')
		 * @param keys				Documentation keys (module code)
		 * @param newWindow			New window name
		 * @param width				New window width
		 * @param height			New window height
		 * @param resizible			Make the new window resizible 
		 * @param showBars			Show scrollbars in the new window
		 * @param chainWithOpener	Chain with opener
		 * @param hAlign			Horizontal alignment
		 * @param vAlign			Vertical alignment
		 */
		ns.openDocWindow =
			function (
					currentWindow,
					url,
					type,
					keys,
					newWindow,
					width,
					height,
					resizible,
					showBars,
					chainWithOpener,
					hAlign,
					vAlign) {
			
			// ------------------------- get current window
			var activeWindow = windowUtilsSpace.getCurrentWindow();
			
			// ------------------------- get the tab control index
			var allTabs = activeWindow.find('[class*="tabControlHead"]');			
			var activeTab = activeWindow.find('[class*="tabControlHeadActive"]'); 
			var tabIndex = allTabs.index(activeTab);	
			
			var completeKeys;
			switch (type) {
			    case 'page':
			        completeKeys = 'pages.';
			    break;
			    
			    case 'dialog':
			        completeKeys = 'dialog.';
                break;
                
                default:
                    completeKeys = '';
			}
			completeKeys = completeKeys + keys;

			// ------------------------- open documentation in new browser
			webUtilsNs.OpenActionWindow(
							webUtilsNs.childEditWindow,
							url + '&type=' + type + '&keys=' + completeKeys + (tabIndex !== -1 ? '.' + tabIndex : ''), 
							newWindow,
							width,
							height,
							resizible,
							showBars,
							chainWithOpener,
							hAlign,
							vAlign);
		}; 
		
		/**
		 * Return true if it is modal window (ID starts with 'modalWindow')
		 * 
		 * @param @WindowId
		 * 
		 * @return true or false
		 */
		ns.isModalWindow = function(pWindowId) {
			return pWindowId.indexOf('modalWindow') === 0;
		};
		
		
		ns.openWindowFromAnotherWindow = function(pCurrentElement, pMenuKey, pCompleteFunction, pCompleteFunctionParams) {
			var originalWindowId = formSpace.getWindow(pCurrentElement);
			var menuItem = $('span[_dci_menukey="' + pMenuKey + '"]').parents('.openElementWindowFromMenu:first');
					
			// ----------------------------- when window content has been clicked - will set to the top - ignore it - new window has to be on top
			$('#' + originalWindowId).attr('_dci_settotopwhenclicked', 'false');
			
			// ----------------------------- create window object and open it
			var newWindow = [];
	        newWindow.url = menuItem.children('a').attr('title');
	        newWindow.src = menuItem.children('img').attr('_dci_srcbig');
	        newWindow.title = menuItem.children('a').children('span').text();
	        newWindow.menuId = menuItem.children('span[class=favorite ]').attr('_dci_menuid');
	        newWindow.menuKey = menuItem.children('span[class=favorite ]').attr('_dci_menukey');
		        
	        ns.createWindow(newWindow, cz.aimtec.dci.utils.getBasePath(), webUtilsNs.rewriteWindow(), null, pCompleteFunction, pCompleteFunctionParams);
		};	
		
		
    /**
		 * Set given inputs given values in window defined by window ID and search.
		 * 
		 * @param pWindowId	in this window input values will be set
		 * @param pCompleteFuntionParams field - value list separated by comma
		 */
		ns.setInputValuesInWindowAndSearch = function(pWindowId, pCompleteFuntionParams) {
			var parameters = pCompleteFuntionParams.split(',');	
			var currentWindow = $(pWindowId);
			
			// ------------------------------ set input values
			for (var i = 0; i < parameters.length; i += 2) {
				currentWindow.find('input[name="displaytagFilter.' + parameters[i] + '"]').attr('value', parameters[i + 1]);
				currentWindow.find('input[name="displaytagFilter.' + parameters[i] + '"]').blur();
			}
			
			// ------------------------------ search
			if (windowUtilsSpace.isCurrentWindowJmesa()) {
			    currentWindow.find('.onInvokeActionContainer').trigger('click');
			} else {
			    currentWindow.find('#searchButton').trigger('click');
			}
		};
		
		/**
		 * Switch to lines tab and search.
		 * 
		 * @param pWindowId	in this window input values will be set
		 * @param pUrl change tab action url
		 * @param pCompleteFuntionParams field - value list separated by comma
		 */
		ns.setInputValuesInWindowChangeTabAndSearch = function(pWindowId, pCompleteFuntionParams) {
			var currentWindow = $(pWindowId);
			var tabUrl;
			
			// ------------------------------ get tab url action
			if (pCompleteFuntionParams) {
				var parameters = pCompleteFuntionParams.split(',');
				tabUrl = parameters[1];
			}
			
			// ------------------------------ open tab, set inputs and search
			cz.aimtec.dci.form.sendDataToAction(currentWindow, tabUrl,
						cz.aimtec.dci.window.setInputValuesInWindowAndSearch, pCompleteFuntionParams);
		};
        
		function initializeDialogs() {
			
	        // ----- set dialog for confirm remove active window
	        var removeWindowDialog = $('#dialogRemoveWindow').dialog(ns.dialogRemoveElementWindowOptions);
	        
	        var removeModalWindowDialog = $('#dialogRemoveModalWindow').dialog(ns.dialogCloseModalWindowOptions);
	        
	        // ----- set dialog for alerting about unsaved changes in jmesa
	        var closeUnsavedJmesaDialog = $('#dialogCloseUnsavedJmesa').dialog(ns.dialogCloseUnsavedJmesaOptions);
	        
	        // ----- set options of dialog for maximum number of windows exceeded
	        var dialogMaxWindow = $('#dialogMaxWindow').dialog(ns.dialogMaxWindowOptions);
	        
	        if (removeWindowDialog.length > 0 && removeModalWindowDialog.length > 0 && dialogMaxWindow.length > 0) {
		            // translate  buttons of dialogs
	            appResourcesSpace.translateButtons([removeWindowDialog, removeModalWindowDialog, closeUnsavedJmesaDialog, dialogMaxWindow]);
	        }
		}
		
    /**
	 * ----------------------------------------------------------------------------
	 * 
	 * Active document handling
	 */
    $(function() {
    	
    	initializeDialogs();
    
    });
    
})(this, this.jQuery);
