<%@ page language="java" %>
<%@ page contentType="text/html;charset=UTF-8" %>
<%@ taglib uri="/WEB-INF/struts-template.tld" prefix="template" %>
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/aimtec-skins.tld" prefix="skin" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="/WEB-INF/aimtec-util.tld" prefix="util" %>
<%@ taglib uri="/WEB-INF/aimtec-ajax.tld" prefix="ajax" %>

	<util:developerPageInfo/>	
	<span class="requireCSS">style/displaytagTemplate.css</span>
	<span class="requireCSS">style/aplAdmin.css</span>
	<span class="requireCSS">style/schedAdmin.css</span>
	<span class="requireCSS">style/editPartnership.css</span>
	
	<script type="text/javascript">
		require(['cz.aimtec.dci.admin']);
	</script>
	
	<c:set var="base">
		<skin:base/>
	</c:set>

	
	<template:insert template="/template/page/pageTemplApp_body.jsp">
	<template:put name="bodyPart">
		<template:insert template="/template/page/pageTemplBasis.jsp">
		    <template:put name="headPart">
				<bean:message key="admin.scheduler.title"/>
				
			</template:put>	
			
			<template:put name="centerPart">
				
				<span class="windowRefreshButton">
					<skin:action type="button" styleClass="formButton" page="/schedulerAdmin.do" 									 
						key="button.refresh"/>									
				</span>
				
				<html:form action="/schedulerAdmin.do" styleId="rescheduleForm">
					<html:hidden property="action" value="reschedule" styleId="action"/>
					<html:hidden property="id" styleId="serviceId"/>
					
					<script type="text/javascript">
						var expandingImageTooltip = '<bean:message key="toggle.expand"/>',
							collapsingImageTooltip = '<bean:message key="toggle.collapse"/>';
					</script>
	
					<%-- ****************************** scheduler period part --%>
					<table class="formSegment" style="width: 100%;">
						<tr>
							<td width="20%" class="labelInput">
								<bean:message key="admin.scheduler.interval"/>
							</td>
							<td class="labelItemInput">
								<html:text property="interval" styleClass="labelItemInput" />
	               				<span class="errorMessage">
								  <html:errors property="interval"/>
								</span>
							</td>
						</tr>
					</table>
					
					
					<%-- ****************************** company services --%>
					<html:img page="/img/space.gif" height="6"/><br>
					<bean:message key="admin.scheduler.companyServices"/>
					<table style="width: 100%; cellspacing: 0; cellpadding: 2; border: 0">
						<%-- **************************** header row --%>
						<tr>			
							<td class="viewHead"><bean:message key="admin.scheduler.code" /></td>
							<td class="viewHead"><bean:message key="description" /></td>
							<td class="viewHead"><bean:message key="admin.scheduler.lastRun" /></td>				
							<td class="viewHead"><bean:message key="admin.scheduler.nextRun" /></td>
							<td class="viewHead"><bean:message key="admin.scheduler.type" /></td>										
							<td class="viewHead">&nbsp;</td>
							<td class="viewHead">&nbsp;</td>
							<td class="viewHead"><bean:message key="admin.scheduler.interval" /></td>
							<td class="viewHead"><bean:message key="admin.scheduler.service.state" /></td>						
							<td class="viewHead">&nbsp;</td>
							<td class="viewHead">&nbsp;</td>
							<td class="viewHead">&nbsp;</td>
						</tr>
					
						<%-- **************************** data rows --%>	
						<tr>
							<c:forEach var="item" items="${schedulerAdminForm.companyServices}">
								<c:if test="${item.enabled}">
									<tr service-code="${item.code}">
										<td class="viewItem" style="vertical-align: top;">
											<c:if test="${item.errorMessage != null}">
												<html:img page="/img/close12.png" height="12" width="12" alt="${item.errorMessage}" title="${item.errorMessage}"/> 
											</c:if>
											<bean:write name="item" property="code"/>&nbsp;
											<c:if test="${item.multiEvent}">
												<html:img page="/img/ar_down_orange.gif" height="12" width="12" altKey="toggle.collapse" titleKey="toggle.collapse" 
													onclick="cz.aimtec.dci.admin.toggleServiceEvents(this, '${item.code}', collapsingImageTooltip, expandingImageTooltip)"
													style="cursor: pointer;"/>
											</c:if>
										</td>
										<td class="viewItem" attribute="description">
											<bean:write name="item" property="description"/>&nbsp;
										</td>
										<td class="viewItem" nowrap="nowrap" attribute="lastTime" data-type="date">
											<bean:write name="item" property="lastTime.stringDateTime_NotNull"/>&nbsp;
										</td>
										<td class="viewItem" nowrap="nowrap" style="text-align: right;" attribute="nextRun">&nbsp;
											<c:if test="${item.notOneTimeType}">
												<bean:write name="item" property="nextTime.stringDateTime_NotNull"/>
											</c:if>
											&nbsp;	
										</td>
										<td class="viewItem" nowrap="nowrap" style="text-align: right;" attribute="type">&nbsp;
											<bean:write name="item" property="scheduleType"/>&nbsp;
										</td>
										<td class="viewItem" style="text-align:right;" attribute="runNow">
											<c:if test="${item.notOneTimeType}">
												<skin:action type="link" page="/schedulerAdmin.do?action=run" 
													paramId="id" paramName="item" paramProperty="code"
													key="admin.scheduler.runNow" styleId="${item.code}RunNow"/>
											</c:if>
											&nbsp;
										</td>	
										<td class="viewItem" style="text-align:right;" attribute="paused">
											<c:if test="${item.notOneTimeType}">
												<c:choose>
													<c:when test="${!item.paused}">
												 		<c:if test="${item.nextTime != ''}">
															<skin:action type="link" page="/schedulerAdmin.do?action=pause"
																paramId="id" paramName="item" paramProperty="code"
																key="admin.scheduler.pause" styleId="${item.code}Pause"/>
												 		</c:if>
												 	</c:when>
												 	<c:otherwise>
														<skin:action type="link" page="/schedulerAdmin.do?action=resume"
															paramId="id" paramName="item" paramProperty="code"
															key="admin.scheduler.resume" styleId="${item.code}Resume"/>
												 	</c:otherwise>
												</c:choose>
											</c:if>
											&nbsp;
										</td>
										<td class="viewItem" style="text-align:right;" attribute="interval">
											<c:if test="${item.interval > 0}">
												<bean:write name="item" property="interval"/>
											</c:if>
											&nbsp;
										</td>	
										<td class="viewItem" style="text-align:center;" attribute="active" data-type="indicator">
											<bean:message key="${item.getServiceStateKey()}"/>
										</td>
										<td class="viewItem" style="text-align:right;" attribute="reschedule">
											<c:choose>
												<c:when test="${item.notOneTimeType && item.enabled}">
													<ajax:action type="submit"
															styleId="${item.code}Reschedule"
															onclick="cz.aimtec.dci.form.setValueOfField(this, 'id', '${item.code}');"
															styleClass="formButton"
															key="admin.scheduler.reschedule" />
												</c:when>
												<c:otherwise>
													&nbsp;
												</c:otherwise>
											</c:choose>
										<td class="viewItem" style="vertical-align:bottom; text-align: center;" attribute="restart">
											<skin:action type="link" page="/schedulerAdmin.do?action=restart" 
														 paramId="id" paramName="item" paramProperty="code"
														 styleId="${item.code}Restart">
												<html:img page="/img/refresh_blue.png" height="12" width="12" titleKey="admin.scheduler.restart"
														  style="border-style: none;"/>
											</skin:action>
										</td>
										<c:if test="${item.multiEvent}">
										    <c:choose>
                                                <c:when test="${!item.isPaused()}">
                                                    <td class="viewItem" style="vertical-align:bottom; text-align: center;" attribute="pauseEvents">
												<skin:action type="link" page="/schedulerAdmin.do?action=pause"
															 paramId="id" paramName="item" paramProperty="code"
															 styleId="${item.code}Restart">
													<html:img page="/img/pause_blue.png" height="13" width="13" titleKey="admin.scheduler.pauseEvents"
														  	  style="border-style: none;"/>
												</skin:action>
											</td>
                                                </c:when>
                                                <c:otherwise>
                                                    <td class="viewItem" style="vertical-align:bottom; text-align: center;">
                                                        <skin:action type="link">
                                                            <html:img page="/img/pause_blue_disabled.png" height="13" width="13"
                                                                      titleKey="admin.scheduler.service.alreadyStopped"
                                                                      style="border-style: none;"/>
                                                        </skin:action>
                                                    </td>
                                                </c:otherwise>
                                            </c:choose>
										</c:if>
									</tr>


									<%-- ********************************** events --%>
									<c:if test="${item.multiEvent}">
										<c:set var="localizer" value="${schedulerAdminForm.localizer}" />
										<tr event-code="${item.code}" id="${item.code}_events">
											<td>&nbsp;</td>
											<td colspan="100">
												<table style="width: 100%; cellspacing: 0; cellpadding: 2; border: 0">
													<thead>
														<tr>
															<td class="viewHeadDetail viewHead" event-code="${admin.scheduler.event.code}"><bean:message key="admin.scheduler.event.code"/></td>
															<td class="viewHeadDetail viewHead schedulerAdminEventsDescription">
																<bean:message key="admin.scheduler.event.description"/>
															</td>
															<td class="viewHeadDetail viewHead">
																<c:out value="${item.getPeriodTitle(localizer)}"/>
															</td>
															<td class="viewHeadDetail viewHead" attribute="executionDate">
																<bean:message key="admin.scheduler.event.executionDate"/>
															</td>
                                                            <td class="viewHeadDetail viewHead" attribute="state">
                                                                <bean:message key="admin.scheduler.event.state.error"/>
                                                            </td>
															<c:if test="${item.showAdvancedStates}">
                                                                <td class="viewHeadDetail viewHead" attribute="state">
                                                                    <bean:message key="admin.scheduler.event.state"/>
                                                                </td>
															</c:if>
															<td class="viewHeadDetail viewHead">&nbsp;</td>
															<td class="viewHeadDetail viewHead">&nbsp;</td>
															<td class="viewHeadDetail viewHead">&nbsp;</td>
														</tr>
													</thead>
													<tbody>
														<c:forEach var="event" items="${item.eventList}">
															<tr event="${event.code}">
																<td class="viewItemDetail viewItem">${event.code}&nbsp;&nbsp;
																	<c:if test="${event.additionalPropertiesSupported}">
																		<c:if test="${event.hasAdditionalProperties}">
																			<html:img page="/img/ar_right.gif" height="12" width="12"
																					onclick="cz.aimtec.dci.admin.toggleSubscriptionEvents(this, '${event.code}', collapsingImageTooltip, expandingImageTooltip)"
																					altKey="toggle.collapse" titleKey="toggle.collapse" 
																					style="cursor: pointer; vertical-align: center;"/>
																		</c:if>
																	</c:if>
																</td>
																<td class="viewItemDetail viewItem schedulerAdminEventsDescription" attribute="description">${event.description}&nbsp;&nbsp;</td>
																<td class="viewItemDetail viewItem" attribute="period">${event.getPeriodText(localizer)}&nbsp;&nbsp;</td>
																<td class="viewItemDetail viewItem" attribute="lastExecution" data-type="date">${event.lastExecution}&nbsp;&nbsp;</td>
                                                                <td class="viewItemDetail viewItem" style="text-align:center;" attribute="state" data-type="indicator">
                                                                    <html:img page="${event.errorStateImage}" height="12" width="12"
                                                                              titleKey="${event.errorStateDescriptionKey}" />&nbsp;&nbsp;
                                                                </td>
                                                                <c:if test="${item.showAdvancedStates}">
                                                                    <td class="viewItemDetail viewItem" style="text-align:center;">
                                                                        <html:img page="${event.eventStateImage}" height="12" width="12"
                                                                                  titleKey="${event.stateDescriptionKey}" />&nbsp;&nbsp;
                                                                    </td>
                                                                </c:if>
																<c:if test="${event.isPeriodical()}">
																	<c:choose>
																		<c:when test="${item.isPaused() || event.isRunning()}">
																			<td class="viewItemDetail viewItem" style="vertical-align:bottom; text-align:right;">
																				<skin:action type="link">
																					<html:img page="/img/run_disabled.png" height="12" width="12"
																					  	  	  titleKey="${event.isRunning() && !item.isPaused() ?
																					  	  	    'admin.scheduler.event.alreadyRunning' : 'admin.scheduler.runEvent'}"
																					  	  	  style="border-style: none;"/>
																				</skin:action>
																			</td>
																		</c:when>
																		<c:otherwise>
																			<td class="viewItemDetail viewItem" style="vertical-align:bottom; text-align:right;">
																				<skin:action type="link"
																					 		 styleId="${item.code}_${event.code}_runEvent"
																					 		 page="/schedulerAdmin.do?action=run&id=${item.code}"
																							 paramId="eventCode" paramName="event" paramProperty="code"
																					 		 style="cursor: pointer;">
																					<html:img page="/img/run.png" height="12" width="12"
																					  	  	  titleKey="admin.scheduler.runEvent"
																					  	  	  style="border-style: none;"/>
																				</skin:action>
																			</td>
																		</c:otherwise>
																	</c:choose>
																</c:if>
																																
																<c:choose>
																	<c:when test="${item.isPaused()}">
																		<td class="viewItemDetail viewItem" style="vertical-align:bottom; text-align:right;" attribute="state" data-type="indicator">
																			<skin:action type="link">
																				<html:img page="/img/refresh_blue_disabled.png" height="12" width="12"
																						  titleKey="admin.scheduler.restartEvent"
																						  style="border-style: none;"/>
																			</skin:action>
																		</td>
																	</c:when>
																	<c:otherwise>
																		<td class="viewItemDetail viewItem" style="vertical-align:bottom; text-align:right;">
																			<skin:action type="link"
																						 page="/schedulerAdmin.do?action=restart&id=${item.code}"
																						 paramId="eventCode" paramName="event" paramProperty="code"
																						 style="cursor: pointer;">
																				<html:img page="/img/refresh_blue.png" height="12" width="12"
																						  titleKey="admin.scheduler.restartEvent"
																						  style="border-style: none;"/>
																			</skin:action>
																		</td>
																	</c:otherwise>
																</c:choose>
																
																<c:choose>
																	<c:when test="${item.isPaused() || event.isPaused()}">
																		<td class="viewItemDetail viewItem" style="vertical-align:bottom; text-align:right;">
																			<skin:action type="link">
																				<html:img page="/img/pause_blue_disabled.png" height="13" width="13"
																						  titleKey="admin.scheduler.event.alreadyStopped"
																						  style="border-style: none;"/>
																			</skin:action>
																		</td>
																	</c:when>
																	<c:otherwise>
																		<td class="viewItemDetail viewItem" style="vertical-align:bottom; text-align:right;">
																			<skin:action type="link"
																						 page="/schedulerAdmin.do?action=pause&id=${item.code}"
																						 paramId="eventCode" paramName="event" paramProperty="code"
																						 style="cursor: pointer;">
																				<html:img page="/img/pause_blue.png" height="13" width="13"
																						  titleKey="admin.scheduler.pauseEvent"
																						  style="border-style: none;"/>
																			</skin:action>
																		</td>
																	</c:otherwise>
																</c:choose>
															</tr>
															<c:if test="${event.additionalPropertiesSupported}">
																<c:if test="${event.hasAdditionalProperties}">
																	<c:set var="event" value="${event}" scope="request" />
																	<!-- 
																		Additional Properties are assigned to each event separately, because
																		for every event there is different structure and different data that should
																		be displayed. JPS with structure and data displaying should be in file
																		<itemCode>AdditionalProperties.jsp, for example opcAdditionalProperties.jsp.
																		Note that this JSP is displayed only when event has additional properties
																		enabled - see ServiceEvent.isAdditionalPropertiesSupported() - and when
																		it has any actual additional properties available 
																		- see ServiceEvent.getHasAdditionalProperties()
																	 -->
																	<template:insert template="/adm/apl/${item.code}AdditionalProperties.jsp" />
																</c:if>
															</c:if>
														</c:forEach>
													</tbody>
												</table>
											</td>
										</tr>
										<tr id="${item.code}_events_delimiter" style="height: 5px;"><td></td></tr>
									</c:if>
								</c:if>
							</c:forEach>
						</tr>
					</table>
					
					
					<%-- ****************************** application services --%>
					<html:img page="/img/space.gif" height="6"/><br>
					<bean:message key="admin.scheduler.applicationServices"/>
					<table style="width: 100%; cellspacing: 0; cellpadding: 2; border: 0">
					
						<%-- **************************** head er row --%>
						<tr>			
							<td class="viewHead"><bean:message key="admin.scheduler.code" /></td>
							<td class="viewHead"><bean:message key="admin.scheduler.lastRun" /></td>				
							<td class="viewHead"><bean:message key="admin.scheduler.nextRun" /></td>				
							<td class="viewHead"><bean:message key="admin.scheduler.interval" /></td>				
						</tr>
						
						<%-- **************************** data rows --%>	
						<logic:iterate id="item" name="schedulerAdminForm" property="applicationServices">
							<tr>
								<td class="viewItem">
									<bean:write name="item" property="code"/>&nbsp;
								</td>
								<td class="viewItem" nowrap="nowrap">
									<bean:write name="item" property="lastTime.stringDateTime_NotNull"/>&nbsp;
								</td>
								<td class="viewItem" nowrap="nowrap">
									<bean:write name="item" property="firstTime.stringDateTime_NotNull"/>&nbsp;
								</td>
								<td class="viewItem" nowrap="nowrap" style="text-align: right;">
									<bean:write name="item" property="interval"/>&nbsp;
								</td>
							</tr>	
						</logic:iterate>
					</table>
					
											
					<%-- ****************************** SQL services --%>
					<html:img page="/img/space.gif" height="6"/><br>
					<bean:message key="admin.scheduler.sqlServices"/>
					<div class="errorMessage">
						<html:errors property="sqlServices"/>
					</div>
					<table style="width: 100%; cellspacing: 0; cellpadding: 2; border: 0">
					
						<%-- **************************** head er row --%>
						<tr>			
							<td class="viewHead"><bean:message key="admin.scheduler.name" /></td>
							<td class="viewHead"><bean:message key="admin.scheduler.lastRun" /></td>				
							<td class="viewHead"><bean:message key="admin.scheduler.nextRun" /></td>
							<td class="viewHead"><bean:message key="admin.scheduler.activity" /></td>
							<td class="viewHead"><bean:message key="admin.scheduler.status" /></td>
							<td class="viewHead"><bean:message key="admin.scheduler.isEnable" /></td>				
							<td class="viewHead"><bean:message key="admin.scheduler.actions" /></td>				
							<td class="viewHead"><bean:message key="aimtec.help" /></td>				
						</tr>
						 
						<%-- **************************** data rows --%>	
						<logic:iterate id="item" name="schedulerAdminForm" property="sqlJobs" type="cz.aimtec.dci.admin.action.SqlJobs">
							<tr>
								<td class="viewItem">
									<bean:write name="item" property="jobName"/>&nbsp;
								</td>
								<td class="viewItem" nowrap="nowrap">
									<bean:write name="item" property="lastExecutedStepDate"/>&nbsp;
								</td>
								<td class="viewItem" nowrap="nowrap">
									<bean:write name="item" property="nextScheduledRunDate"/>&nbsp;
								</td>
								<td class="viewItem"  style="text-align: center;">
									<bean:message key="${item.currentRunStatus}"/>&nbsp;
								</td>
								<td class="viewItem"  style="text-align: center;">
									<bean:message key="${item.lastRunOutcome}"/>&nbsp;
								</td>
								<td class="viewItem"  style="text-align: center;">
									<bean:message key="${item.enabled}"/>&nbsp;
								</td>
								<td class="viewItem" nowrap="nowrap">
									<skin:action type="link" key="admin.scheduler.runNow"
										onclick="cz.aimtec.dci.window.openModalWindow(this, '${base}/schedulerAdmin.do?action=runSqlJob&id=${item.jobName}', 'RunSqlJobInfo', 360, 150, 1, 1, 1, 'null', 'null', 'true', null, null, false, false, 'null');"/>
								</td>					
								<td class="viewItemHelp">
									<skin:documentationImage key="${item.jobName}" documentationKey="${item.jobName}" documentationType="job"/>
								</td>
							</tr>
						</logic:iterate>
					</table>
				</html:form>
			</template:put>
		</template:insert> 
	</template:put>
	<script type="text/javascript">
    	require(['cz.aimtec.dci.systemServices'],

    		function(systemServices) {
    			systemServices.initialize();
    	});

    </script>
</template:insert>
