#!/bin/bash

WEBAPPS_PATH=$CATALINA_HOME/webapps
APP_PATH=$WEBAPPS_PATH/CoreGate
CONFIG_PROPERTIES_PATH=$APP_PATH/WEB-INF/config.properties

# replace placeholders - configure service using environment variables
sed -i -e s,'${dci.dbName}',$dbName,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${dci.dbServerName}',$dbServerName,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${dci.dbServerPort}',$dbServerPort,g $CONFIG_PROPERTIES_PATH

sed -i -e s,'${service.discovery.server}',$serviceDiscoveryServer,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.discovery.port}',$serviceDiscoveryPort,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.discovery.path}',$serviceDiscoveryPath,g $CONFIG_PROPERTIES_PATH

sed -i -e s,'${service.server}',$serviceServer,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.port}',$servicePort,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.path}',$servicePath,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.name}',$serviceName,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.version}',$serviceVersion,g $CONFIG_PROPERTIES_PATH

sed -i -e s,'${dciCore.server}',$dciCoreServer,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${dciCore.port}',$dciCorePort,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${dciCore.path}',$dciCorePath,g $CONFIG_PROPERTIES_PATH

sed -i -e s,'${service.eventbus.server}',$serviceEventbusServer,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.eventbus.port}',$serviceEventbusPort,g $CONFIG_PROPERTIES_PATH

# start tomcat
if [ "$javaDebug" = "true" ]
then
	exec env UMASK=0000 $CATALINA_HOME/bin/catalina.sh jpda run
else
	exec env UMASK=0000 $CATALINA_HOME/bin/catalina.sh run
fi

exit $?
