#!/bin/bash

WEBAPPS_PATH=$CATALINA_HOME/webapps
APP_PATH=$WEBAPPS_PATH/CoreServices
CONFIG_PROPERTIES_PATH=$APP_PATH/WEB-INF/config.properties

# ! MAKE SURE THE LINE ENDINGS ARE "LF" !

# replace placeholders - configure service using environment variables
sed -i -e s,'${service.discovery.server}',$serviceDiscoveryServer,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.discovery.port}',$serviceDiscoveryPort,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.discovery.path}',$serviceDiscoveryPath,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${applicationDomainName}',$applicationDomainName,g $CONFIG_PROPERTIES_PATH

sed -i -e s,'${service.eventbus.server}',$serviceEventbusServer,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.eventbus.port}',$serviceEventbusPort,g $CONFIG_PROPERTIES_PATH

sed -i -e s,'${service.server}',$serviceServer,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.port}',$servicePort,g $CONFIG_PROPERTIES_PATH
sed -i -e s,'${service.path}',$servicePath,g $CONFIG_PROPERTIES_PATH

# start tomcat
if [ "$javaDebug" = "true" ]
then
	exec env UMASK=0000 $CATALINA_HOME/bin/catalina.sh jpda run
else
	exec env UMASK=0000 $CATALINA_HOME/bin/catalina.sh run
fi

exit $?