package cz.aimtec.dci.microservices;

import cz.aimtec.dci.microservice.discovery.DiscoveryService;
import cz.aimtec.dci.microservice.eventbus.EventBusClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.Map;

/**
 * All used services mapping.
 *
 * @author hors
 * @version 11. 10. 2017/hors - created<br>
 */
@Configuration
public class ServiceList {

    @Autowired
    EventBusClient eventBusClient;

    /**
     * Static versions list of consumed services.
     *
     * @return map of names and related versions
     */
    public static Map<String, String> getServiceVersions() {
        return Map.of(
                new CoreGate().getServiceName(), new CoreGate().getClientVersion()
        );
    }

    @Bean
    public CoreGate coreGate(DiscoveryService discoverService) {
        return new CoreGate(discoverService, eventBusClient, "core-gate", "4.0.0");
    }
}
